
import 'dart:convert';

import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';

//对接厂商详情
class ButtFactory extends StatefulWidget {
  List<dynamic> list = [];

  ButtFactory(this.list, {Key? key});

  @override
  State<StatefulWidget> createState() {
    return ButtFactoryState(list);
  }
}

class ButtFactoryState extends State with TickerProviderStateMixin {
  List<dynamic> list = [];


  var scrSize ;
  ButtFactoryState(this.list);

  @override
  void initState() {
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    scrSize = MediaQuery.of(context).size;
    return Scaffold(
        backgroundColor: Colors.white,
        appBar: AppBar(
          title: const Text(
            "对接厂商",
            style: TextStyle(color: Colors.black),
          ),
          backgroundColor: Colors.white,
          elevation: 0,
          leading: IconButton(
            icon: const Icon(
              Icons.arrow_back,
              color: Colors.black,
            ),
            onPressed: () {
              Navigator.pop(context);
            },
          ),
        ),
        body: CustomScrollView(
          slivers: [
            SliverToBoxAdapter(
                child: ListView.builder(
                    physics: const NeverScrollableScrollPhysics(),
                    shrinkWrap: true,
                    itemCount: list.length,
                    itemBuilder: (BuildContext context, int index) {
                      return designProgressInfoWidget(index);
                    })),
          ],
        ));
  }

  Widget paddingLine() {
    return Container(
      padding: const EdgeInsets.only(top: 10),
      width: double.infinity,
      height: 10,
      color: const Color(0xffE5E5E5),
    );
  }

  //设计进度
  Widget designProgressInfoWidget(int index) {
    return Column(
      children: [
        paddingLine(),
        Container(
          alignment: Alignment.topLeft,
          margin: const EdgeInsets.only(top: 20, left: 10, right: 10),
          child: Row(
            mainAxisAlignment: MainAxisAlignment.spaceBetween,
            children: [
              Row(
                children: [
                  CircleAvatar(
                    radius: 10,
                    backgroundColor: Colors.grey,
                    backgroundImage: NetworkImage(list[index]["avatar"] == null
                        ? ""
                        : json.decode(list[index]["avatar"])["url"]),
                  ),
                  Text(
                    list[index]["realname"] ?? "",
                    style:
                        const TextStyle(color: Color(0xff222222), fontSize: 15),
                  ),
                ],
              ),
              Text(
                list[index]["statusName"] ?? "",
                style: const TextStyle(color: Color(0xff222222), fontSize: 15),
              )
            ],
          ),
        ),
        Container(
          margin: const EdgeInsets.only(bottom: 20),
          child: Row(
            crossAxisAlignment: CrossAxisAlignment.center,
            mainAxisAlignment: MainAxisAlignment.spaceBetween,
            children:
                desigerChildeWidgets(json.decode(list[index]["progress"])),
          ),
        )
      ],
    );
  }

  List<Widget> desigerChildeWidgets(List<dynamic> progress) {
    List<Widget> listWidget = [];
    Widget childeWidget = const Text("");
    if (progress.isNotEmpty) {
      for (int i = 0; i < progress.length; i++) {
        if (progress.length == 1) {
          childeWidget = designProgressInfoChildWidget2(
              true, true, progress[i]["n"] ?? "", progress[i]["t"] ?? "");
        } else if (progress.length == 2) {
          if (i == 0) {
            childeWidget = designProgressInfoChildWidget2(
                true, false, progress[i]["n"] ?? "", progress[i]["t"] ?? "");
          } else {
            childeWidget = designProgressInfoChildWidget2(
                false, true, progress[i]["n"] ?? "", progress[i]["t"] ?? "");
          }
        } else if (progress.length == 3) {
          if (i == 0) {
            childeWidget = designProgressInfoChildWidget3(
                true, false, progress[i]["n"] ?? "", progress[i]["t"] ?? "");
          } else if (i == 1) {
            childeWidget = designProgressInfoChildWidget3(
                false, false, progress[i]["n"] ?? "", progress[i]["t"] ?? "");
          } else {
            childeWidget = designProgressInfoChildWidget3(
                false, true, progress[i]["n"] ?? "", progress[i]["t"] ?? "");
          }
        }
        listWidget.add(childeWidget);
      }
    }
    return listWidget;
  }


  //对接进度子widget 2个进度
  Widget designProgressInfoChildWidget2(
      bool isVisibleLeft, bool isVisibleRight, String name, String time) {
    return Container(
      padding: const EdgeInsets.only(top: 20),
      child: Column(
        children: [
          Row(
            children: [
              Opacity(
                  opacity: isVisibleLeft ? 0 : 1,
                  child: Container(
                    height: 1,
                    width: scrSize.width / 2.5 - 70,
                    color: const Color(0xff07905F),
                  )),
              Container(
                margin: const EdgeInsets.only(left: 10, right: 10),
                child: const SizedBox(
                  width: 10,
                  height: 10,
                  child: CircleAvatar(
                    radius: 15,
                    backgroundColor: Color(0xff07905F),
                  ),
                ),
              ),
              Opacity(
                opacity: isVisibleRight ? 0 : 1,
                child: Container(
                  height: 1,
                  width: isVisibleRight
                      ? scrSize.width / 2.5 - 70
                      : scrSize.width/ 2.5 - 70,
                  color: const Color(0xff07905F),
                ),
              ),
            ],
          ),
          Container(
              margin: const EdgeInsets.only(top: 5, bottom: 5),
              child: Text(
                name,
                style: const TextStyle(fontSize: 10),
              )),
          Text(
            time,
            style: const TextStyle(fontSize: 10, color: Color(0xff000000)),
          ),
        ],
      ),
    );
  }

  //对接进度子widget 3个进度
  Widget designProgressInfoChildWidget3(
      bool isVisibleLeft, bool isVisibleRight, String name, String time) {
    return Container(
      padding: const EdgeInsets.only(top: 20),
      child: Column(
        children: [
          Row(
            children: [
              Opacity(
                  opacity: isVisibleLeft ? 0 : 1,
                  child: Container(
                    height: 1,
                    width: scrSize.width / 3 - 80,
                    color: const Color(0xff07905F),
                  )),
              Container(
                margin: const EdgeInsets.only(left: 10, right: 10),
                child: const SizedBox(
                  width: 10,
                  height: 10,
                  child: CircleAvatar(
                    radius: 15,
                    backgroundColor: Color(0xff07905F),
                  ),
                ),
              ),
              Opacity(
                opacity: isVisibleRight ? 0 : 1,
                child: Container(
                  height: 1,
                  width: isVisibleRight
                      ? scrSize.width / 3 - 80
                      : scrSize.width / 3 - 80,
                  color: const Color(0xff07905F),
                ),
              ),
            ],
          ),
          Container(
              margin: const EdgeInsets.only(top: 5, bottom: 5),
              child: Text(
                name,
                style: const TextStyle(fontSize: 10),
              )),
          Text(
            time,
            style: const TextStyle(fontSize: 10, color: Color(0xff000000)),
          ),
        ],
      ),
    );
  }
}
