
import 'dart:collection';
import 'dart:convert';

import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:flutter_html/flutter_html.dart';
import 'package:pull_to_refresh/pull_to_refresh.dart';
import 'package:textileclothing/Message/ButtDesigner.dart';

import '../dio/APIs.dart';
import '../dio/HttpUtils.dart';
import '../utils/Global.dart';
import 'dart:convert' as convert;

import '../utils/TimeUtils.dart';

class MessageDetail extends StatefulWidget {
  const MessageDetail(this.text, this.type, {super.key});

  final String text;
  final String type;

  @override
  State<StatefulWidget> createState() {
    return MessageDetailState(text, type);
  }
}

//设计师设计设计详情
class MessageDetailState extends State with TickerProviderStateMixin {
  bool isloading = false;

  bool isRefresh = false;
  RefreshController refreshController = RefreshController();

  Map datamap = HashMap();

  final String id;
  final String type;
  List<dynamic> list = [];

  MessageDetailState(this.id, this.type);

  var scrSize ;
  @override
  void initState() {
    super.initState();
    getSqlData(id);
    setDjListSqlData(id);
  }

  //获取详情
  getSqlData(String requirementRowId) async {
    Map jsParam = {"requirementRowId": requirementRowId};
    var str = convert.jsonEncode(jsParam);
    HttpUtils.postJSON(context, APIs.getSqlData, {
      "sqlKey": "IOtnRrONhZc",
      "allValues": str,
      "token": await Global.getData("token"),
    }, success: (data) async {
      setState(() {
        isRefresh = true;
        datamap = data[0];
      });
    }, fail: (code, msg) {});
  }

  //对接设计师进度接口
  setDjListSqlData(String requirementRowId) async {
    Map jsParam = {"requirementRowId": requirementRowId};
    var str = convert.jsonEncode(jsParam);
    HttpUtils.postJSON(context, APIs.getSqlData, {
      "sqlKey": "IWIQfzuCFgw",
      "allValues": str,
      "token": await Global.getData("token"),
    }, success: (data) async {
      setState(() {
        list = json.decode(data[0]["progress"]);
        // print("object"+list[0].toString());
      });
    }, fail: (code, msg) {});
  }

  //对接接口
  setDjSqlData(String requirementRowId) async {
    Map jsParam = {"requirementRowId": requirementRowId};
    var str = convert.jsonEncode(jsParam);
    HttpUtils.postJSON(context, APIs.getSqlData, {
      "sqlKey": "IOvZPKNCODE",
      "allValues": str,
      "token": await Global.getData("token"),
    }, success: (data) async {
      setState(() {
        if (data[0]["code"] == "200") {
          showDialog(
            context: context,
            builder: (context) {
              return AlertDialog(
                title: const Text('操作成功'),
                content: const Text('当前需求已对接，请到web端的个人中心查看相关信息'),
                actions: [

                  ElevatedButton(
                      child: const Text("知道了"),
                      onPressed: () async {

                        Navigator.of(context).pop();// 关闭对话框
                        Navigator.pop(context);
                        //弹出对话框并等待其关闭
                        // bool? delete = await showDeleteConfirmDialog1();
                        // if (delete == null) {
                        //   print("取消删除");
                        // } else {
                        //   print("已确认删除");
                        //... 删除文件
                        // }
                      }
                  ),
                ],
              );
            },
          );
          // Toasts.showToast(data[0]["prompt"]);


          // Toasts.showToast("当前需求已对接，请到web端的个人中心查看相关信息");
        }
      });
    }, fail: (code, msg) {});
  }

  // Future<bool?> showDeleteConfirmDialog1() {
  //   return showDialog<bool>(
  //       context: context,
  //       builder: (context) {
  //         return AlertDialog(
  //             title: const Text("提示"),
  //             content: const Text("您确定要删除当前文件吗?"),
  //             actions: <Widget>[
  //               TextButton(
  //                 child: const Text("取消"),
  //                 onPressed: () => Navigator.of(context).pop(), // 关闭对话框
  //               ),
  //               TextButton(
  //                   child: const Text("删除"),
  //                   onPressed: () {
  //                     //关闭对话框并返回true
  //                     Navigator.of(context).pop(true);
  //                   }
  //               )
  //             ]
  //         );
  //       }
  //   );
  // }
      @override
      Widget build(BuildContext context) {

        scrSize = MediaQuery.of(context).size;
        return Scaffold(
          // backgroundColor: Colors.white,
            appBar: AppBar(
              title: const Text(
                "设计需求",
                style: TextStyle(color: Colors.black),
              ),
              backgroundColor: Colors.white,
              elevation: 0,
              leading: IconButton(
                icon: const Icon(
                  Icons.arrow_back,
                  color: Colors.black,
                ),
                onPressed: () {
                  Navigator.pop(context);
                },
              ),
            ),
            body: isRefresh
                ? CustomScrollView(
              slivers: [
                SliverToBoxAdapter(
                    child: Container(
                      padding: const EdgeInsets.only(top: 10),
                      width: double.infinity,
                      height: 10,
                      // color: const Color(0xffE5E5E5),
                    )),
                //显示顶部
                topWidget(datamap),
                designProgressInfoWidget(),
                baseInfoWidget(),
                designInfoWidget(),
                contactsInfoWidget(),
                SliverToBoxAdapter(child: paddingLine()),
                contactsJointButtonWidget(),
              ],
            )
                : Global.add());
      }

      Widget paddingLine() {
        return Container(
          margin: const EdgeInsets.only(top: 20),
          padding: const EdgeInsets.only(top: 10),
          width: double.infinity,
          height: 10,
          // color: const Color(0xffE5E5E5),
        );
      }

      //顶部信息
      Widget topWidget(Map map) {
        return SliverToBoxAdapter(
            child: Container(
                margin: const EdgeInsets.only(top: 10, left: 10, right: 10),
                //边框设置
                decoration: BoxDecoration(
                  //背景
                  color: Colors.white,
                  //设置四周圆角 角度
                  borderRadius: const BorderRadius.all(Radius.circular(10.0)),
                  //设置四周边框
                  border: Border.all(width: 1, color: Colors.white),
                ),
                child: Column(
                  // mainAxisAlignment: MainAxisAlignment.start,
                  children: [
                    Container(
                      margin: const EdgeInsets.only(
                          top: 10, left: 10, right: 10, bottom: 10),
                      child: Row(
                        mainAxisAlignment: MainAxisAlignment.spaceBetween,
                        children: [
                          Row(
                            children: [
                              ClipOval(
                                  child: datamap["avatar"] == null ||
                                      datamap["avatar"] == ""
                                      ? Global.getImageNull()
                                      : Global.getImage(
                                      json.decode(datamap["avatar"])["url"])),
                              Container(
                                margin: const EdgeInsets.only(
                                    bottom: 10, left: 10, top: 10),
                                child: Text(
                                  map["publisherName"] ?? "",
                                  overflow: TextOverflow.ellipsis,
                                  style: const TextStyle(
                                      fontSize: 13, color: Color(0xff666666)),
                                ),
                              )
                            ],
                          ),
                          map["publisherTime"] == null
                              ? const Text(
                            "发布日期 : ",
                          )
                              : Text(
                            "发布日期 : ${TimeUtils.timestampToDateStr(map["publisherTime"], true)}",
                            overflow: TextOverflow.ellipsis,
                            style: const TextStyle(
                                fontSize: 13, color: Color(0xff999999)),
                          )
                        ],
                      ),
                    ),
                    Container(
                      margin: const EdgeInsets.only(top: 1),
                      width: double.infinity,
                      height: 0.5,
                      color: const Color(0xffE5E5E5),
                    ),
                    Container(
                        margin: const EdgeInsets.only(top: 10, left: 10, right: 20),
                        child: Row(
                          mainAxisAlignment: MainAxisAlignment.spaceBetween,
                          children: [
                            Expanded(
                                child: Text(
                                  map["title"] ?? "",
                                  style: const TextStyle(
                                      fontSize: 15,
                                      color: Color(0xff666666),
                                      fontWeight: FontWeight.bold),
                                )),
                            map["canAbutment"] != null && map["canAbutment"] == "3"
                                ? const Text("已截止",
                                style: TextStyle(
                                    fontSize: 13, color: Color(0xff666666)))
                                : const Text("进行中",
                                style: TextStyle(
                                    fontSize: 13, color: Color(0xFF067DEB)))
                          ],
                        )),
                    Container(
                        margin: const EdgeInsets.only(top: 20, left: 10, right: 20),
                        child: Row(
                          children: [
                            const Text(
                              "设计费用(不含税):",
                              // overflow: TextOverflow.ellipsis,
                              style:
                              TextStyle(fontSize: 15, color: Color(0xff999999)),
                            ),
                            Text(
                              map["product_price"] == null
                                  ? ""
                                  : "￥${map["product_price"].toString()}",
                              //   Text("￥",
                              // overflow: TextOverflow.ellipsis,
                              style: const TextStyle(
                                  fontSize: 15, color: Color(0xffF93428)),
                            ),
                          ],
                        )),
                    Container(
                        margin: const EdgeInsets.only(top: 20, left: 10, right: 20),
                        child: Row(
                          children: [
                            const Text(
                              "截止时间:",
                              // overflow: TextOverflow.ellipsis,
                              style:
                              TextStyle(fontSize: 15, color: Color(0xff999999)),
                            ),
                            Text(
                              map["want_date"] == null
                                  ? ""
                                  : TimeUtils.timestampToDateStr(
                                  map["want_date"], true),
                              //   Text("￥",
                              // overflow: TextOverflow.ellipsis,
                              style: const TextStyle(
                                  fontSize: 15, color: Color(0xffF93428)),
                            ),
                          ],
                        )),
                  ],
                )));
      }

      Widget designerChildWidget(String url, String state, String name) {
        return Container(
          margin: const EdgeInsets.only(left: 10, right: 10, top: 10),
          child: Column(
            children: [
              Stack(alignment: Alignment.bottomCenter, children: [
                CircleAvatar(
                  // radius: window.innerWidth! / 12,
                  backgroundColor: Colors.grey,
                  backgroundImage: NetworkImage(url),
                ),
                Container(
                  padding: const EdgeInsets.all(5),
                  //边框设置
                  decoration: BoxDecoration(
                    //背景
                    color: state.contains("采纳")
                        ? Colors.deepOrangeAccent
                        : Colors.blue,
                    //设置四周圆角 角度
                    borderRadius: const BorderRadius.all(Radius.circular(18.0)),
                    //设置四周边框
                    border: Border.all(
                        width: 1,
                        color: state.contains("采纳")
                            ? Colors.deepOrangeAccent
                            : Colors.blue),
                  ),
                  child: Text(
                    state,
                    style: const TextStyle(fontSize: 15, color: Color(0xffffffff)),
                  ),
                )
              ]),
              Padding(
                padding: const EdgeInsets.only(top: 10, bottom: 10),
                child: Text(
                  name,
                  style: const TextStyle(fontSize: 15, color: Color(0xff222222)),
                ),
              )
            ],
          ),
        );
      }

      //基础信息
      Widget baseInfoWidget() {
        return SliverToBoxAdapter(
            child: Container(
                margin: const EdgeInsets.only(top: 10, left: 10, right: 10),
                //边框设置
                decoration: BoxDecoration(
                  //背景
                  color: Colors.white,
                  //设置四周圆角 角度
                  borderRadius: const BorderRadius.all(Radius.circular(10.0)),
                  //设置四周边框
                  border: Border.all(width: 1, color: Colors.white),
                ),
                child: Column(
                  children: [
                    Container(
                      alignment: Alignment.topLeft,
                      margin: const EdgeInsets.only(top: 20),
                      child: Row(
                        children: [
                          Container(
                            margin: const EdgeInsets.only(right: 10),
                            width: 3,
                            height: 15,
                            color: const Color(0xff00946B),
                          ),
                          const Text(
                            "基础信息",
                            style: TextStyle(
                                color: Color(0xff222222),
                                fontSize: 15,
                                fontWeight: FontWeight.bold),
                          ),
                        ],
                      ),
                    ),
                    baseInfoChildWidget("套件/单件", datamap["set_piece"] ?? ""),
                    baseInfoChildWidget("款式类型", datamap["style_type"] ?? ""),
                    baseInfoChildWidget("性别", datamap["gender"] ?? ""),
                    baseInfoChildWidget("上装/下装", datamap["top_bottom"] ?? ""),
                    baseInfoChildWidget("款式", datamap["short_long"] ?? ""),
                    baseInfoChildWidget("季节", datamap["season"] ?? ""),
                    baseInfoChildWidget("年份", datamap["year"] ?? ""),
                    baseInfoChildWidget("使用环境", datamap["environment"] ?? ""),
                  ],
                )));
      }

      Widget baseInfoChildWidget(String name, String value) {
        return Container(
            margin: const EdgeInsets.only(top: 20, left: 10, right: 20),
            child: Row(
              children: [
                SizedBox(
                  width: 100,
                  child: Text(
                    name,
                    overflow: TextOverflow.ellipsis,
                    style: const TextStyle(fontSize: 15, color: Color(0xff999999)),
                  ),
                ),
                Text(
                  value,
                  overflow: TextOverflow.ellipsis,
                  style: const TextStyle(fontSize: 15, color: Color(0xff222222)),
                ),
              ],
            ));
      }

      //设计进度
      Widget designProgressInfoWidget() {
        return SliverToBoxAdapter(
          child: Container(
            margin: const EdgeInsets.only(top: 10, left: 10, right: 10),
            //边框设置
            decoration: BoxDecoration(
              //背景
              color: Colors.white,
              //设置四周圆角 角度
              borderRadius: const BorderRadius.all(Radius.circular(10.0)),
              //设置四周边框
              border: Border.all(width: 1, color: Colors.white),
            ),
            child: Column(
              children: [
                Container(
                  alignment: Alignment.topLeft,
                  margin: const EdgeInsets.only(top: 10, left: 5),
                  child: Row(
                    children: [
                      Container(
                        width: 3,
                        height: 15,
                        color: const Color(0xff00946B),
                      ),
                      const Text(
                        "设计进度",
                        style: TextStyle(
                            color: Color(0xff222222),
                            fontSize: 15,
                            fontWeight: FontWeight.bold),
                      ),
                    ],
                  ),
                ),
                Row(
                  crossAxisAlignment: CrossAxisAlignment.center,
                  mainAxisAlignment: MainAxisAlignment.spaceBetween,
                  children: progressInfoChildWidget(),
                )
              ],
            ),
          ),
        );
      }

      List<Widget> progressInfoChildWidget() {
        List<Widget> listWidget = [];
        for (int i = 0; i < list.length; i++) {
          if (i == 0) {
            listWidget.add(designProgressInfoChildWidget(
                true, false, list[i]["n"], list[i]["t"] ?? ""));
          } else if (i < list.length - 1) {
            listWidget.add(designProgressInfoChildWidget(
                false, false, list[i]["n"], list[i]["t"] ?? ""));
          } else {
            listWidget.add(designProgressInfoChildWidget(
                false, true, list[i]["n"], list[i]["t"] ?? ""));
          }
        }
        return listWidget;
      }

      //设计进度子widget
      Widget designProgressInfoChildWidget(
          bool isVisibleLeft, bool isVisibleRight, String name, String time) {
        // formatDate(DateTime.now(),[yyyy,'年',mm,'月',dd])
        return Container(
          padding: const EdgeInsets.only(top: 20, bottom: 10),
          child: Column(
            children: [
              Row(
                children: [
                  Opacity(
                      opacity: isVisibleLeft ? 0 : 1,
                      child: Container(
                        height: 1,
                        width: scrSize.width/list.length-13-(scrSize.width/list.length)/2,
                        color: const Color(0xff07905F),
                      )),
                  Container(
                    margin: const EdgeInsets.only(right: 10),
                    child: const SizedBox(
                      width: 10,
                      height: 10,
                      child: CircleAvatar(
                        radius: 15,
                        backgroundColor: Color(0xff07905F),
                      ),
                    ),
                  ),
                  Opacity(
                    opacity: isVisibleRight ? 0 : 1,
                    child: Container(
                      height: 1,
                      width: scrSize.width/list.length-13-(scrSize.width/list.length)/2,
                      color: const Color(0xff07905F),
                    ),
                  ),
                ],
              ),
              Container(
                  margin: const EdgeInsets.only(top: 5, bottom: 5),
                  child: Text(
                    name,
                    style: const TextStyle(fontSize: 10),
                  )),
              Text(
                time,
                style: const TextStyle(fontSize: 10, color: Color(0xff000000)),
              ),
            ],
          ),
        );
      }

      //设计详情
      Widget designInfoWidget() {
        return SliverToBoxAdapter(
            child: Container(
                margin: const EdgeInsets.only(top: 10, left: 10, right: 10),
                //边框设置
                decoration: BoxDecoration(
                  //背景
                  color: Colors.white,
                  //设置四周圆角 角度
                  borderRadius: const BorderRadius.all(Radius.circular(10.0)),
                  //设置四周边框
                  border: Border.all(width: 1, color: Colors.white),
                ),
                child: Column(
                  children: [
                    Container(
                      alignment: Alignment.topLeft,
                      margin: const EdgeInsets.only(top: 20),
                      child: Row(
                        children: [
                          Container(
                            margin: const EdgeInsets.only(right: 10),
                            width: 3,
                            height: 15,
                            color: const Color(0xff00946B),
                          ),
                          const Text(
                            "设计详情",
                            style: TextStyle(
                                color: Color(0xff222222),
                                fontSize: 15,
                                fontWeight: FontWeight.bold),
                          ),
                        ],
                      ),
                    ),
                    Container(
                        margin: const EdgeInsets.only(top: 20, left: 10, right: 20),
                        child: Html(data: datamap["content"] ?? ""))
                  ],
                )));
      }

      //联系人信息
      Widget contactsInfoWidget() {
        return SliverToBoxAdapter(
            child: Container(
                margin: const EdgeInsets.only(top: 10, left: 10, right: 10),
                //边框设置
                decoration: BoxDecoration(
                  //背景
                  color: Colors.white,
                  //设置四周圆角 角度
                  borderRadius: const BorderRadius.all(Radius.circular(10.0)),
                  //设置四周边框
                  border: Border.all(width: 1, color: Colors.white),
                ),
                child: Column(
                  children: [
                    Container(
                      alignment: Alignment.topLeft,
                      margin: const EdgeInsets.only(top: 20),
                      child: Row(
                        children: [
                          Container(
                            margin: const EdgeInsets.only(right: 10),
                            width: 3,
                            height: 15,
                            color: const Color(0xff00946B),
                          ),
                          const Text(
                            "联系人信息",
                            style: TextStyle(
                                color: Color(0xff222222),
                                fontSize: 15,
                                fontWeight: FontWeight.bold),
                          ),
                        ],
                      ),
                    ),
                    baseInfoChildWidget("联系人", datamap["contacts"] ?? ""),
                    baseInfoChildWidget("固定电话", datamap["phone"] ?? ""),
                    baseInfoChildWidget("E-mail", datamap["email"] ?? ""),
                    baseInfoChildWidget("QQ", datamap["qq"] ?? ""),
                  ],
                )));
      }

      //对接按钮
      Widget contactsJointButtonWidget() {
        return SliverToBoxAdapter(
          child:
          // datamap["canAbutment"] == "2" ?
          Container(
              color: const Color(0xffE5E5E5),
              padding: const EdgeInsets.only(
                  top: 10, bottom: 20, left: 10, right: 10),
              child: TextButton(
                onPressed: () {
                  setDjSqlData(id);

                },
                style: ButtonStyle(
                  //设置字体颜色
                  foregroundColor: MaterialStateProperty.resolveWith((states) {
                    //按下按钮时的字体颜色
                    if (states.contains(MaterialState.pressed)) {
                      return Colors.white;
                    }
                    //默认不使用字体颜色
                    return Colors.white;
                  }),
                  //背景颜色
                  backgroundColor:
                  MaterialStateProperty.all(const Color(0xff00946B)),
                  //水波纹颜色 不想使用 设置透明即可
                  overlayColor: MaterialStateProperty.all(Colors.transparent),
                  //设置边框
                  side: MaterialStateProperty.all(
                      const BorderSide(color: Colors.white)),
                  //设置形状、圆角
                  shape: MaterialStateProperty.all(const StadiumBorder()),
                ),
                child: const Text("立即对接"),
              ))
              // : const Text(""),
        );
      }

      void _onRefresh() async {
        if (isloading) {
          //下拉刷新获取网络数据
          // getQueryHome();
        } else {
          refreshController.refreshCompleted();
          refreshController.loadComplete();
        }
        isloading = true;
      }

      void _onLoading() async {
        refreshController.loadComplete();
      }
}

