import 'dart:collection';
import 'dart:convert';

import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:flutter_html/flutter_html.dart';
import 'package:pull_to_refresh/pull_to_refresh.dart';
import 'package:textileclothing/Message/ButtDesigner.dart';

import '../dio/APIs.dart';
import '../dio/HttpUtils.dart';
import '../utils/Global.dart';
import 'dart:convert' as convert;

import '../utils/TimeUtils.dart';

class MessageDetailQy extends StatefulWidget {
  const MessageDetailQy(this.text, this.type, {super.key});

  final String text;
  final String type;

  @override
  State<StatefulWidget> createState() {
    return MessageDetailQyState(text, type);
  }
}

//企业：设计需求详情
class MessageDetailQyState extends State with TickerProviderStateMixin {
  bool isloading = false;

  bool isRefresh = false;
  RefreshController refreshController = RefreshController();
  Map datamap = HashMap();
  List<dynamic> list = [];

  final String id;
  final String type;

  var scrSize ;
  MessageDetailQyState(this.id, this.type);

  @override
  void initState() {
    super.initState();
    getGongXuDesignDetail(id);
    getSjsDetail(id);
  }

  //获取详情
  getGongXuDesignDetail(String requirementRowId) async {
    Map jsParam = {"requirementRowId": requirementRowId};
    var str = convert.jsonEncode(jsParam);
    HttpUtils.postJSON(context, APIs.getSqlData, {
      "sqlKey": "IOtnRrONhZc",
      "allValues": str,
      "token": await Global.getData("token"),
    }, success: (data) async {
      setState(() {
        isRefresh = true;
        datamap = data[0];
      });
    }, fail: (code, msg) {});
  }

  //获取对接设计师
  getSjsDetail(String requirementRowId) async {
    Map jsParam = {"requirementRowId": requirementRowId};
    var str = convert.jsonEncode(jsParam);
    HttpUtils.postJSON(context, APIs.getSqlData, {
      "sqlKey": "IVjpDzKzNdM",
      "allValues": str,
      "token": await Global.getData("token"),
    }, success: (data) async {
      setState(() {
        isRefresh = true;
        list = data;
      });
    }, fail: (code, msg) {});
  }

  @override
  Widget build(BuildContext context) {
    scrSize = MediaQuery.of(context).size;
    return Scaffold(
        appBar: AppBar(
          title: const Text(
            "设计需求",
            style: TextStyle(color: Colors.black),
          ),
          backgroundColor: Colors.white,
          elevation: 0,
          leading: IconButton(
            icon: const Icon(
              Icons.arrow_back,
              color: Colors.black,
            ),
            onPressed: () {
              Navigator.pop(context);
            },
          ),
        ),
        body: isRefresh
            ? CustomScrollView(
                slivers: [
                  //显示顶部
                  topWidget(datamap),
                  // SliverToBoxAdapter(child: paddingLine()),
                  designerWidget(type == "设计需求" ? list : list),
                  // SliverToBoxAdapter(child: paddingLine()),
                  baseInfoWidget(),
                  // SliverToBoxAdapter(child: paddingLine()),
                  // designProgressInfoWidget(),
                  // SliverToBoxAdapter(child: paddingLine()),
                  designInfoWidget(),
                  // SliverToBoxAdapter(child: paddingLine()),
                  contactsInfoWidget(),
                  SliverToBoxAdapter(child: paddingLine()),
                  // contactsJointButtonWidget(),
                ],
              )
            : Global.add());
  }

  Widget paddingLine() {
    return Container(
      margin: const EdgeInsets.only(top: 20),
      padding: const EdgeInsets.only(top: 10),
      width: double.infinity,
      height: 10,
      // color: Colors.white,
    );
  }

  //顶部信息
  Widget topWidget(Map map) {
    return SliverToBoxAdapter(
        child: Container(
            margin: const EdgeInsets.only(top: 10, left: 10, right: 10),
            //边框设置
            decoration: BoxDecoration(
              //背景
              color: Colors.white,
              //设置四周圆角 角度
              borderRadius: const BorderRadius.all(Radius.circular(10.0)),
              //设置四周边框
              border: Border.all(width: 1, color: Colors.white),
            ),
            child: Column(
              // mainAxisAlignment: MainAxisAlignment.start,
              children: [
                Container(
                  margin: const EdgeInsets.only(
                      top: 10, left: 10, right: 10, bottom: 10),
                  child: Row(
                    mainAxisAlignment: MainAxisAlignment.spaceBetween,
                    children: [
                      Text(
                        map["code"] ?? "",
                        overflow: TextOverflow.ellipsis,
                        style: const TextStyle(
                            fontSize: 13, color: Color(0xff666666)),
                      ),
                      map["publisherTime"] == null
                          ? const Text("发布日期 : ")
                          : Text(
                              "发布日期 : ${TimeUtils.timestampToDateStr(map["publisherTime"], true)}",
                              overflow: TextOverflow.ellipsis,
                              style: const TextStyle(
                                  fontSize: 13, color: Color(0xff999999)),
                            )
                    ],
                  ),
                ),

                Container(
                  margin: const EdgeInsets.only(top: 1),
                  width: double.infinity,
                  height: 0.5,
                  color: const Color(0xffE5E5E5),
                ),
                Container(
                    margin: const EdgeInsets.only(top: 10, left: 10, right: 20),
                    child: Row(
                      mainAxisAlignment: MainAxisAlignment.spaceBetween,
                      children: [
                        Expanded(
                            child: Text(
                          map["title"] ?? "",
                          overflow: TextOverflow.ellipsis,
                          style: const TextStyle(
                              fontSize: 15,
                              color: Color(0xff666666),
                              fontWeight: FontWeight.bold),
                        )),
                        map["canAbutment"] != null && map["canAbutment"] == "3"
                            ? const Text("已截止",
                                style: TextStyle(
                                    fontSize: 13, color: Color(0xff666666)))
                            : const Text("进行中",
                                style: TextStyle(
                                    fontSize: 13, color: Color(0xFF067DEB)))
                        // Container(
                        //   // margin: const EdgeInsets.only(top: 10, left: 10, right: 10),
                        //   //边框设置
                        //   decoration: BoxDecoration(
                        //     //背景
                        //     color: const Color(0xFF067DEB),
                        //     //设置四周圆角 角度
                        //     borderRadius: const BorderRadius.all(Radius.circular(5.0)),
                        //     //设置四周边框
                        //     border: Border.all(width: 1, color: Colors.white),
                        //   ),
                        //   child:
                        //   Text(map["canAbutmentName"]??"没返回数据",
                        //       style: const TextStyle(fontSize: 13, color: Color(0xFF067DEB))))
                      ],
                    )),
                Container(
                    margin: const EdgeInsets.only(top: 20, left: 10, right: 20),
                    child: Row(
                      children: [
                        const Text(
                          "设计费用(不含税):",
                          overflow: TextOverflow.ellipsis,
                          style:
                              TextStyle(fontSize: 15, color: Color(0xff999999)),
                        ),
                        Text(
                          map["product_price"] == null
                              ? ""
                              : "￥${map["product_price"].toString()}",
                          //   Text("￥",
                          overflow: TextOverflow.ellipsis,
                          style: const TextStyle(
                              fontSize: 15, color: Color(0xffF93428)),
                        ),
                      ],
                    )),
                Container(
                    margin: const EdgeInsets.only(
                        top: 20, left: 10, right: 20, bottom: 10),
                    child: Row(
                      children: [
                        const Text(
                          "截止时间:",
                          overflow: TextOverflow.ellipsis,
                          style:
                              TextStyle(fontSize: 15, color: Color(0xff999999)),
                        ),
                        Text(
                          map["want_date"] == null
                              ? ""
                              : TimeUtils.timestampToDateStr(
                                  map["want_date"], true),
                          style: const TextStyle(
                            fontSize: 15,
                            color: Color(0xff333333),
                          ),
                        ),
                      ],
                    )),
                // Container(
                //   margin: const EdgeInsets.only(top: 10),
                //   width: double.infinity,
                //   height: 0.5,
                //   color: const Color(0xffE5E5E5),
                // ),
                // GestureDetector(
                //   child:Container(
                //       margin: const EdgeInsets.only(top: 5, left: 10, right: 10,bottom: 10),
                //       child: Row(
                //         mainAxisAlignment: MainAxisAlignment.spaceBetween,
                //         children:[
                //           Text(APIs.typename=="企业"?
                //           "对接设计师:":"对接厂商",
                //             overflow: TextOverflow.ellipsis,
                //             style: const TextStyle(fontSize: 15, color: Color(0xff333333)),
                //           ),
                //           const Icon(Icons.arrow_forward_ios,color: Color(0xff333333),size: 15),
                //         ],
                //       )) ,
                //   onTap: (){
                //
                //   },
                // ),
              ],
            )));
  }

  //对接设计师
  Widget designerWidget(List<dynamic> list) {
    return SliverToBoxAdapter(
        child: Container(
            margin: const EdgeInsets.only(top: 10, left: 10, right: 10),
            //边框设置
            decoration: BoxDecoration(
              //背景
              color: Colors.white,
              //设置四周圆角 角度
              borderRadius: const BorderRadius.all(Radius.circular(10.0)),
              //设置四周边框
              border: Border.all(width: 1, color: Colors.white),
            ),
            child: GestureDetector(
              child: Column(
                children: [
                  Container(
                    alignment: Alignment.topLeft,
                    margin: const EdgeInsets.only(top: 20),
                    child: Row(
                      mainAxisAlignment: MainAxisAlignment.spaceBetween,
                      children: [
                        Row(
                          children: [
                            Container(
                              margin: const EdgeInsets.only(right: 10),
                              width: 3,
                              height: 15,
                              color: const Color(0xff00946B),
                            ),
                            const Text(
                              "对接设计师",
                              style: TextStyle(
                                  color: Color(0xff222222),
                                  fontSize: 15,
                                  fontWeight: FontWeight.bold),
                            ),
                          ],
                        ),
                        const Icon(Icons.chevron_right)
                      ],
                    ),
                  ),
                  Row(
                    mainAxisAlignment: MainAxisAlignment.spaceBetween,
                    children: desigerChildeWidgets(),
                  )
                ],
              ),
              onTap: () {
                Navigator.push(context, MaterialPageRoute(builder: (context) {
                  return ButtDesigner(list);
                }));
              },
            )));
  }

  List<Widget> desigerChildeWidgets() {
    List<Widget> listWidget = [];
    if (list.isNotEmpty) {
      for (int i = 0; i < list.length; i++) {
        listWidget.add(designerChildWidget(null==list[i]["avatar"]?"":
          json.decode(list[i]["avatar"])["url"],
          list[i]["statusName"],
          list[i]["username"],
        ));
      }
    }
    return listWidget;
  }

  Widget designerChildWidget(String url, String state, String name) {
    return Container(
      margin: const EdgeInsets.only(left: 10, right: 10, top: 10),
      child: Column(
        children: [
          Stack(alignment: Alignment.bottomCenter, children: [
            CircleAvatar(
              radius: scrSize.width  / 12,
              backgroundColor: Colors.grey,
              backgroundImage: NetworkImage(url==""?"images/avatar.png":url),
            ),
            Container(
              padding: const EdgeInsets.all(5),
              //边框设置
              decoration: BoxDecoration(
                //背景
                color: state.contains("采纳")
                    ? Colors.deepOrangeAccent
                    : Colors.blue,
                //设置四周圆角 角度
                borderRadius: const BorderRadius.all(Radius.circular(18.0)),
                //设置四周边框
                border: Border.all(
                    width: 1,
                    color: state.contains("采纳")
                        ? Colors.deepOrangeAccent
                        : Colors.blue),
              ),
              child: Text(
                state,
                style: const TextStyle(fontSize: 15, color: Color(0xffffffff)),
              ),
            )
          ]),
          Padding(
            padding: const EdgeInsets.only(top: 10, bottom: 10),
            child: Text(
              name,
              style: const TextStyle(fontSize: 15, color: Color(0xff222222)),
            ),
          )
        ],
      ),
    );
  }

  //基础信息
  Widget baseInfoWidget() {
    return SliverToBoxAdapter(
        child: Container(
            margin: const EdgeInsets.only(top: 10, left: 10, right: 10),
            //边框设置
            decoration: BoxDecoration(
              //背景
              color: Colors.white,
              //设置四周圆角 角度
              borderRadius: const BorderRadius.all(Radius.circular(10.0)),
              //设置四周边框
              border: Border.all(width: 1, color: Colors.white),
            ),
            child: Column(
              children: [
                Container(
                  alignment: Alignment.topLeft,
                  margin: const EdgeInsets.only(top: 20),
                  child: Row(
                    children: [
                      Container(
                        margin: const EdgeInsets.only(right: 10),
                        width: 3,
                        height: 15,
                        color: const Color(0xff00946B),
                      ),
                      const Text(
                        "基础信息",
                        style: TextStyle(
                            color: Color(0xff222222),
                            fontSize: 15,
                            fontWeight: FontWeight.bold),
                      ),
                    ],
                  ),
                ),
                baseInfoChildWidget("套件/单件", datamap["set_piece"] ?? ""),
                baseInfoChildWidget("款式类型", datamap["style_type"] ?? ""),
                baseInfoChildWidget("性别", datamap["gender"] ?? ""),
                baseInfoChildWidget("上装/下装", datamap["top_bottom"] ?? ""),
                baseInfoChildWidget("款式", datamap["short_long"] ?? ""),
                baseInfoChildWidget("季节", datamap["season"] ?? ""),
                baseInfoChildWidget("年份", datamap["year"] ?? ""),
                baseInfoChildWidget("使用环境", datamap["environment"] ?? ""),
              ],
            )));
  }

  Widget baseInfoChildWidget(String name, String value) {
    return Container(
        margin: const EdgeInsets.only(top: 20, left: 10, right: 20),
        child: Row(
          children: [
            SizedBox(
              width: 100,
              child: Text(
                name,
                overflow: TextOverflow.ellipsis,
                style: const TextStyle(fontSize: 15, color: Color(0xff999999)),
              ),
            ),
            Text(
              value,
              overflow: TextOverflow.ellipsis,
              style: const TextStyle(fontSize: 15, color: Color(0xff222222)),
            ),
          ],
        ));
  }

  //设计详情
  Widget designInfoWidget() {
    return SliverToBoxAdapter(
        child: Container(
            margin: const EdgeInsets.only(top: 10, left: 10, right: 10),
            //边框设置
            decoration: BoxDecoration(
              //背景
              color: Colors.white,
              //设置四周圆角 角度
              borderRadius: const BorderRadius.all(Radius.circular(10.0)),
              //设置四周边框
              border: Border.all(width: 1, color: Colors.white),
            ),
            child: Column(
              children: [
                Container(
                  alignment: Alignment.topLeft,
                  margin: const EdgeInsets.only(top: 20),
                  child: Row(
                    children: [
                      Container(
                        margin: const EdgeInsets.only(right: 10),
                        width: 3,
                        height: 15,
                        color: const Color(0xff00946B),
                      ),
                      const Text(
                        "设计详情",
                        style: TextStyle(
                            color: Color(0xff222222),
                            fontSize: 15,
                            fontWeight: FontWeight.bold),
                      ),
                    ],
                  ),
                ),
                Container(
                    margin: const EdgeInsets.only(top: 20, left: 10, right: 20),
                    child: Html(data: datamap["content"] ?? ""))
              ],
            )));
  }

  //联系人信息
  Widget contactsInfoWidget() {
    return SliverToBoxAdapter(
        child: Container(
            margin: const EdgeInsets.only(top: 10, left: 10, right: 10),
            //边框设置
            decoration: BoxDecoration(
              //背景
              color: Colors.white,
              //设置四周圆角 角度
              borderRadius: const BorderRadius.all(Radius.circular(10.0)),
              //设置四周边框
              border: Border.all(width: 1, color: Colors.white),
            ),
            child: Column(
              children: [
                Container(
                  alignment: Alignment.topLeft,
                  margin: const EdgeInsets.only(top: 20),
                  child: Row(
                    children: [
                      Container(
                        margin: const EdgeInsets.only(right: 10),
                        width: 3,
                        height: 15,
                        color: const Color(0xff00946B),
                      ),
                      const Text(
                        "联系人信息",
                        style: TextStyle(
                            color: Color(0xff222222),
                            fontSize: 15,
                            fontWeight: FontWeight.bold),
                      ),
                    ],
                  ),
                ),
                baseInfoChildWidget("联系人", datamap["contacts"] ?? ""),
                baseInfoChildWidget("固定电话", datamap["phone"] ?? ""),
                baseInfoChildWidget("E-mail", datamap["email"] ?? ""),
                baseInfoChildWidget("QQ", datamap["qq"] ?? ""),
              ],
            )));
  }

  void _onRefresh() async {
    if (isloading) {
      //下拉刷新获取网络数据
      // getQueryHome();
    } else {
      refreshController.refreshCompleted();
      refreshController.loadComplete();
    }
    isloading = true;
  }

  void _onLoading() async {
    refreshController.loadComplete();
  }
}
