
import 'dart:collection';
import 'dart:convert';

import 'package:event_bus/event_bus.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'package:intl/intl.dart';
// import 'package:intl/intl.dart';
import 'package:pull_to_refresh/pull_to_refresh.dart';
import 'package:textileclothing/Message/MessageDetail.dart';
import 'package:textileclothing/Message/MessageDetailQy.dart';
import 'package:textileclothing/Message/ProduceDetail.dart';
import 'package:toast/toast.dart';

import '../Iconfont.dart';
import '../dio/APIs.dart';
import '../dio/HttpUtils.dart';
import '../home/BusContent.dart';
import '../home/HomeSerch.dart';
import '../utils/Global.dart';
import '../utils/TimeUtils.dart';
import '../widget/MySmartRefresher.dart';
import '../widget/StickyTabBarDelegate.dart';
import 'dart:convert' as convert;

import '../widget/Toast.dart';
import 'ProduceDetailQy.dart';
import 'package:flutter_localizations/flutter_localizations.dart';

class MessageMain extends StatefulWidget {

  State mess = new MessageMainState();

  @override
  State<StatefulWidget> createState() {
    return mess;
  }

  serchClear(){
    (mess as MessageMainState).clearSerchController();
  }

}

class MessageMainState extends State with TickerProviderStateMixin {
  bool isLoading = false;
  bool isLoadMore = false;

  bool isRefreshFwsp = false;
  bool isRefreshData = false;
  bool isRefreshSjxq = false;
  bool isRefreshScxq = false;
  RefreshController refreshController = RefreshController();

  int fwspPageNo = 1;
  int fwsppageSize = 15;

  int tzggPageNo = 1;
  int tzggpageSize = 15;

  int syxqPageNo = 1;
  int syxqpageSize = 15;

  late TabController newSContRoller;
  List<String> homeNewsType = [];
  TextEditingController serChController = TextEditingController();

  Map fwspMap = HashMap(); //服务审批
  Map datamap = HashMap(); //公告
  Map sjxqmap = HashMap(); //设计需求
  Map scxqmap = HashMap(); //生产需求
  int tabClickIndex = 0;

  String birthday = ""; //日期
  // late DateTime dateTimeNew ;
  String noticeBirthday = "";
  String startTime = "";
  String endTime = "";

  void clearSerchController() {
    serChController.clear();
    fwspMap.clear();
    tabClickIndex = 0;
    initData();
  }

  @override
  void initState() {
    super.initState();
    serChController.clear();
    //监听广播
    Global.eventBus.on().listen((event) {
      setState(() {
        APIs.typename = event;
        initData();
        tabClickIndex = 0;
        fwspPageNo = 1;
        tzggPageNo = 1;
        syxqPageNo = 1;
      });
    });
    initData();
  }

  initData() {
    if (APIs.typename == "企业用户") {
      homeNewsType = ["服务审批", "通知公告", "设计需求", "生产需求"];
    } else if (APIs.typename == "设计师用户") {
      homeNewsType = ["服务审批", "通知公告", "设计需求"];
    } else if (APIs.typename == "工厂用户") {
      homeNewsType = ["服务审批", "通知公告", "生产需求"];
    } else {
      homeNewsType = ["服务审批", "通知公告"];
    }
    newSContRoller = TabController(
      length: homeNewsType.length, //设置了这个控制器要显示多少个
      vsync: this,
    );
    getWait("");
  }

  //服务审批
  getWait(String formStatusId) async {
    HttpUtils.postJSON(context, APIs.getWaitPage, {
      "pageSize": fwsppageSize,
      "pageNo": fwspPageNo,
      "token": await Global.getData("token"),
      "appName": serChController.text ?? "",
      "startTime": startTime != "" ? startTime : "",
      "endTime": endTime != "" ? endTime : "",
      "levelId": formStatusId
    }, success: (data) async {
      setState(() {
        isRefreshFwsp = true;
        if (fwspPageNo == 1) {
          fwspMap = data;
        } else if (fwspPageNo <= fwspMap["totalPage"]) {
          fwspMap["rows"].addAll(data["rows"]);
        }
        if (fwspMap.isNotEmpty && fwspPageNo == fwspMap["totalPage"]) {
          refreshController.loadNoData();
        } else {
          refreshController.loadComplete();
        }
        refreshController.refreshCompleted();
        if (!serChController.text.isNotEmpty) {
          Global.numberRedBus.fire(data["total"]);
        }
      });
    }, fail: (code, msg) {});
  }

  // 所有需求列表
  getSqlData(String sqlKey, String endTime, String title) async {
    Map jsParam = {"fulText": serChController.text ?? "", "dateStr": endTime};
    var str = convert.jsonEncode(jsParam);
    HttpUtils.postJSON(context, APIs.getSqlData, {
      "pageSize": syxqpageSize,
      "pageNo": syxqPageNo,
      "token": await Global.getData("token"),
      "title": serChController.text ?? "",
      "sqlKey": sqlKey,
      "jsParams": [str].toString(),
    }, success: (data) async {
      setState(() {
        if (tabClickIndex == 2) {
          if (APIs.typename == "工厂用户") {
            isRefreshScxq = true;
            if (syxqPageNo == 1) {
              scxqmap = data;
            } else if (syxqPageNo <= scxqmap["totalPage"]) {
              scxqmap["rows"].addAll(data["rows"]);
            }
            if (scxqmap.isNotEmpty && syxqPageNo == scxqmap["totalPage"]) {
              refreshController.loadNoData();
            } else {
              refreshController.loadComplete();
            }
            refreshController.refreshCompleted();
            // print("syxqPageNo:"+syxqPageNo.toString()+":"+scxqmap["totalPage"].toString());
            // scxqmapTemporary = data;
            // scxqmap.addAll(scxqmapTemporary);
          } else {
            isRefreshSjxq = true;
            if (syxqPageNo == 1) {
              sjxqmap = data;
            } else if (syxqPageNo <= sjxqmap["totalPage"]) {
              sjxqmap["rows"].addAll(data["rows"]);
            }
            if (sjxqmap.isNotEmpty && syxqPageNo == sjxqmap["totalPage"]) {
              refreshController.loadNoData();
            } else {
              refreshController.loadComplete();
            }
            refreshController.refreshCompleted();
            // print("syxqPageNo:"+syxqPageNo.toString()+" sjxqmap:"+sjxqmap["totalPage"].toString());
            // sjxqmapTemporary= data;
            // sjxqmap.addAll(sjxqmapTemporary);
          }
        } else {
          isRefreshScxq = true;
          if (syxqPageNo == 1) {
            scxqmap = data;
          } else if (syxqPageNo <= scxqmap["totalPage"]) {
            scxqmap["rows"].addAll(data["rows"]);
          }
          if (scxqmap.isNotEmpty && syxqPageNo == scxqmap["totalPage"]) {
            refreshController.loadNoData();
          } else {
            refreshController.loadComplete();
          }
          refreshController.refreshCompleted();
          // print("syxqPageNo:"+syxqPageNo.toString()+" scxqmap:"+scxqmap["totalPage"].toString());
          // scxqmapTemporary = data;
          // scxqmap.addAll(scxqmapTemporary);
        }
      });
    }, fail: (code, msg) {});
  }

  //获取通知公告列表
  getNewsList() async {
    if (noticeBirthday == "") {
      HttpUtils.postJSON(context, APIs.BaseNewsList, {
        "pageNo": tzggPageNo,
        "pageSize": tzggpageSize,
        "channelId": "7",
        "randomKey": "0.3473468060730387",
        "title": serChController.text ?? "",
        "statusKey": "2",
        "token": await Global.getData("token"),
      }, success: (data) async {
        setState(() {
          isRefreshData = true;
          if (tzggPageNo == 1) {
            datamap = data;
          } else if (tzggPageNo <= datamap["totalPage"]) {
            datamap["rows"].addAll(data["rows"]);
          }
          if (datamap.isNotEmpty && tzggPageNo == datamap["totalPage"]) {
            refreshController.loadNoData();
          } else {
            refreshController.loadComplete();
          }
          refreshController.refreshCompleted();
          // print("通知公告0+"+tzggPageNo.toString()+ ":"+ datamap["totalPage"].toString());
          // datamapTemporary= data;
          // datamap.addAll(datamapTemporary);
        });
      }, fail: (code, msg) {});
    } else {
      HttpUtils.postJSON(context, APIs.BaseNewsList, {
        "pageNo": tzggPageNo,
        "pageSize": tzggpageSize,
        "channelId": "7",
        "randomKey": "0.3473468060730387",
        "title": serChController.text ?? "",
        "statusKey": "2",
        "token": await Global.getData("token"),
        "publishTime": noticeBirthday,
      }, success: (data) async {
        setState(() {
          isRefreshData = true;
          if (tzggPageNo == 1) {
            datamap = data;
          } else if (tzggPageNo <= datamap["totalPage"]) {
            datamap["rows"].addAll(data["rows"]);
          }
          if (datamap.isNotEmpty && tzggPageNo == datamap["totalPage"]) {
            refreshController.resetNoData();
          } else {
            refreshController.loadComplete();
          }
          refreshController.refreshCompleted();
          // print("通知公告+" + datamap["totalPage"].toString());
        });
      }, fail: (code, msg) {});
    }
  }

  void setonTap(String id) async {
    if (tabClickIndex == 0) {
      Global.appUrl(context,
          "/IfarmeAffairDetail?id=$id&token=${await Global.getData("token")}");
    } else if (tabClickIndex == 2) {
      if (APIs.typename == "企业用户") {
        Navigator.push(context, MaterialPageRoute(builder: (context) {
          return MessageDetailQy(id, "设计需求");
        }));
      } else if (APIs.typename == "设计师用户") {
        Navigator.push(context, MaterialPageRoute(builder: (context) {
          return MessageDetail(id, "设计需求");
        }));
      } else {
        Navigator.push(context, MaterialPageRoute(builder: (context) {
          return ProduceDetail(id, "生产需求");
        }));
      }
    } else if (tabClickIndex == 3) {
      Navigator.push(context, MaterialPageRoute(builder: (context) {
        return ProduceDetailQy(id, "生产需求");
      }));
    } else {}
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        title: const Text(
          "消息",
          style: TextStyle(color: Colors.white),
        ),
        backgroundColor: Color(APIs.themeColors),
        elevation: 0,
        leadingWidth: 0,
        leading: const Text(""),
      ),
      body: MySmartRefresher().getRefreshers(
        refreshController,
        _onRefresh,
        _onLoading,
        CustomScrollView(
          slivers: [
            //显示标题
            getTabBar(),
            //搜索
            serchWidget(),
            //显示列表内容
            getBoxAdapter(),
          ],
        ),
      ),
    );
  }

  Widget serchWidget() {
    return SliverPersistentHeader(
        delegate: StickyTabBarDelegate(
      child: Container(
        margin: const EdgeInsets.only(left: 10, right: 10, top: 10, bottom: 10),
        child: Row(
          children: <Widget>[
            //因为它是左右占比结构,所以使用Expanded 的flex
            Expanded(
                flex: 1,
                child: Container(
                  //所有组件垂直居中
                  alignment: Alignment.center,
                  height: 40,
                  padding: const EdgeInsets.fromLTRB(10, 0, 15, 0),
                  margin: const EdgeInsets.fromLTRB(10, 0, 10, 0),
                  //带有弧度的边框,有背景色
                  decoration: BoxDecoration(
                    //背景
                    color: const Color(0xfff2f2f2),
                    //设置四周圆角 角度
                    borderRadius: const BorderRadius.all(Radius.circular(25.0)),
                    //设置四周边框
                    border: Border.all(
                      width: 1,
                      color: const Color(0xfff2f2f2),
                    ),
                  ),
                  child: TextField(
                    controller: serChController,
                    style: const TextStyle(fontSize: 16),
                    decoration: InputDecoration(
                      hintText: "请输入标题、内容",
                      hintStyle: const TextStyle(color: Color(0x50000000)),
                      border: InputBorder.none,
                      prefixIcon: GestureDetector(
                        child: const Icon(Iconfont.search,
                            color: Color(0x50000000), size: 15),
                        onTap: () {
                          birthday = "";
                          onTapBar(tabClickIndex, "");
                        },
                      ),
                    ),
                  ),
                )),
            GestureDetector(
              child: Container(
                  width: 20,
                  height: 20,
                  margin: const EdgeInsets.only(bottom: 2),
                  child: Image.asset(
                    "images/times.png",
                  )),
              onTap: () {
                Future<DateTime?> selectedDate = selectDate(context);
                selectedDate.then((dateTime) {
                  setState(() {
                    fwspMap.clear();
                    datamap.clear();
                    sjxqmap.clear();
                    scxqmap.clear();
                    fwspPageNo = 1;
                    tzggPageNo = 1;
                    syxqPageNo = 1;
                    DateTime dateTimeNew = dateTime!;
                    noticeBirthday =
                        DateFormat('yyyy-MM-dd').format(dateTimeNew);
                    birthday = dateToTimestamp(dateTime.toString()).toString();
                    onTapBar(tabClickIndex, noticeBirthday);
                    startTime = dateToTimestamp(
                            DateFormat('yyyy-MM-dd 00:00:00')
                                .format(dateTimeNew))
                        .toString();
                    endTime = dateToTimestamp(DateFormat('yyyy-MM-dd 23:59:59')
                            .format(dateTimeNew))
                        .toString();
                  });
                });
              },
            )
          ],
        ),
      ),
    ));
  }

  ///日期转时间戳
  static int dateToTimestamp(String date, {isMicroseconds = false}) {
    DateTime dateTime = DateTime.parse(date);
    int timestamp = dateTime.millisecondsSinceEpoch;
    if (isMicroseconds) {
      timestamp = dateTime.microsecondsSinceEpoch;
    }
    return timestamp;
  }

  Future<DateTime?> selectDate(BuildContext context) async {
    DateTime? picked = await showDatePicker(
        context: context,
        initialDate: DateTime.now(),
        locale: const Locale('zh'),
        firstDate: DateTime(1960),
        lastDate: DateTime(2030));
    return picked;
  }

  List<Widget> getTabs() {
    if (homeNewsType == []) {
      return [];
    } else {
      return homeNewsType.map((f) {
        return Text(
          f, //对象里面显示的内容
          style: const TextStyle(fontSize: 15),
        );
      }).toList();
    }
  }

  Widget getTabBar() {
    return SliverPersistentHeader(
//        pinned: true,
        delegate: StickyTabBarDelegate(
            child: TabBar(
      tabs: getTabs(),
      //tab要显示内容如何显示
      controller: newSContRoller,
      //控制tab显示多少个内容
      indicatorColor: Color(APIs.themeColors),
      indicatorSize: TabBarIndicatorSize.label,
      //下划线跟tab一样宽
      isScrollable: true,
      //不允许滑动
      labelColor: Colors.black,
      unselectedLabelColor: Colors.black,
      indicatorWeight: 2.0,
      //下划线高度
      labelPadding:
          const EdgeInsets.only(left: 10, right: 10, top: 10, bottom: 10),
      //间距
      labelStyle: const TextStyle(height: 2),
      onTap: (index) {
        fwspPageNo = 1;
        tzggPageNo = 1;
        syxqPageNo = 1;
        serChController.clear();
        birthday = "";
        setState(() {
          tabClickIndex = index;
          onTapBar(index, "");
        });
        // pageNo = 1;
        // this.tabClickIndex = index;
        // //点击事件
        // getNewsList(homeNewsType[index].id);
      },
    )));
  }

  onTapBar(int index, String time) {
    if (index == 1) {
      getNewsList();
    } else if (index == 2) {
      if (APIs.typename == "企业用户") {
        getSqlData("IVJyowsnSsw", time, ""); //企业设计需求列表：sqlKey: IVJyowsnSsw----
      } else if (APIs.typename == "设计师用户") {
        getSqlData("IVKBWDLXzgQ", time, ""); //设计师设计需求列表：sqlKey: IVKBWDLXzgQ
      } else if (APIs.typename == "工厂用户") {
        getSqlData("IVKBgfEKeTE", time, ""); //工厂生产需求列表：sqlKey: IVKBWDLXzgQ
      }
    } else if (index == 3) {
      if (APIs.typename == "企业用户") {
        //生产需求列表
        getSqlData("IVKAWVAdASY", time, ""); //企业：sqlKey: IVKAWVAdASY
      } else if (APIs.typename == "工厂用户") {
        getSqlData("IVKBgfEKeTE", time, ""); //工厂：sqlKey: IVKBWDLXzgQ
      }
    } else {
      getWait("");
    }
  }

  Widget widgetBody(Map map) {
    return SliverToBoxAdapter(
        child: ListView.builder(
            //是list列表
            physics: const NeverScrollableScrollPhysics(),
            shrinkWrap: true,
            itemCount: map["rows"].length ?? 0,
            itemBuilder: (BuildContext context, int index) {
              return getNewsGGType(map["rows"][index]);
            }));
  }

  //新闻公告列表
  Widget getBoxAdapter() {
    if (tabClickIndex == 1) {
      //公告
      if (!isRefreshData||datamap.isEmpty) {
        return SliverToBoxAdapter(child: Global.add());
      } else {
        return widgetBody(datamap);
      }
    } else if (tabClickIndex == 2) {
      //设计需求
      if (APIs.typename == "工厂用户") {
        if (!isRefreshScxq||scxqmap.isEmpty) {
          return SliverToBoxAdapter(child: Global.add());
        } else {
          // print("工厂data数据");
          return widgetBody(scxqmap);
        }
      } else {
        if (!isRefreshSjxq||sjxqmap.isEmpty) {
          return SliverToBoxAdapter(child: Global.add());
        } else {
          return widgetBody(sjxqmap);
        }
      }
    } else if (tabClickIndex == 3) {
      //生产需求
      if (!isRefreshScxq||scxqmap.isEmpty) {
        return SliverToBoxAdapter(child: Global.add());
      } else {
        return widgetBody(scxqmap);
      }
    } else {
      if (!isRefreshFwsp||fwspMap.isEmpty) {
        return SliverToBoxAdapter(child: Global.add());
      } else {
        return widgetBody(fwspMap); //服务审批
      }
    }
  }

  Widget getNewsGGType(Map map) {
    if (tabClickIndex == 1) {
      //新闻公告列表
      return getList1(
          map["isTop"],
          map["title"],
          map["createTime"],
          map["userName"],
          map["id"],
          map["isLink"] ?? false,
          map["linkUrl"] ?? "");
    } else if (tabClickIndex == 2) {
      //设计师-设计需求
      if (APIs.typename == "设计师用户") {
        return getList2(map);
      } else if (APIs.typename == "工厂用户") {
        //工厂-生产需求
        return getList4(map);
      } else {
        //企业-设计需求
        return getList3(map);
      }
    } else if (tabClickIndex == 3) {
      //企业-生产需求
      return getList5(map);
    } else {
      //审批
      return getList(map);
    }
  }

  Widget getList(Map map) {
    return GestureDetector(
        child: Container(
          margin: const EdgeInsets.only(top: 10, left: 10, right: 10),
          //边框设置
          decoration: BoxDecoration(
            //背景
            color: Colors.white,
            //设置四周圆角 角度
            borderRadius: const BorderRadius.all(Radius.circular(10.0)),
            //设置四周边框
            border: Border.all(width: 1, color: Colors.white),
          ),
          child: Column(
            mainAxisAlignment: MainAxisAlignment.start,
            children: [
              Container(
                color: Colors.white,
                margin: const EdgeInsets.only(top: 20, left: 10, right: 10),
                child: Row(
                  mainAxisAlignment: MainAxisAlignment.spaceBetween,
                  children: [
                    Row(
                      children: [
                        ClipOval(
                            child: map["userHeader"] == null ||
                                    map["userHeader"] == ""
                                ? Global.getImageNull()
                                : Global.getImage(
                                    json.decode(map["userHeader"])["url"])),
                        // ClipOval(
                        //     child: FadeInImage.assetNetwork(
                        //       placeholder: 'images/noavailable.png',
                        //       image: map["userHeader"]==null||map["userHeader"]==""? ""
                        //           : json.decode(map["userHeader"])["url"],
                        //       width: 20,
                        //       height: 20,
                        //       fit: BoxFit.cover,
                        //     )),
                        Container(
                            margin: const EdgeInsets.only(left: 10),
                            child: Text(map["userName"] ?? "",
                                style: const TextStyle(
                                    fontSize: 13, color: Color(0xff666666)))),
                      ],
                    ),
                    Text(
                      map["createTime"] == null
                          ? ""
                          : TimeUtils.timestampToDateStr(
                              map["createTime"], true),
                      overflow: TextOverflow.ellipsis,
                      style: const TextStyle(
                          fontSize: 13, color: Color(0xff999999)),
                    )
                  ],
                ),
              ),
              Container(
                margin: const EdgeInsets.only(
                    top: 10, bottom: 5, left: 10, right: 10),
                width: double.infinity,
                height: 0.5,
                color: const Color(0xffE5E5E5),
              ),
              Container(
                  margin: const EdgeInsets.only(top: 10, left: 10, right: 20),
                  child: Row(
                    children: [
                      Text(
                        map["appName"] ?? "",
                        // map["appName"] +"("+map["formLevel"]+")"?? "",
                        overflow: TextOverflow.ellipsis,
                        style: const TextStyle(
                            fontSize: 15,
                            color: Color(0xff333333),
                            fontWeight: FontWeight.bold),
                      ),
                      Expanded(
                          child: Text(
                        map["statusName"] ?? "",
                        textAlign: TextAlign.right,
                        style: const TextStyle(
                            fontSize: 15, color: Color(0xffFF862F)),
                      )),
                    ],
                  )),
              Container(
                  margin: const EdgeInsets.only(top: 20, left: 10, right: 20),
                  child: Row(
                    children: [
                      const Text(
                        "单         号:  ",
                        overflow: TextOverflow.ellipsis,
                        style:
                            TextStyle(fontSize: 15, color: Color(0xff999999)),
                      ),
                      Text(
                        map["formLevelId"] ?? "",
                        overflow: TextOverflow.ellipsis,
                        style: const TextStyle(
                            fontSize: 15, color: Color(0xff333333)),
                      ),
                    ],
                  )),
              Container(
                  margin: const EdgeInsets.only(
                      top: 20, left: 10, right: 20, bottom: 10),
                  child: Row(
                    children: [
                      const Text(
                        "处理结果:  ",
                        overflow: TextOverflow.ellipsis,
                        style:
                            TextStyle(fontSize: 15, color: Color(0xff999999)),
                      ),
                      Expanded(
                        child: Text(
                          map["currentHandleResult"] ?? "",
                          style: const TextStyle(
                            fontSize: 15,
                            color: Color(0xff333333),
                          ),
                        ),
                      ),
                    ],
                  ))
            ],
          ),
        ),
        onTap: () {
          setonTap(map["id"]);
        });
  }

  Widget getList1(bool isTop, String title, int time, String name, String id,
      bool isLink, String linkUrl) {
    return GestureDetector(
        child: Container(
            margin: const EdgeInsets.only(top: 10, left: 10, right: 10),
            decoration: BoxDecoration(
                //背景
                color: Colors.white,
                //设置四周圆角 角度
                borderRadius: const BorderRadius.all(Radius.circular(10.0)),
                //设置四周边框
                border: Border.all(width: 1, color: Colors.white)),
            child: Column(
              mainAxisAlignment: MainAxisAlignment.start,
              children: [
                Container(
                  alignment: Alignment.topLeft,
                  margin: const EdgeInsets.only(top: 20, left: 10, right: 10),
                  child: Text(
                    title,
                    overflow: TextOverflow.ellipsis,
                    style: const TextStyle(
                        fontSize: 15,
                        color: Color(0xff333333),
                        fontWeight: FontWeight.bold),
                  ),
                ),
                Container(
                    margin: const EdgeInsets.only(
                        top: 20, left: 10, right: 20, bottom: 10),
                    child: Row(
                      children: [
                        isTop
                            ?  Expanded(
                                flex: 1,
                                child: Text(
                                  "置顶",
                                  // ZyDateUtils.instance.getFormartData(
                                  //     timeSamp: time, format: "yyyy年MM月dd日 HH:mm:ss"),
                                  style: TextStyle(
                                      height: 1.3,
                                      fontSize: 13,
                                      color:Color(APIs.themeColors),
                                      // color: Color(0xff07905F),
                                      fontWeight: FontWeight.bold),
                                ))
                            : const Text(""),
                        Expanded(
                            flex: 3,
                            child: Text(name,
                                style: const TextStyle(
                                    height: 1.3,
                                    fontSize: 13,
                                    color: Color(0xff8e8e8e)),
                                textAlign: TextAlign.left)),
                        Expanded(
                            flex: 4,
                            child: Text(
                                time == null
                                    ? ""
                                    : TimeUtils.timestampToDateStr(time, true),
                                // ZyDateUtils.instance.getFormartData(
                                //     timeSamp: time, format: "yyyy年MM月dd日 HH:mm:ss"),
                                style: const TextStyle(
                                    height: 1.3,
                                    fontSize: 13,
                                    color: Color(0xff8e8e8e)),
                                textAlign: TextAlign.left)),
                        const Expanded(
                            flex: 2,
                            child: Text("查看详情",
                                style: TextStyle(
                                    height: 1.3,
                                    fontSize: 13,
                                    color: Color(0xff8e8e8e)),
                                textAlign: TextAlign.right))
                      ],
                    )),
              ],
            )),
        onTap: () async {
          if (isLink) {
            Global.openUrl(context, linkUrl, true);
          } else {
            // setonTap(id);
            Global.openUrl(context,
                "/h5View/detail?id=$id&token=${await Global.getData("token")}");
          }
          // setonTap(id);
        });
  }

  Widget getList2(Map map) {
    return GestureDetector(
        child: Container(
            margin: const EdgeInsets.only(top: 10, left: 10, right: 10),
            //边框设置
            decoration: BoxDecoration(
              //背景
              color: Colors.white,
              //设置四周圆角 角度
              borderRadius: const BorderRadius.all(Radius.circular(10.0)),
              //设置四周边框
              border: Border.all(width: 1, color: Colors.white),
            ),
            child: Column(
              // mainAxisAlignment: MainAxisAlignment.start,
              children: [
                Container(
                  margin: const EdgeInsets.only(top: 10, right: 10, left: 10),
                  child: Row(
                    mainAxisAlignment: MainAxisAlignment.spaceBetween,
                    children: [
                      Row(
                        children: [
                          ClipOval(
                              child: map["companyLogo"] == null ||
                                      map["companyLogo"] == ""
                                  ? Global.getImageNull()
                                  : Global.getImage(
                                      APIs.BaseUrl + map["companyLogo"])),
                          Container(
                            margin: const EdgeInsets.only(
                                bottom: 10, left: 10, top: 10),
                            child: Text(
                              map["companyName"].length > 9
                                  ? map["companyName"].substring(1, 9) + "..."
                                  : map["companyName"] ?? "",
                              overflow: TextOverflow.ellipsis,
                              style: const TextStyle(
                                  fontSize: 13, color: Color(0xff666666)),
                            ),
                          )
                        ],
                      ),
                      Text(
                        map["changeTime"] ?? "",
                        overflow: TextOverflow.ellipsis,
                        style: const TextStyle(
                            fontSize: 13, color: Color(0xff999999)),
                      )
                    ],
                  ),
                ),
                Container(
                  margin: const EdgeInsets.only(top: 1),
                  width: double.infinity,
                  height: 0.5,
                  color: const Color(0xffE5E5E5),
                ),
                Container(
                    margin: const EdgeInsets.only(top: 10, left: 10, right: 20),
                    child: Row(
                      mainAxisAlignment: MainAxisAlignment.spaceBetween,
                      children: [
                        Expanded(
                          child: Text(
                            map["name"] ?? "职业女装设计",
                            // overflow: TextOverflow.ellipsis,
                            style: const TextStyle(
                                fontSize: 15,
                                color: Color(0xff666666),
                                fontWeight: FontWeight.bold),
                          ),
                        ),
                      ],
                    )),
                Row(
                  mainAxisAlignment: MainAxisAlignment.spaceBetween,
                  // mainAxisAlignment: MainAxisAlignment.start,
                  children: [
                    Column(
                      children: [
                        Container(
                            margin: const EdgeInsets.only(top: 20, left: 10),
                            child: Row(
                              children: [
                                const Text(
                                  "设计费用(不含税):",
                                  // overflow: TextOverflow.ellipsis,
                                  style: TextStyle(
                                      fontSize: 15, color: Color(0xff999999)),
                                ),
                                Text(
                                  map["isFace"] == 1
                                      ? "  面议  "
                                      : "￥${map["price"].toString()}",
                                  // overflow: TextOverflow.ellipsis,
                                  style: const TextStyle(
                                      fontSize: 15, color: Color(0xffF93428)),
                                ),
                              ],
                            )),
                        Container(
                            margin: const EdgeInsets.only(top: 20, bottom: 10),
                            child: Row(
                              children: [
                                const Text(
                                  "截止时间 : ",
                                  // overflow: TextOverflow.ellipsis,
                                  style: TextStyle(
                                      fontSize: 15, color: Color(0xff999999)),
                                ),
                                Text(
                                  map["endTime"] ?? "",
                                  style: const TextStyle(
                                    fontSize: 15,
                                    color: Color(0xff333333),
                                  ),
                                ),
                              ],
                            )),
                      ],
                    ),
                    map["typeCode"] == "-1"
                        ? Image.asset(
                            "images/Invitation.png",
                            width: 50,
                            height: 50,
                          )
                        : Image.asset(
                            "images/adopt.png",
                            width: 50,
                            height: 50,
                          ),
                  ],
                ),
              ],
            )),
        onTap: () {
          if (APIs.typename == "企业用户") {
            setonTap(map["row_id"]);
          } else {
            setonTap(map["requirement_id"]);
          }
        });
  }

  //工厂-生产需求
  Widget getList4(Map map) {
    return GestureDetector(
        child: Container(
            margin: const EdgeInsets.only(top: 10, left: 10, right: 10),
            //边框设置
            decoration: BoxDecoration(
              //背景
              color: Colors.white,
              //设置四周圆角 角度
              borderRadius: const BorderRadius.all(Radius.circular(10.0)),
              //设置四周边框
              border: Border.all(width: 1, color: Colors.white),
            ),
            child: Column(
              // mainAxisAlignment: MainAxisAlignment.start,
              children: [
                Container(
                  margin: const EdgeInsets.only(top: 10, right: 10, left: 10),
                  child: Row(
                    mainAxisAlignment: MainAxisAlignment.spaceBetween,
                    children: [
                      Row(
                        children: [
                          ClipOval(
                              child: map["companyLogo"] == null ||
                                      map["companyLogo"] == ""
                                  ? Global.getImageNull()
                                  : Global.getImage(
                                      APIs.BaseUrl + map["companyLogo"])),
                          Container(
                            margin: const EdgeInsets.only(
                                bottom: 10, left: 10, top: 10),
                            child: Text(
                              map["companyName"].length > 9
                                  ? map["companyName"].substring(1, 9) + "..."
                                  : map["companyName"] ?? "",
                              overflow: TextOverflow.ellipsis,
                              style: const TextStyle(
                                  fontSize: 13, color: Color(0xff666666)),
                            ),
                          )
                        ],
                      ),
                      Text(
                        map["changeTime"] ?? "",
                        overflow: TextOverflow.ellipsis,
                        style: const TextStyle(
                            fontSize: 13, color: Color(0xff999999)),
                      )
                    ],
                  ),
                ),
                Container(
                  margin: const EdgeInsets.only(top: 1),
                  width: double.infinity,
                  height: 0.5,
                  color: const Color(0xffE5E5E5),
                ),
                Container(
                    margin: const EdgeInsets.only(top: 10, left: 10, right: 20),
                    child: Row(
                      mainAxisAlignment: MainAxisAlignment.spaceBetween,
                      children: [
                        Expanded(
                          child: Text(
                            map["name"] ?? "职业女装生产",
                            // overflow: TextOverflow.ellipsis,
                            style: const TextStyle(
                                fontSize: 15,
                                color: Color(0xff666666),
                                fontWeight: FontWeight.bold),
                          ),
                        ),
                      ],
                    )),
                Row(
                  mainAxisAlignment: MainAxisAlignment.spaceBetween,
                  // mainAxisAlignment: MainAxisAlignment.start,
                  children: [
                    Column(
                      children: [
                        Container(
                            margin: const EdgeInsets.only(top: 20, left: 10),
                            child: Row(
                              children: [
                                const Text(
                                  "期望交货时间:",
                                  // overflow: TextOverflow.ellipsis,
                                  style: TextStyle(
                                      fontSize: 15, color: Color(0xff999999)),
                                ),
                                Text(
                                  map["endTime"] ?? "",
                                  // overflow: TextOverflow.ellipsis,
                                  style: const TextStyle(
                                      fontSize: 15, color: Color(0xffF93428)),
                                ),
                              ],
                            )),
                        Container(
                            margin: const EdgeInsets.only(top: 20, bottom: 10),
                            child: Row(
                              children: [
                                const Text(
                                  "生产费用(不含税):",
                                  // overflow: TextOverflow.ellipsis,
                                  style: TextStyle(
                                      fontSize: 15, color: Color(0xff999999)),
                                ),
                                Text(
                                  map["isFace"] == 1
                                      ? "  面议  "
                                      : "￥${map["price"].toString()}",
                                  style: const TextStyle(
                                    fontSize: 15,
                                    color: Color(0xff333333),
                                  ),
                                ),
                              ],
                            )),
                        Container(
                            margin: const EdgeInsets.only(top: 20, bottom: 10),
                            child: Row(
                              children: [
                                const Text(
                                  "生 产 数 量 : ",
                                  // overflow: TextOverflow.ellipsis,
                                  style: TextStyle(
                                      fontSize: 15, color: Color(0xff999999)),
                                ),
                                Text(
                                  map["amount"].toString() ?? "",
                                  style: const TextStyle(
                                    fontSize: 15,
                                    color: Color(0xff333333),
                                  ),
                                ),
                              ],
                            )),
                      ],
                    ),
                    map["typeCode"] == "-1"
                        ? Image.asset(
                            "images/Invitation.png",
                            width: 50,
                            height: 50,
                          )
                        : Image.asset(
                            "images/adopt.png",
                            width: 50,
                            height: 50,
                          ),
                  ],
                ),
              ],
            )),
        onTap: () {
          if (APIs.typename == "企业用户") {
            setonTap(map["row_id"]);
          } else {
            setonTap(map["requirement_id"]);
          }
        });
  }

  Widget getList3(Map map) {
    return GestureDetector(
        child: Container(
            margin: const EdgeInsets.only(top: 10, left: 10, right: 10),
            //边框设置
            decoration: BoxDecoration(
              //背景
              color: Colors.white,
              //设置四周圆角 角度
              borderRadius: const BorderRadius.all(Radius.circular(10.0)),
              //设置四周边框
              border: Border.all(width: 1, color: Colors.white),
            ),
            child: Column(
              // mainAxisAlignment: MainAxisAlignment.start,
              children: [
                Container(
                  margin: const EdgeInsets.only(
                      top: 10, left: 10, right: 10, bottom: 10),
                  child: Row(
                    mainAxisAlignment: MainAxisAlignment.spaceBetween,
                    children: [
                      Text(
                        map["code"] ?? "",
                        overflow: TextOverflow.ellipsis,
                        style: const TextStyle(
                            fontSize: 13, color: Color(0xff666666)),
                      ),
                      Text(
                        map["changeTime"] ?? "",
                        overflow: TextOverflow.ellipsis,
                        style: const TextStyle(
                            fontSize: 13, color: Color(0xff999999)),
                      )
                    ],
                  ),
                ),

                Container(
                  margin: const EdgeInsets.only(top: 1),
                  width: double.infinity,
                  height: 0.5,
                  color: const Color(0xffE5E5E5),
                ),
                Container(
                    margin: const EdgeInsets.only(top: 10, left: 10, right: 20),
                    child: Row(
                      mainAxisAlignment: MainAxisAlignment.spaceBetween,
                      children: [
                        Text(
                          // map["company_name"],
                          map["title"],
                          overflow: TextOverflow.ellipsis,
                          style: const TextStyle(
                              fontSize: 15,
                              color: Color(0xff666666),
                              fontWeight: FontWeight.bold),
                        ),
                        map["canAbutmentName"] != null &&
                                map["canAbutmentName"] == "已截止"
                            ? Text(map["canAbutmentName"] ?? "没返回数据",
                                style: const TextStyle(
                                    fontSize: 13, color: Color(0xff666666)))
                            : Text(map["canAbutmentName"] ?? "没返回数据",
                                style: const TextStyle(
                                    fontSize: 13, color: Color(0xFF067DEB))),
                      ],
                    )),

                Container(
                    margin: const EdgeInsets.only(top: 20, left: 10, right: 20),
                    child: Row(
                      children: [
                        const Text(
                          "发布时间:",
                          // overflow: TextOverflow.ellipsis,
                          style:
                              TextStyle(fontSize: 15, color: Color(0xff999999)),
                        ),
                        Text(
                          map["changeTime"] ?? "",
                          style: const TextStyle(
                            fontSize: 15,
                            color: Color(0xff333333),
                          ),
                        ),
                      ],
                    )),
                Container(
                    margin: const EdgeInsets.only(top: 20, left: 10, right: 20),
                    child: Row(
                      children: [
                        const Text(
                          "设计费用(不含税):",
                          // overflow: TextOverflow.ellipsis,
                          style:
                              TextStyle(fontSize: 15, color: Color(0xff999999)),
                        ),
                        Text(
                          map["isFace"] == 1
                              ? "  面议  "
                              : "￥${map["price"].toString()}",
                          // overflow: TextOverflow.ellipsis,
                          style: const TextStyle(
                              fontSize: 15, color: Color(0xffF93428)),
                        ),
                      ],
                    )),
                Container(
                    margin: const EdgeInsets.only(
                        top: 20, right: 20, left: 10, bottom: 10),
                    child: Row(
                      children: [
                        const Text(
                          "截止时间 : ",
                          // overflow: TextOverflow.ellipsis,
                          style:
                              TextStyle(fontSize: 15, color: Color(0xff999999)),
                        ),
                        Text(
                          map["endTime"] ?? "",
                          style: const TextStyle(
                            fontSize: 15,
                            color: Color(0xff333333),
                          ),
                        ),
                      ],
                    )),
                // Container(
                //   margin: const EdgeInsets.only(top: 10),
                //   width: double.infinity,
                //   height: 0.5,
                //   color: const Color(0xffE5E5E5),
                // ),
                // GestureDetector(
                //   child:Container(
                //       margin: const EdgeInsets.only(top: 5, left: 10, right: 10,bottom: 10),
                //       child: Row(
                //         mainAxisAlignment: MainAxisAlignment.spaceBetween,
                //         children:[
                //           Text(APIs.typename=="企业"?
                //           "对接设计师:":"对接厂商",
                //             overflow: TextOverflow.ellipsis,
                //             style: const TextStyle(fontSize: 15, color: Color(0xff333333)),
                //           ),
                //           const Icon(Icons.arrow_forward_ios,color: Color(0xff333333),size: 15),
                //         ],
                //       )) ,
                //   onTap: (){
                //
                //   },
                // ),
              ],
            )),
        onTap: () {
          setonTap(map["row_id"]);
        });
  }

  //企业——生产需求
  Widget getList5(Map map) {
    return GestureDetector(
        child: Container(
            margin: const EdgeInsets.only(top: 10, left: 10, right: 10),
            //边框设置
            decoration: BoxDecoration(
              //背景
              color: Colors.white,
              //设置四周圆角 角度
              borderRadius: const BorderRadius.all(Radius.circular(10.0)),
              //设置四周边框
              border: Border.all(width: 1, color: Colors.white),
            ),
            child: Column(
              // mainAxisAlignment: MainAxisAlignment.start,
              children: [
                Container(
                  margin: const EdgeInsets.only(
                      top: 10, left: 10, right: 10, bottom: 10),
                  child: Row(
                    mainAxisAlignment: MainAxisAlignment.spaceBetween,
                    children: [
                      Text(
                        map["code"] ?? "",
                        overflow: TextOverflow.ellipsis,
                        style: const TextStyle(
                            fontSize: 13, color: Color(0xff666666)),
                      ),
                      Text(
                        map["changeTime"] ?? "",
                        overflow: TextOverflow.ellipsis,
                        style: const TextStyle(
                            fontSize: 13, color: Color(0xff999999)),
                      )
                    ],
                  ),
                ),
                Container(
                  margin: const EdgeInsets.only(top: 1),
                  width: double.infinity,
                  height: 0.5,
                  color: const Color(0xffE5E5E5),
                ),
                Container(
                    margin: const EdgeInsets.only(top: 10, left: 10, right: 20),
                    child: Row(
                      mainAxisAlignment: MainAxisAlignment.spaceBetween,
                      children: [
                        Text(
                          map["title"] ?? "",
                          overflow: TextOverflow.ellipsis,
                          style: const TextStyle(
                              fontSize: 15,
                              color: Color(0xff666666),
                              fontWeight: FontWeight.bold),
                        ),
                        map["canAbutmentName"] != null &&
                                map["canAbutmentName"] == "已截止"
                            ? Text(map["canAbutmentName"] ?? "没返回数据",
                                style: const TextStyle(
                                    fontSize: 13, color: Color(0xff666666)))
                            : Text(map["canAbutmentName"] ?? "没返回数据",
                                style: const TextStyle(
                                    fontSize: 13, color: Color(0xFF067DEB))),
                      ],
                    )),
                Container(
                    margin: const EdgeInsets.only(top: 20, left: 10, right: 20),
                    child: Row(
                      children: [
                        const Text(
                          "发布时间:",
                          // overflow: TextOverflow.ellipsis,
                          style:
                              TextStyle(fontSize: 15, color: Color(0xff999999)),
                        ),
                        Text(
                          map["applyTime"] ?? "",
                          style: const TextStyle(
                            fontSize: 15,
                            color: Color(0xff333333),
                          ),
                        ),
                      ],
                    )),
                Container(
                    margin: const EdgeInsets.only(top: 20, left: 10, right: 20),
                    child: Row(
                      children: [
                        const Text(
                          "产品类型：",
                          // overflow: TextOverflow.ellipsis,
                          style:
                              TextStyle(fontSize: 15, color: Color(0xff999999)),
                        ),
                        Text(
                          map["type_name"] ?? "",
                          // overflow: TextOverflow.ellipsis,
                          style: const TextStyle(
                              fontSize: 15, color: Color(0xff999999)),
                        ),
                      ],
                    )),
                Container(
                    margin: const EdgeInsets.only(top: 20, right: 20, left: 10),
                    child: Row(
                      children: [
                        const Text(
                          "期望交货时间: ",
                          // overflow: TextOverflow.ellipsis,
                          style:
                              TextStyle(fontSize: 15, color: Color(0xff999999)),
                        ),
                        Text(
                          map["endTime"] ?? "",
                          style: const TextStyle(
                            fontSize: 15,
                            color: Color(0xff333333),
                          ),
                        ),
                      ],
                    )),
                Container(
                    margin: const EdgeInsets.only(
                        top: 20, left: 10, right: 20, bottom: 10),
                    child: Row(
                      children: [
                        const Text(
                          "生产费用(不含税):",
                          overflow: TextOverflow.ellipsis,
                          style:
                              TextStyle(fontSize: 15, color: Color(0xff999999)),
                        ),
                        Text(map["isFace"] == 1
                            ? "  面议  "
                            : "￥${map["amount"]}/件x ${map["price"]}")
                      ],
                    )),
              ],
            )),
        onTap: () {
          setonTap(map["row_id"]);
        });
  }

  void _onRefresh() async {
    fwspMap.clear();
    datamap.clear();
    sjxqmap.clear();
    scxqmap.clear();
    noticeBirthday = "";
    //下拉刷新获取网络数据;
    if (tabClickIndex == 1) {
      //通知公告
      tzggPageNo = 1;
    } else if (tabClickIndex == 2 || tabClickIndex == 3) {
      //所有需求
      syxqPageNo = 1;
    } else {
      //服务审批
      fwspPageNo = 1;
    }
    onTapBar(tabClickIndex, "");
    isLoading = true;
  }

  void _onLoading() async {
    if (tabClickIndex == 1) {
      // if (tzggPageNo < datamap["totalPage"]) {
        //通知公告
        tzggPageNo++;
        onTapBar(tabClickIndex, "");
        refreshController.isRefresh;
      // }
    } else if (tabClickIndex == 2 || tabClickIndex == 3) {
      // if (syxqPageNo < sjxqmap["totalPage"]) {
        //所有需求
        syxqPageNo++;
        onTapBar(tabClickIndex, "");
        refreshController.isRefresh;
        // refreshController.loadComplete();
      // } else {
      //   Toasts.showToast("暂无更多数据");
      // }
    }  else {
      // if (fwspPageNo < fwspMap["totalPage"]) {
        fwspPageNo++;
        onTapBar(tabClickIndex, "");
        refreshController.isRefresh;
        // refreshController.loadComplete();
      // } else {
      //   Toasts.showToast("暂无更多数据");
      //   refreshController.resetNoData();
      // }
      //服务审批
      // fwspPageNo++;
    }
  }
}
