import 'dart:collection';
import 'dart:convert';

import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:flutter_html/flutter_html.dart';
import 'package:pull_to_refresh/pull_to_refresh.dart';

import '../dio/APIs.dart';
import '../dio/HttpUtils.dart';
import '../utils/Global.dart';
import 'dart:convert' as convert;

import '../utils/TimeUtils.dart';
import '../widget/Toast.dart';

class ProduceDetail extends StatefulWidget {
  const ProduceDetail(this.id, this.type, {super.key});

  final String id;
  final String type;

  @override
  State<StatefulWidget> createState() {
    return ProduceDetailState(id, type);
  }
}

// //工厂：工厂需求详情
class ProduceDetailState extends State with TickerProviderStateMixin {
  bool isLoading = false;

  bool isRefresh = false;

  Map dataMap = HashMap();

  final String id;
  final String type;
  List<dynamic> list = [];

  ProduceDetailState(this.id, this.type);

  var scrSize ;
  @override
  void initState() {
    super.initState();
    getSqlData(id);
    setDjListSqlData(id);
  }

  //获取详情
  getSqlData(String requirementRowId) async {
    Map jsParam = {"requirementRowId": requirementRowId};
    var str = convert.jsonEncode(jsParam);
    HttpUtils.postJSON(context, APIs.getSqlData, {
      "sqlKey": "IOtnRrONhZc",
      "allValues": str,
      "token": await Global.getData("token"),
    }, success: (data) async {
      setState(() {
        isRefresh = true;
        dataMap = data[0];
      });
    }, fail: (code, msg) {});
  }

  //对接设计师进度接口
  setDjListSqlData(String requirementRowId) async {
    Map jsParam = {"requirementRowId": requirementRowId};
    var str = convert.jsonEncode(jsParam);
    HttpUtils.postJSON(context, APIs.getSqlData, {
      "sqlKey": "IWIQfzuCFgw",
      "allValues": str,
      "token": await Global.getData("token"),
    }, success: (data) async {
      setState(() {
        isLoading = true;
        list = json.decode(data[0]["progress"]);
        // print("object"+list[0].toString());
      });
    }, fail: (code, msg) {});
  }

  //对接接口
  setDjSqlData(String requirementRowId) async {
    Map jsParam = {"requirementRowId": requirementRowId};
    var str = convert.jsonEncode(jsParam);
    HttpUtils.postJSON(context, APIs.getSqlData, {
      "sqlKey": "IOvZPKNCODE",
      "allValues": str,
      "token": await Global.getData("token"),
    }, success: (data) async {
      setState(() {
        if (data[0]["code"] == "200") {
          showDialog(
            context: context,
            builder: (context) {
              return AlertDialog(
                title: const Text('操作成功'),
                content: const Text('当前需求已对接，请到web端的个人中心查看相关信息'),
                actions: [

                  ElevatedButton(
                      child: const Text("知道了"),
                      onPressed: () async {

                        Navigator.of(context).pop();// 关闭对话框

                        Navigator.pop(context);
                        //弹出对话框并等待其关闭
                        // bool? delete = await showDeleteConfirmDialog1();
                        // if (delete == null) {
                        //   print("取消删除");
                        // } else {
                        //   print("已确认删除");
                        //... 删除文件
                        // }
                      }
                  ),
                ],
              );
            },
          );
          // Toasts.showToast(data[0]["prompt"]);


          // Toasts.showToast("当前需求已对接，请到web端的个人中心查看相关信息");
        }
      });
    }, fail: (code, msg) {});
  }

  Future<bool?> showDeleteConfirmDialog1() {
    return showDialog<bool>(
        context: context,
        builder: (context) {
          return AlertDialog(
              title: const Text("提示"),
              content: const Text("您确定要删除当前文件吗?"),
              actions: <Widget>[
                TextButton(
                  child: const Text("取消"),
                  onPressed: () => Navigator.of(context).pop(), // 关闭对话框
                ),
                TextButton(
                    child: const Text("删除"),
                    onPressed: () {
                      //关闭对话框并返回true
                      Navigator.of(context).pop(true);
                    }
                )
              ]
          );
        }
    );
  }
  @override
  Widget build(BuildContext context) {

    scrSize = MediaQuery.of(context).size;
    return Scaffold(
      // backgroundColor: Colors.white,
        appBar: AppBar(
          title: const Text(
            "生产需求",
            style: TextStyle(color: Colors.black),
          ),
          backgroundColor: Colors.white,
          elevation: 0,
          leading: IconButton(
            icon: const Icon(
              Icons.arrow_back,
              color: Colors.black,
            ),
            onPressed: () {
              Navigator.pop(context);
            },
          ),
        ),
        body: isRefresh&&isLoading
            ? CustomScrollView(
          slivers: [
            SliverToBoxAdapter(
                child: Container(
                  padding: const EdgeInsets.only(top: 10),
                  width: double.infinity,
                  height: 10,
                  // color: const Color(0xffE5E5E5),
                )),
            //显示顶部
            topWidget(),
            //是订单进度
            designProgressInfoWidget(),
            imaegWidget(dataMap.isNotEmpty?APIs.BaseUrl+jsonDecode(dataMap["picture"])["files"][0]["path"]:""),
            //datamap["picture"]
            baseInfoWidget(),
            designInfoWidget(),
            contactsInfoWidget(),
            SliverToBoxAdapter(child: paddingLine()),
            contactsJointButtonWidget(),
            // baseInfoWidget(),
            // designInfoWidget(),
            // contactsInfoWidget(),
            // SliverToBoxAdapter(child: paddingLine()),
            // contactsJointButtonWidget(),
          ],
        )
            : Global.add());
  }

  Widget paddingLine() {
    return Container(
      margin: const EdgeInsets.only(top: 20),
      padding: const EdgeInsets.only(top: 10),
      width: double.infinity,
      height: 10,
      // color: const Color(0xffE5E5E5),
    );
  }

  //顶部信息
  Widget topWidget() {
    return SliverToBoxAdapter(
        child: Container(
            margin: const EdgeInsets.only(top: 20, left: 10, right: 10),
            //边框设置
            decoration: BoxDecoration(
              //背景
              color: Colors.white,
              //设置四周圆角 角度
              borderRadius: const BorderRadius.all(Radius.circular(10.0)),
              //设置四周边框
              border: Border.all(width: 1, color: Colors.white),
            ),
            child: Column(
              mainAxisAlignment: MainAxisAlignment.start,
              children: [
                Container(
                  margin: const EdgeInsets.only(top: 20, left: 10, right: 10),
                  child: Row(
                    mainAxisAlignment: MainAxisAlignment.spaceBetween,
                    children: [
                      Row(
                        children: [
                          ClipOval(
                              child: dataMap["avatar"] == null ||
                                  dataMap["avatar"] == ""
                                  ? Global.getImageNull()
                                  : Global.getImage(
                                  json.decode(dataMap["avatar"])["url"])),
                          // Image.asset("images/logo.png", width: 50,height: 50),
                          Container(
                              margin: const EdgeInsets.only(left: 10),
                              //map["companyName"].length>9 ?map["companyName"].substring(1, 9) + "...":map["companyName"]?? ""
                              child: Text(
                                dataMap["publisherName"].length > 9
                                    ? dataMap["publisherName"].substring(1, 9) +
                                    "..."
                                    : dataMap["publisherName"] ?? "",
                                overflow: TextOverflow.ellipsis,
                                style: const TextStyle(
                                    fontSize: 13, color: Color(0xff666666)),
                              )),
                        ],
                      ),
                      dataMap["publisherTime"] == null
                          ? const Text(
                        "发布日期 : ",
                      )
                          : Text(
                          "发布日期 : ${TimeUtils.timestampToDateStr(dataMap["publisherTime"], true)}",
                          overflow: TextOverflow.ellipsis,
                          style: const TextStyle(
                              fontSize: 13, color: Color(0xff999999)))
                    ],
                  ),
                ),
                Container(
                    margin: const EdgeInsets.only(top: 10, left: 10, right: 20),
                    child: Row(
                      children: [
                        Expanded(
                          child: Text(
                            dataMap["title"] ?? "",
                            style: const TextStyle(
                                fontSize: 15,
                                color: Color(0xff666666),
                                fontWeight: FontWeight.bold),
                          ),
                        )
                      ],
                    )),
                Container(
                    margin: const EdgeInsets.only(top: 20, left: 10, right: 20),
                    child: Row(
                      children: [
                        const Text(
                          "产品类型:",
                          overflow: TextOverflow.ellipsis,
                          style:
                          TextStyle(fontSize: 15, color: Color(0xff999999)),
                        ),
                        Text(
                          dataMap["typeName"] ?? "",
                          style: const TextStyle(
                            fontSize: 15,
                            color: Color(0xff333333),
                          ),
                        ),
                      ],
                    )),
                Container(
                    margin: const EdgeInsets.only(
                      top: 20,
                      left: 10,
                      right: 20,
                    ),
                    child: Row(
                      children: [
                        const Text(
                          "期望交货时间:",
                          overflow: TextOverflow.ellipsis,
                          style:
                          TextStyle(fontSize: 15, color: Color(0xff999999)),
                        ),
                        dataMap["want_date"] == null
                            ? const Text(" ")
                            : Text(
                          TimeUtils.timestampToDateStr(
                              dataMap["want_date"], true),
                          // Text(
                          //   "2023-10-10",
                          style: const TextStyle(
                            fontSize: 15,
                            color: Color(0xff333333),
                          ),
                        ),
                      ],
                    )),
                Container(
                    margin: const EdgeInsets.only(top: 20, left: 10, right: 20),
                    child: Row(
                      children: [
                        const Text(
                          "生产费用(不含税):",
                          overflow: TextOverflow.ellipsis,
                          style:
                          TextStyle(fontSize: 15, color: Color(0xff999999)),
                        ),
                        dataMap["amount"] == null
                            ? const Text(
                          "￥0/件",
                          overflow: TextOverflow.ellipsis,
                          style: TextStyle(
                              fontSize: 15, color: Color(0xffF93428)),
                        )
                            : Text(
                          "￥${dataMap["amount"]}/件",
                          overflow: TextOverflow.ellipsis,
                          style: const TextStyle(
                              fontSize: 15, color: Color(0xffF93428)),
                        ),
                        dataMap["product_price"] == null
                            ? const Text(
                          "x ",
                          overflow: TextOverflow.ellipsis,
                          style: TextStyle(
                              fontSize: 15, color: Color(0xff333333)),
                        )
                            : Text(
                          "x ${dataMap["product_price"]}",
                          overflow: TextOverflow.ellipsis,
                          style: const TextStyle(
                              fontSize: 15, color: Color(0xff333333)),
                        ),
                      ],
                    )),
              ],
            )));
  }

  Widget designerChildWidget(String url, String state, String name) {
    return Container(
      margin: const EdgeInsets.only(left: 10, right: 10, top: 10),
      child: Column(
        children: [
          Stack(alignment: Alignment.bottomCenter, children: [
            CircleAvatar(
              radius: scrSize.width / 12,
              backgroundColor: Colors.grey,
              backgroundImage: NetworkImage(url),
            ),
            Container(
              padding: const EdgeInsets.all(5),
              //边框设置
              decoration: BoxDecoration(
                //背景
                color: state.contains("采纳")
                    ? Colors.deepOrangeAccent
                    : Colors.blue,
                //设置四周圆角 角度
                borderRadius: const BorderRadius.all(Radius.circular(18.0)),
                //设置四周边框
                border: Border.all(
                    width: 1,
                    color: state.contains("采纳")
                        ? Colors.deepOrangeAccent
                        : Colors.blue),
              ),
              child: Text(
                state,
                style: const TextStyle(fontSize: 15, color: Color(0xffffffff)),
              ),
            )
          ]),
          Padding(
            padding: const EdgeInsets.only(top: 10, bottom: 10),
            child: Text(
              name,
              style: const TextStyle(fontSize: 15, color: Color(0xff222222)),
            ),
          )
        ],
      ),
    );
  }

  //产品图片
  Widget imaegWidget(String path) {
    return SliverToBoxAdapter(
      child: Container(
        margin: const EdgeInsets.only(top: 10, left: 10, right: 10),
        //边框设置
        decoration: BoxDecoration(
          //背景
          color: Colors.white,
          //设置四周圆角 角度
          borderRadius: const BorderRadius.all(Radius.circular(10.0)),
          //设置四周边框
          border: Border.all(width: 1, color: Colors.white),
        ),
        child: Column(
          children: [
            Container(
              alignment: Alignment.topLeft,
              margin: const EdgeInsets.only(top: 10),
              child: Row(
                children: [
                  Container(
                    width: 3,
                    height: 15,
                    color: const Color(0xff00946B),
                  ),
                  const Text(
                    " 产品图片",
                    style: TextStyle(
                        color: Color(0xff222222),
                        fontSize: 15,
                        fontWeight: FontWeight.bold),
                  ),
                ],
              ),
            ),
            Container(
              padding: const EdgeInsets.only(right: 5, top: 10, bottom: 10),
              child: Image.network(
                path,
                // width: Global.getScale(context) * 120,
                // height: Global.getScale(context) * 80,
                fit: BoxFit.cover,
              ),
            )
          ],
        ),
      ),
    );
  }
  //基础信息
  Widget baseInfoWidget() {
    return SliverToBoxAdapter(
        child: Container(
            margin: const EdgeInsets.only(top: 10, left: 10, right: 10),
            //边框设置
            decoration: BoxDecoration(
              //背景
              color: Colors.white,
              //设置四周圆角 角度
              borderRadius: const BorderRadius.all(Radius.circular(10.0)),
              //设置四周边框
              border: Border.all(width: 1, color: Colors.white),
            ),
            child: Column(
              children: [
                Container(
                  alignment: Alignment.topLeft,
                  margin: const EdgeInsets.only(top: 20),
                  child: Row(
                    children: [
                      Container(
                        margin: const EdgeInsets.only(right: 10),
                        width: 3,
                        height: 15,
                        color: const Color(0xff00946B),
                      ),
                      const Text(
                        "基础信息",
                        style: TextStyle(
                            color: Color(0xff222222),
                            fontSize: 15,
                            fontWeight: FontWeight.bold),
                      ),
                    ],
                  ),
                ),
                baseInfoChildWidget("套件/单件", dataMap["set_piece"] ?? ""),
                baseInfoChildWidget("款式类型", dataMap["style_type"] ?? ""),
                baseInfoChildWidget("性别", dataMap["gender"] ?? ""),
                baseInfoChildWidget("上装/下装", dataMap["top_bottom"] ?? ""),
                baseInfoChildWidget("款式", dataMap["short_long"] ?? ""),
                baseInfoChildWidget("季节", dataMap["season"] ?? ""),
                baseInfoChildWidget("年份", dataMap["year"] ?? ""),
                baseInfoChildWidget("使用环境", dataMap["environment"] ?? ""),
              ],
            )));
  }

  Widget baseInfoChildWidget(String name, String value) {
    return Container(
        margin: const EdgeInsets.only(top: 20, left: 10, right: 20),
        child: Row(
          children: [
            SizedBox(
              width: 100,
              child: Text(
                name,
                overflow: TextOverflow.ellipsis,
                style: const TextStyle(fontSize: 15, color: Color(0xff999999)),
              ),
            ),
            Text(
              value,
              overflow: TextOverflow.ellipsis,
              style: const TextStyle(fontSize: 15, color: Color(0xff222222)),
            ),
          ],
        ));
  }

  //设计进度
  Widget designProgressInfoWidget() {
    return SliverToBoxAdapter(
      child: Container(
        margin: const EdgeInsets.only(top: 10, left: 10, right: 10),
        //边框设置
        decoration: BoxDecoration(
          //背景
          color: Colors.white,
          //设置四周圆角 角度
          borderRadius: const BorderRadius.all(Radius.circular(10.0)),
          //设置四周边框
          border: Border.all(width: 1, color: Colors.white),
        ),
        child: Column(
          children: [
            Container(
              alignment: Alignment.topLeft,
              margin: const EdgeInsets.only(top: 10, left: 5),
              child: Row(
                children: [
                  Container(
                    width: 3,
                    height: 15,
                    color: const Color(0xff00946B),
                  ),
                  const Text(
                    "  生产进度",
                    style: TextStyle(
                        color: Color(0xff222222),
                        fontSize: 15,
                        fontWeight: FontWeight.bold),
                  ),
                ],
              ),
            ),
            Row(
              // crossAxisAlignment: CrossAxisAlignment.center,
              mainAxisAlignment: MainAxisAlignment.spaceBetween,
              children: progressInfoChildWidget(),
            )
          ],
        ),
      ),
    );
  }

  List<Widget> progressInfoChildWidget() {
    List<Widget> listWidget = [];
    for (int i = 0; i < list.length; i++) {
      if (i == 0) {
        listWidget.add(designProgressInfoChildWidget(
            true, false, list[i]["n"], list[i]["t"] ?? ""));
      } else if (i < list.length - 1) {
        listWidget.add(designProgressInfoChildWidget(
            false, false, list[i]["n"], list[i]["t"] ?? ""));
      } else {
        listWidget.add(designProgressInfoChildWidget(
            false, true, list[i]["n"], list[i]["t"] ?? ""));
      }
    }
    return listWidget;
  }

  //设计进度子widget
  Widget designProgressInfoChildWidget(
      bool isVisibleLeft, bool isVisibleRight, String name, String time) {
    // formatDate(DateTime.now(),[yyyy,'年',mm,'月',dd])
    return Container(
      padding: const EdgeInsets.only(top: 20, bottom: 10),
      child: Column(
        children: [
          Row(
            children: [
              Opacity(
                  opacity: isVisibleLeft ? 0 : 1,
                  child: Container(
                    height: 1,
                    width: scrSize.width/list.length-13-(scrSize.width/list.length)/2,
                    color: const Color(0xff07905F),
                  )),
              Container(
                margin: const EdgeInsets.only(right: 10),
                child: const SizedBox(
                  width: 10,
                  height: 10,
                  child: CircleAvatar(
                    radius: 15,
                    backgroundColor: Color(0xff07905F),
                  ),
                ),
              ),
              Opacity(
                opacity: isVisibleRight ? 0 : 1,
                child: Container(
                  height: 1,
                  width: scrSize.width/list.length-13-(scrSize.width/list.length)/2,
                  color: const Color(0xff07905F),
                ),
              ),
            ],
          ),
          Container(
              margin: const EdgeInsets.only(top: 5, bottom: 5),
              child: Text(
                name,
                style: const TextStyle(fontSize: 10),
              )),
          Text(
            time,
            style: const TextStyle(fontSize: 10, color: Color(0xff000000)),
          ),
        ],
      ),
    );
  }

  //设计详情
  Widget designInfoWidget() {
    return SliverToBoxAdapter(
        child: Container(
            margin: const EdgeInsets.only(top: 10, left: 10, right: 10),
            //边框设置
            decoration: BoxDecoration(
              //背景
              color: Colors.white,
              //设置四周圆角 角度
              borderRadius: const BorderRadius.all(Radius.circular(10.0)),
              //设置四周边框
              border: Border.all(width: 1, color: Colors.white),
            ),
            child: Column(
              children: [
                Container(
                  alignment: Alignment.topLeft,
                  margin: const EdgeInsets.only(top: 20),
                  child: Row(
                    children: [
                      Container(
                        margin: const EdgeInsets.only(right: 10),
                        width: 3,
                        height: 15,
                        color: const Color(0xff00946B),
                      ),
                      const Text(
                        "生产详情",
                        style: TextStyle(
                            color: Color(0xff222222),
                            fontSize: 15,
                            fontWeight: FontWeight.bold),
                      ),
                    ],
                  ),
                ),
                Container(
                    margin: const EdgeInsets.only(top: 20, left: 10, right: 20),
                    child: Html(data: dataMap["content"] ?? ""))
              ],
            )));
  }

  //联系人信息
  Widget contactsInfoWidget() {
    return SliverToBoxAdapter(
        child: Container(
            margin: const EdgeInsets.only(top: 10, left: 10, right: 10),
            //边框设置
            decoration: BoxDecoration(
              //背景
              color: Colors.white,
              //设置四周圆角 角度
              borderRadius: const BorderRadius.all(Radius.circular(10.0)),
              //设置四周边框
              border: Border.all(width: 1, color: Colors.white),
            ),
            child: Column(
              children: [
                Container(
                  alignment: Alignment.topLeft,
                  margin: const EdgeInsets.only(top: 20),
                  child: Row(
                    children: [
                      Container(
                        margin: const EdgeInsets.only(right: 10),
                        width: 3,
                        height: 15,
                        color: const Color(0xff00946B),
                      ),
                      const Text(
                        "联系人信息",
                        style: TextStyle(
                            color: Color(0xff222222),
                            fontSize: 15,
                            fontWeight: FontWeight.bold),
                      ),
                    ],
                  ),
                ),
                baseInfoChildWidget("联系人", dataMap["contacts"] ?? ""),
                baseInfoChildWidget("固定电话", dataMap["phone"] ?? ""),
                baseInfoChildWidget("E-mail", dataMap["email"] ?? ""),
                baseInfoChildWidget("QQ", dataMap["qq"] ?? ""),
              ],
            )));
  }

  //对接按钮
  Widget contactsJointButtonWidget() {
    return SliverToBoxAdapter(
        child:
        Container(
            color: const Color(0xffE5E5E5),
            padding: const EdgeInsets.only(
                top: 10, bottom: 20, left: 10, right: 10),
            child: TextButton(
              onPressed: () {
                setDjSqlData(id);

              },
              style: ButtonStyle(
                //设置字体颜色
                foregroundColor: MaterialStateProperty.resolveWith((states) {
                  //按下按钮时的字体颜色
                  if (states.contains(MaterialState.pressed)) {
                    return Colors.white;
                  }
                  //默认不使用字体颜色
                  return Colors.white;
                }),
                //背景颜色
                backgroundColor:
                MaterialStateProperty.all(const Color(0xff00946B)),
                //水波纹颜色 不想使用 设置透明即可
                overlayColor: MaterialStateProperty.all(Colors.transparent),
                //设置边框
                side: MaterialStateProperty.all(
                    const BorderSide(color: Colors.white)),
                //设置形状、圆角
                shape: MaterialStateProperty.all(const StadiumBorder()),
              ),
              child: const Text("立即对接"),
            ))
      // : const Text(""),
    );
  }
}






