import 'dart:collection';
import 'dart:convert';

import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:flutter_html/flutter_html.dart';
import 'package:pull_to_refresh/pull_to_refresh.dart';

import '../dio/APIs.dart';
import '../dio/HttpUtils.dart';
import '../utils/Global.dart';
import 'dart:convert' as convert;

import 'ButtFactory.dart';

class ProduceDetailQy extends StatefulWidget {


  const ProduceDetailQy(this.id, this.type);

  final String id;
  final String type;

  @override
  State<StatefulWidget> createState() {
    return ProduceDetailState(id, type);
  }
}

//企业：工厂需求详情
class ProduceDetailState extends State with TickerProviderStateMixin {
  bool isloading = false;

  List<int> listint = [0x40FFBE34, 0x403BBD67, 0x406B66FF, 0x401278C0];

  bool isRefresh = false;
  RefreshController refreshController = RefreshController();

  int pageNo = 1;
  int pageSize = 15;

  Map datamap = HashMap();
  int tabClickIndex = 0;

  final String id;
  final String type;

  ProduceDetailState(this.id, this.type);

  List<Map> list = [];

  List<dynamic> listmanufacturer = [];

  var scrSize ;
  @override
  void initState() {
    super.initState();
    getSqlData(id);
    getSjsDetail(id);
  }

  //获取详情
  getSqlData(String requirementRowId) async {
    Map jsParam = {
      "requirementRowId": requirementRowId,
      "random": "0.3045814815019656"
    };
    var str = convert.jsonEncode(jsParam);
    HttpUtils.postJSON(context, APIs.getSqlData, {
      "sqlKey": "IOtnRrONhZc",
      "allValues": str,
      "token": await Global.getData("token"),
    }, success: (data) async {
      setState(() {
        isRefresh = true;
        datamap = data[0];
      });
    }, fail: (code, msg) {});
  }

  //获取对接厂商
  getSjsDetail(String requirementRowId) async {
    Map jsParam = {"requirementRowId": requirementRowId};
    var str = convert.jsonEncode(jsParam);
    HttpUtils.postJSON(context, APIs.getSqlData, {
      "sqlKey": "IVjpDzKzNdM",
      "allValues": str,
      "token": await Global.getData("token"),
    }, success: (data) async {
      setState(() {
        isRefresh = true;
        listmanufacturer = data;
      });
    }, fail: (code, msg) {});
  }

  @override
  Widget build(BuildContext context) {

    scrSize = MediaQuery.of(context).size;
    return Scaffold(
        appBar: AppBar(
          title: const Text(
            "生产需求",
            style: TextStyle(color: Colors.black),
          ),
          elevation: 0,
          backgroundColor: Colors.white,
          leading: IconButton(
            icon: const Icon(
              Icons.arrow_back,
              color: Colors.black,
            ),
            onPressed: () {
              Navigator.pop(context);
            },
          ),
        ),
        body: CustomScrollView(
          slivers: [
            SliverToBoxAdapter(
                child: Container(
              padding: const EdgeInsets.only(top: 10),
              width: double.infinity,
              height: 10,
              color: Colors.white,
            )),
            //显示顶部
            topWidget(datamap),
            designerWidget(list),
            imaegWidget(datamap.isNotEmpty?APIs.BaseUrl+jsonDecode(datamap["picture"])["files"][0]["path"]:""),
            // designProgressInfoWidget(),
            baseInfoWidget(),
            designInfoWidget(),
            contactsInfoWidget(),
            SliverToBoxAdapter(child: paddingLine()),
          ],
        ));
  }

  Widget paddingLine() {
    return Container(
      margin: const EdgeInsets.only(top: 20),
      padding: const EdgeInsets.only(top: 10),
      width: double.infinity,
      height: 10,
      // color: const Color(0xffE5E5E5),
    );
  }


  Widget topWidget(Map map) {
    return  SliverToBoxAdapter(
        child: Container(
            margin: const EdgeInsets.only(top: 10, left: 10, right: 10),
            //边框设置
            decoration: BoxDecoration(
              //背景
              color: Colors.white,
              //设置四周圆角 角度
              borderRadius: const BorderRadius.all(Radius.circular(10.0)),
              //设置四周边框
              border: Border.all(width: 1, color: Colors.white),
            ),
            child: Column(
              // mainAxisAlignment: MainAxisAlignment.start,
              children: [
                Container(
                  margin: const EdgeInsets.only(
                      top: 10, left: 10, right: 10, bottom: 10),
                  child: Row(
                    mainAxisAlignment: MainAxisAlignment.spaceBetween,
                    children: [
                      Text(
                        map["code"] ?? "",
                        overflow: TextOverflow.ellipsis,
                        style: const TextStyle(
                            fontSize: 13, color: Color(0xff666666)),
                      ),
                      Text(
                        map["applyTime"] ?? "",
                        overflow: TextOverflow.ellipsis,
                        style: const TextStyle(
                            fontSize: 13, color: Color(0xff999999)),
                      )
                    ],
                  ),
                ),

                Container(
                  margin: const EdgeInsets.only(top: 1),
                  width: double.infinity,
                  height: 0.5,
                  color: const Color(0xffE5E5E5),
                ),
                Container(
                    margin: const EdgeInsets.only(top: 20, left: 10, right: 20),
                    child: Row(
                      children: [
                        const Text(
                          "产品类型：",
                          // overflow: TextOverflow.ellipsis,
                          style: TextStyle(fontSize: 15, color: Color(0xff999999)),
                        ),
                        Text(
                          map["typeName"]??"",
                          // overflow: TextOverflow.ellipsis,
                          style: const TextStyle(
                              fontSize: 15, color: Color(0xff999999)),
                        ),
                      ],
                    )),
                Container(
                    margin: const EdgeInsets.only(
                        top: 20, right: 20, left: 10),
                    child: Row(
                      children: [
                        const Text(
                          "期望交货时间: ",
                          // overflow: TextOverflow.ellipsis,
                          style:
                          TextStyle(fontSize: 15, color: Color(0xff999999)),
                        ),
                        Text(
                          map["endTime"] ?? "",
                          style: const TextStyle(
                            fontSize: 15,
                            color: Color(0xff333333),
                          ),
                        ),
                      ],
                    )),

                Container(
                    margin: const EdgeInsets.only(top: 20, left: 10, right: 20,bottom: 20),
                    child: Row(
                      children:  [
                        const Text("生产费用(不含税):",
                          overflow: TextOverflow.ellipsis,
                          style: TextStyle(fontSize: 15, color: Color(0xff999999)),
                        ),map["amount"]== null? const Text(
                          "￥0/件",
                          overflow: TextOverflow.ellipsis,
                          style: TextStyle(fontSize: 15, color: Color(0xffF93428)),
                        ):Text(
                          "￥${map["amount"]}/件",
                          overflow: TextOverflow.ellipsis,
                          style: const TextStyle(fontSize: 15, color: Color(0xffF93428)),
                        ),map["product_price"]==null? const Text(
                          "x ",
                          overflow: TextOverflow.ellipsis,
                          style: TextStyle(fontSize: 15, color: Color(0xff333333)),
                        ):Text(
                          "x ${map["product_price"]}",
                          overflow: TextOverflow.ellipsis,
                          style: const TextStyle(fontSize: 15, color: Color(0xff333333)),
                        ),
                      ],
                    )),
              ],
            )));
  }

  //对接厂商
  Widget designerWidget(List<Map> list) {
    return SliverToBoxAdapter(
        child: Container(
            margin: const EdgeInsets.only(top: 10, left: 10, right: 10),
            //边框设置
            decoration: BoxDecoration(
              //背景
              color: Colors.white,
              //设置四周圆角 角度
              borderRadius: const BorderRadius.all(Radius.circular(10.0)),
              //设置四周边框
              border: Border.all(width: 1, color: Colors.white),
            ),
            child: GestureDetector(
              child: Column(
                children: [
                  Container(
                    alignment: Alignment.topLeft,
                    margin: const EdgeInsets.only(top: 20),
                    child: Row(
                      mainAxisAlignment: MainAxisAlignment.spaceBetween,
                      children: [
                        Row(
                          children: [
                            Container(
                              margin: const EdgeInsets.only(right: 10),
                              width: 3,
                              height: 15,
                              color: const Color(0xff00946B),
                            ),
                            const Text(
                              "对接厂商",
                              style: TextStyle(
                                  color: Color(0xff222222),
                                  fontSize: 15,
                                  fontWeight: FontWeight.bold),
                            ),
                          ],
                        ),
                        const Icon(Icons.chevron_right)
                      ],
                    ),
                  ),
                  Row(
                    mainAxisAlignment: MainAxisAlignment.spaceBetween,
                    children: desigerChildeWidgets(),
                  )
                ],
              ),
              onTap: () {
                Navigator.push(context, MaterialPageRoute(builder: (context) {
                  return  ButtFactory(listmanufacturer);
                }));
              },
            )));
  }

  //产品图片
  Widget imaegWidget(String path) {
    return SliverToBoxAdapter(
      child: Container(
        margin: const EdgeInsets.only(top: 10, left: 10, right: 10),
        //边框设置
        decoration: BoxDecoration(
          //背景
          color: Colors.white,
          //设置四周圆角 角度
          borderRadius: const BorderRadius.all(Radius.circular(10.0)),
          //设置四周边框
          border: Border.all(width: 1, color: Colors.white),
        ),
        child: Column(
          children: [
            Container(
              alignment: Alignment.topLeft,
              margin: const EdgeInsets.only(top: 10),
              child: Row(
                children: [
                  Container(
                    width: 3,
                    height: 15,
                    color: const Color(0xff00946B),
                  ),
                  const Text(
                    " 产品图片",
                    style: TextStyle(
                        color: Color(0xff222222),
                        fontSize: 15,
                        fontWeight: FontWeight.bold),
                  ),
                ],
              ),
            ),
            Container(
              padding: const EdgeInsets.only(right: 5, top: 10, bottom: 10),
              child: Image.network(
                path,
                // width: Global.getScale(context) * 120,
                // height: Global.getScale(context) * 80,
                fit: BoxFit.cover,
              ),
            )
          ],
        ),
      ),
    );
  }

  List<Widget> desigerChildeWidgets() {
    List<Widget> listWidget = [];
    if (listmanufacturer.isNotEmpty) {
      for (int i = 0; i < listmanufacturer.length; i++) {
        listWidget.add(designerChildWidget(
            listmanufacturer[i]["avatar"] == null
                ? ""
                : json.decode(listmanufacturer[i]["avatar"])["url"] ?? "",
            listmanufacturer[i]["statusName"] ?? "",
            listmanufacturer[i]["username"] ?? ""));
      }
    }
    return listWidget;
  }

  Widget designerChildWidget(String url, String state, String name) {
    return Container(
      margin: const EdgeInsets.only(left: 10, right: 10, top: 10),
      child: Column(
        children: [
          Stack(alignment: Alignment.bottomCenter, children: [
            CircleAvatar(
              radius: scrSize.width / 12,
              backgroundColor: Colors.grey,
              backgroundImage: NetworkImage(url==""?"images/avatar.png":url),
            ),
            Container(
              padding: const EdgeInsets.all(5),
              //边框设置
              decoration: BoxDecoration(
                //背景
                color: state.contains("采纳")
                    ? Colors.deepOrangeAccent
                    : Colors.blue,
                //设置四周圆角 角度
                borderRadius: const BorderRadius.all(Radius.circular(18.0)),
                //设置四周边框
                border: Border.all(
                    width: 1,
                    color: state.contains("采纳")
                        ? Colors.deepOrangeAccent
                        : Colors.blue),
              ),
              child: Text(
                state,
                style: const TextStyle(fontSize: 12, color: Color(0xffffffff)),
              ),
            )
          ]),
          Padding(
            padding: const EdgeInsets.only(top: 10, bottom: 10),
            child: Text(
              name,
              style: const TextStyle(fontSize: 12, color: Color(0xff222222)),
            ),
          )
        ],
      ),
    );
  }

  //订单进度
  Widget designProgressInfoWidget() {
    return SliverToBoxAdapter(
      child: Container(
        margin: const EdgeInsets.only(top: 10, left: 10, right: 10),
        //边框设置
        decoration: BoxDecoration(
          //背景
          color: Colors.white,
          //设置四周圆角 角度
          borderRadius: const BorderRadius.all(Radius.circular(10.0)),
          //设置四周边框
          border: Border.all(width: 1, color: Colors.white),
        ),
        child: Column(
          children: [
            Container(
              alignment: Alignment.topLeft,
              margin: const EdgeInsets.only(top: 10),
              child: Row(
                children: [
                  Container(
                    width: 3,
                    height: 15,
                    color: const Color(0xff00946B),
                  ),
                  const Text(
                    "订单进度",
                    style: TextStyle(
                        color: Color(0xff222222),
                        fontSize: 15,
                        fontWeight: FontWeight.bold),
                  ),
                ],
              ),
            ),
            Row(
              crossAxisAlignment: CrossAxisAlignment.center,
              // mainAxisAlignment: MainAxisAlignment.spaceBetween,
              children: [
                designProgressInfoChildWidget(true, false, "邀约", "12-12 12:00"),
                designProgressInfoChildWidget(
                    false, false, "对接", "12-12 12:00"),
                designProgressInfoChildWidget(
                    false, false, "上传作品", "12-12 12:00"),
                designProgressInfoChildWidget(false, true, "采纳", "12-12 12:00"),
              ],
            )
          ],
        ),
      ),
    );
  }

  //对接进度子widget
  Widget designProgressInfoChildWidget(
      bool isVisibleLeft, bool isVisibleRight, String name, String time) {
    return Container(
      padding: const EdgeInsets.only(top: 20),
      child: Column(
        children: [
          Row(
            children: [
              Opacity(
                  opacity: isVisibleLeft ? 0 : 1,
                  child: Container(
                    height: 1,
                    width: scrSize.width / 3 - 80,
                    color: const Color(0xff07905F),
                  )),
              Container(
                margin: const EdgeInsets.only(right: 10),
                child: const SizedBox(
                  width: 10,
                  height: 10,
                  child: CircleAvatar(
                    radius: 15,
                    backgroundColor: Color(0xff07905F),
                  ),
                ),
              ),
              Opacity(
                opacity: isVisibleRight ? 0 : 1,
                child: Container(
                  height: 1,
                  width: isVisibleRight
                      ? scrSize.width / 3 - 80
                      : scrSize.width / 3 - 80,
                  color: const Color(0xff07905F),
                ),
              ),
            ],
          ),
          Container(
              margin: const EdgeInsets.only(top: 5, bottom: 5),
              child: Text(
                name,
                style: const TextStyle(fontSize: 10),
              )),
          Text(
            time,
            style: const TextStyle(fontSize: 10, color: Color(0xff000000)),
          ),
        ],
      ),
    );
  }

  //基础信息
  Widget baseInfoWidget() {
    return SliverToBoxAdapter(
        child: Container(
            margin: const EdgeInsets.only(top: 10, left: 10, right: 10),
            //边框设置
            decoration: BoxDecoration(
              //背景
              color: Colors.white,
              //设置四周圆角 角度
              borderRadius: const BorderRadius.all(Radius.circular(10.0)),
              //设置四周边框
              border: Border.all(width: 1, color: Colors.white),
            ),
            child: Column(
              children: [
                Container(
                  alignment: Alignment.topLeft,
                  margin: const EdgeInsets.only(top: 20),
                  child: Row(
                    children: [
                      Container(
                        margin: const EdgeInsets.only(right: 10),
                        width: 3,
                        height: 15,
                        color: const Color(0xff00946B),
                      ),
                      const Text(
                        "基础信息",
                        style: TextStyle(
                            color: Color(0xff222222),
                            fontSize: 15,
                            fontWeight: FontWeight.bold),
                      ),
                    ],
                  ),
                ),
                baseInfoChildWidget("套件/单件", datamap["set_piece"] ?? ""),
                baseInfoChildWidget("款式类型", datamap["style_type"] ?? ""),
                baseInfoChildWidget("性别", datamap["gender"] ?? ""),
                baseInfoChildWidget("上装/下装", datamap["top_bottom"] ?? ""),
                baseInfoChildWidget("款式", datamap["short_long"] ?? ""),
                baseInfoChildWidget("季节", datamap["season"] ?? ""),
                baseInfoChildWidget("年份", datamap["year"] ?? ""),
                baseInfoChildWidget("使用环境", datamap["environment"] ?? ""),
              ],
            )));
  }

  //生产要求
  Widget designInfoWidget() {
    return SliverToBoxAdapter(
        child: Container(
            margin: const EdgeInsets.only(top: 10, left: 10, right: 10),
            //边框设置
            decoration: BoxDecoration(
              //背景
              color: Colors.white,
              //设置四周圆角 角度
              borderRadius: const BorderRadius.all(Radius.circular(10.0)),
              //设置四周边框
              border: Border.all(width: 1, color: Colors.white),
            ),
            child: Column(
              children: [
                Container(
                  alignment: Alignment.topLeft,
                  margin: const EdgeInsets.only(top: 20),
                  child: Row(
                    children: [
                      Container(
                        margin: const EdgeInsets.only(right: 10),
                        width: 3,
                        height: 15,
                        color: const Color(0xff00946B),
                      ),
                      const Text(
                        "生产要求",
                        style: TextStyle(
                            color: Color(0xff222222),
                            fontSize: 15,
                            fontWeight: FontWeight.bold),
                      ),
                    ],
                  ),
                ),
                Container(
                    margin: const EdgeInsets.only(top: 20, left: 10, right: 20),
                    child: Html(data: datamap["content"] ?? ""))
              ],
            )));
  }

  //联系人信息
  Widget contactsInfoWidget() {
    return SliverToBoxAdapter(
        child: Container(
            margin: const EdgeInsets.only(top: 10, left: 10, right: 10),
            //边框设置
            decoration: BoxDecoration(
              //背景
              color: Colors.white,
              //设置四周圆角 角度
              borderRadius: const BorderRadius.all(Radius.circular(10.0)),
              //设置四周边框
              border: Border.all(width: 1, color: Colors.white),
            ),
            child: Column(
              children: [
                Container(
                  alignment: Alignment.topLeft,
                  margin: const EdgeInsets.only(top: 20),
                  child: Row(
                    children: [
                      Container(
                        margin: const EdgeInsets.only(right: 10),
                        width: 3,
                        height: 15,
                        color: const Color(0xff00946B),
                      ),
                      const Text(
                        "联系人信息",
                        style: TextStyle(
                            color: Color(0xff222222),
                            fontSize: 15,
                            fontWeight: FontWeight.bold),
                      ),
                    ],
                  ),
                ),
                baseInfoChildWidget("联系人", datamap["contacts"] ?? ""),
                baseInfoChildWidget("固定电话", datamap["phone"] ?? ""),
                baseInfoChildWidget("E-mail", datamap["email"] ?? ""),
                baseInfoChildWidget("QQ", datamap["qq"] ?? ""),
              ],
            )));
  }

  Widget baseInfoChildWidget(String name, String value) {
    return Container(
        margin: const EdgeInsets.only(top: 20, left: 10, right: 20),
        child: Row(
          children: [
            SizedBox(
              width: 100,
              child: Text(
                name,
                overflow: TextOverflow.ellipsis,
                style: const TextStyle(fontSize: 15, color: Color(0xff999999)),
              ),
            ),
            Text(
              value,
              overflow: TextOverflow.ellipsis,
              style: const TextStyle(fontSize: 15, color: Color(0xff222222)),
            ),
          ],
        ));
  }

  void _onRefresh() async {
    if (isloading) {
      //下拉刷新获取网络数据
      // getQueryHome();
    } else {
      refreshController.refreshCompleted();
      refreshController.loadComplete();
    }
    isloading = true;
  }

  void _onLoading() async {
    refreshController.loadComplete();
  }
}
