import 'package:event_bus/event_bus.dart';
import 'package:flutter/material.dart';
import 'package:textileclothing/Message/MessageMain.dart';
import 'package:textileclothing/utils/Global.dart';
import 'package:shared_preferences/shared_preferences.dart';
import 'Iconfont.dart';

import 'User/MyUser.dart';
import 'home/HomeBody.dart';

class MyHome extends StatefulWidget {
  const MyHome({super.key});

  @override
  State<StatefulWidget> createState() {
    return HomeState();
  }
}

class HomeState extends State  {
  int _selectedIndex = 0;
  // EventBus eventBus = EventBus();
  static final List<Widget> _pageList = [];
  int waitCount = 0;
  HomeBody homeBody = HomeBody();
  MessageMain messageMain = MessageMain();
  @override
  void initState() {
    super.initState();
    Global.numberRedBus.on().listen((event) {
      setState(() {
        waitCount = int.parse(event);
      });
    });
    // getWait();
    if (_pageList.isEmpty) {
      _pageList.add(homeBody);
      _pageList.add(messageMain);
      _pageList.add(MyUser());
    }
    // //监听广播
    // eventBus.on<BusContent>().listen((event) {
    //   setState(() {
    //     _selectedIndex = event.state;
    //   });
    // });
    // getindex();
  }

  getindex() async {
    var ii = await Global.getData("index");
    setState(() {
      if (ii == null) {
        _selectedIndex = 0;
      } else {
        // _selectedIndex = 1;
        _selectedIndex = int.parse(ii);
      }
    });
  }

  @override
  void deactivate() {
    super.deactivate();
  }

  @override
  Widget build(BuildContext context) {
    // super.build(context);
    // ScreenUtil.instance = ScreenUtil.getInstance()..init(context);
    return Scaffold(
      bottomNavigationBar: BottomNavigationBar(
        items: <BottomNavigationBarItem>[
          BottomNavigationBarItem(
            icon: Container(
              width: 20,
                height: 20,
                margin: const EdgeInsets.only(bottom: 2),
                child:  Image.asset("images/information.png",)),
            activeIcon: Container(
                width: 20,
                height: 20,
                margin: const EdgeInsets.only(bottom: 2),
                child: Image.asset("images/informations.png",)),
            label: '资讯',
          ),
          BottomNavigationBarItem(
            icon: Container(
                width: 20,
                height: 20,
                margin: const EdgeInsets.only(bottom: 2),
                child:  Image.asset("images/message.png",)),
            activeIcon: Container(
                width: 20,
                height: 20,
                margin: const EdgeInsets.only(bottom: 2),
                child: Image.asset("images/messages.png",)),
                // child: CommonRedMessage.showRedWidget( Image.asset("images/messages.png",), waitCount)),
            label: '消息',
          ),
          BottomNavigationBarItem(
            icon: Container(
                width: 20,
                height: 20,
                margin: const EdgeInsets.only(bottom: 2),
                child:  Image.asset("images/my.png",)),
            activeIcon: Container(
                width: 20,
                height: 20,
                margin: const EdgeInsets.only(bottom: 2),
                child: Image.asset("images/mys.png",)),
            label: '我的',
          ),
        ],
        type: BottomNavigationBarType.fixed,
        currentIndex: _selectedIndex,
        fixedColor: Colors.black,
        onTap: _onItemTapped,
      ),
      body: IndexedStack(
        index: _selectedIndex,
        children: _pageList,
      ),
    );
  }

  void _onItemTapped(int index) {
    setState(() {
      _pageList.clear();
      _pageList.add(homeBody);
      _pageList.add(messageMain);
      _pageList.add(MyUser());
      homeBody.serchClear();
      messageMain.serchClear();
      // Global.saveData("index", index.toString());
      _selectedIndex = index;
    });
  }

  // @override
  // bool get wantKeepAlive => true;
}
