import 'dart:collection';

import 'dart:convert';
import 'package:flutter/material.dart';

import '../dio/APIs.dart';
import '../dio/HttpUtils.dart';
import '../dio/DioUtils.dart';
import '../utils/Global.dart';
import 'dart:convert' as convert;

class AccountAuthentication extends StatefulWidget {
  const AccountAuthentication({super.key});

  @override
  State<StatefulWidget> createState() {
    return AccountAuthenticationState();
  }
}

//账号认证界面
class AccountAuthenticationState extends State {

  bool isReady = false;

  Map dataMap = HashMap();
  Map infoMap = HashMap();
  @override
  void initState() {
    super.initState();
    getSqlColumn();
    getMyInfo();
  }
  //个人信息
  getMyInfo() async {
    HttpUtils.postJSON(
        context,
        "${APIs.Myinfo_Info}?token=${await Global.getData("token")}",
        {}, success: (data) async {
      setState(() {
        dataMap = data["data"];
      });
    }, fail: (code, msg) {}, type: Type.JSON);
  }


  getSqlColumn() async {
    Map jsParam={"timeStemp":"1682579667383"};
    var str=convert.jsonEncode(jsParam);
    HttpUtils.postJSON(context, APIs.getSqlColumn, {
      "json": "IGkDVEMLKCJ",
      "type": "1",
      "token": await Global.getData("token"),
      "param": str,

    }, success: (data) async {
      setState(() {
        isReady = true;
        infoMap = data;

      });
    }, fail: (code, msg) {});
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        centerTitle: false,
        backgroundColor: Colors.white,
        title: const Text(
          "账号认证",
          style: TextStyle(color: Colors.black, fontSize: 18),
        ),
        elevation: 0,
        leading: IconButton(
          icon: const Icon(
            Icons.arrow_back,
            color: Colors.black,
          ),
          onPressed: () {
            Navigator.pop(context);
          },
        ),//标题头阴影  0 为无
      ),
      // backgroundColor: Colors.white,
      body:isReady?Container(
          margin: const EdgeInsets.only( top: 60),
          child: Column(
            crossAxisAlignment: CrossAxisAlignment.start,
            children: [
              Center(
                child: ClipOval(
                    child: FadeInImage.assetNetwork(
                      placeholder: 'images/avatar.png',
                  image:Global.getisEmpty(dataMap["avatar"])?"":json.decode(dataMap["avatar"])["url"],
                  width: Global.getScale(context) *58,
                  height: Global.getScale(context) *58,
                  fit: BoxFit.cover,
                )),),

          Container(
              decoration: BoxDecoration(
            //背景
            color: Colors.white,
            //设置四周圆角 角度
            borderRadius: const BorderRadius.all(Radius.circular(10.0)),
            //设置四周边框
            border: Border.all(width: 1, color: Colors.white),
          ),
              margin: const EdgeInsets.only( top:30,bottom: 30,left: 10,right: 10),
              child: Column(
                  children: [
                    getContainer("我是企业","images/enterprise.png",infoMap["brandConfigure"][0]),
                    Global.getPartingLine(),
                    getContainer("我是工厂","images/factory.png",infoMap["factoryConfigure"][0]),
                    Global.getPartingLine(),
                    getContainer("我是设计师","images/designer.png",infoMap["designerConfigure"][0]),
                    Global.getPartingLine(),
              ]))
        ],
          )
      ):Global.add());
  }

  Widget getContainer(String name,String img,Map map){
    return GestureDetector(

      behavior: HitTestBehavior.opaque,
        child:Row(
          mainAxisAlignment: MainAxisAlignment.spaceBetween,
          children: [
            Container(
              margin: const EdgeInsets.only(left: 30, top: 20),
              child: Row(
                children: [
                  Container(
                    margin: const EdgeInsets.only(right: 10),
                    child: Image(
                      image: AssetImage(img),
                      width: 20,
                      height: 20,),
                    // child: const Icon(Iconfont.topicSet,
                    //     color: Color(0xff333333), size: 20),
                  ), Text(name,
                    style:
                    const TextStyle(fontSize: 14, color: Color(0xff333333),fontWeight: FontWeight.bold),
                  )
                ],
              ),
            ),
            gettype(map)
          ],
        ),//getState("我是企业","images/enterprise.png",infoMap["brandConfigure"][0]),
        onTap: () async {
          if(map["isCertified"]==0&&map["isExistingProcess"]==0){//未认证——发起页面——id:map["appId"]
            // Global.openUrl(context,"/IfarmeAffair?id=${map["appId"]}&get=mobile&token=${await Global.getData("token")}}&hasSingle=${map["hasSingle"]}");
            Global.openUrl(context,"/IfarmeAffair?id=${map["appId"]}&get=mobile&token=${await Global.getData("token")}");
          }else if (map["isCertified"]==1&&map["isExistingProcess"]==0){//已经认证可修改——修改表单页面——id:map["modifyAppId"]
            // Global.openUrl(context,"/IfarmeAffair?id=${map["modifyAppId"]}&get=mobile&token=${await Global.getData("token")}}&hasSingle=${map["hasSingle"]}");
            Global.openUrl(context,"/IfarmeAffair?id=${map["modifyAppId"]}&get=mobile&token=${await Global.getData("token")}");
          }else if (map["isCertified"]==1&&map["isExistingProcess"]==1){//已经认证不可修改——只可查看表单——id:map["process_biz_key"]
            Global.openUrl(
                context,
                "/IfarmeAffairDetail?id=${map["process_biz_key"]}&token=${await Global.getData("token")}",
                false,
                11, (map) {
              setState(() {
                getSqlColumn();
              });
            });
          }else if (map["isExistingProcess"]==1){//认证中——只可查看表单——id:map["process_biz_key"]
            Global.openUrl(
                context,
                "/IfarmeAffairDetail?id=${map["process_biz_key"]}&token=${await Global.getData("token")}",
                false,
                11, (map) {
              setState(() {
                getSqlColumn();
              });
            });

          }

        },
      );

  }
  // Widget getContainer1(String name,String img,Map map){
  //   return
  //     Row(
  //     mainAxisAlignment: MainAxisAlignment.spaceBetween,
  //     children: [
  //       Container(
  //         margin: const EdgeInsets.only(left: 30, top: 20),
  //         child: Row(
  //           children: [
  //             Container(
  //               margin: const EdgeInsets.only(right: 10),
  //               child: Image(
  //                 image: AssetImage(img),
  //                 width: 20,
  //                 height: 20,),
  //               // child: const Icon(Iconfont.topicSet,
  //               //     color: Color(0xff333333), size: 20),
  //             ), Text(name,
  //               style:
  //               const TextStyle(fontSize: 14, color: Color(0xff333333),fontWeight: FontWeight.bold),
  //             )
  //           ],
  //         ),
  //       ),
  //       gettype(map)
  //     ],
  //   );
  // }
  // Widget getContainer2(String name,String img,Map map ){
  //   return Row(
  //     mainAxisAlignment: MainAxisAlignment.spaceBetween,
  //     children: [
  //       Container(
  //         margin: const EdgeInsets.only(left: 30, top: 20),
  //         child: Row(
  //           children: [
  //             Container(
  //               margin: const EdgeInsets.only(right: 10),
  //               child: Image(
  //                 image: AssetImage(img),
  //                 width: 20,
  //                 height: 20,),
  //               // child: const Icon(Iconfont.topicSet,
  //               //     color: Color(0xff333333), size: 20),
  //             ), Text(name,
  //               style:
  //               const TextStyle(fontSize: 14, color: Color(0xff333333),fontWeight: FontWeight.bold),
  //             )
  //           ],
  //         ),
  //       ),
  //       gettype(map)
  //     ],
  //   );
  // }

  Widget gettype(Map map ){
    if (map["isCertified"]==1) {
      return Container(
        margin: const EdgeInsets.only(left: 20, top: 20, right: 20),
        child: Row(
          children:  [
            Container(
                padding: const EdgeInsets.only(left: 10, top: 2,bottom: 2, right: 10),
                decoration: BoxDecoration(
                  // gradient: const LinearGradient(colors:[Color(0xffFFB932), Color(0xffFFD632)]),//设置渐变色
                  color:  const Color(0xff15CE78),//背景
                  borderRadius: const BorderRadius.all(Radius.circular(25.0)),//设置四周圆角 角度
                  border: Border.all(width: 1, color: Colors.white70),//设置四周边框
                ),
                child:  Text("已认证",
                    style: TextStyle(height: 1.6, color: Colors.white, fontSize: Global.getScale(context) *12))),
            const Icon(
              Icons.arrow_forward_ios,
              size:11.0,
              color: Color(0xff999999),
            )
          ],
        ),
      );
    }else if(map["isCertified"]==0&&map["isExistingProcess"]==0){
      return Container(
        margin: const EdgeInsets.only(left: 20, top: 20, right: 20),
        child: Row(
          children:  [
            Container(
                padding: const EdgeInsets.only(left: 10, top: 5,bottom: 5, right: 20),
                decoration: BoxDecoration(
                  // gradient: const LinearGradient(colors:[Color(0xffFFB932), Color(0xffFFD632)]),//设置渐变色
                  // color:  const Color(0xff15CE78),//背景
                  color: Colors.white70,//背景
                  borderRadius: const BorderRadius.all(Radius.circular(25.0)),//设置四周圆角 角度
                  border: Border.all(width: 1, color: Colors.white70),//设置四周边框
                ),
                child:  Text("未认证",
                    style: TextStyle(height: 1.6, color: Colors.white, fontSize: Global.getScale(context) *12))),
            const Icon(
              Icons.arrow_forward_ios,
              size:11.0,
              color: Color(0xff999999),
            )
          ],
        ),
      );
    }else{
      return Container(
        margin: const EdgeInsets.only(left: 20, top: 20, right: 20),
        child: Row(
          children:  [
            Container(
                padding: const EdgeInsets.only(left: 10, top: 5,bottom: 5, right: 20),
                decoration: BoxDecoration(
                  // gradient: const LinearGradient(colors:[Color(0xffFFB932), Color(0xffFFD632)]),//设置渐变色
                  // color:  const Color(0xff15CE78),//背景
                  color: const Color(0xFFFBC02D),//背景
                  borderRadius: const BorderRadius.all(Radius.circular(25.0)),//设置四周圆角 角度
                  border: Border.all(width: 1, color: Colors.white70),//设置四周边框
                ),
                child:  Text("审核中",
                    style: TextStyle(height: 1.6, color: Colors.white, fontSize: Global.getScale(context) *12))),
            const Icon(
              Icons.arrow_forward_ios,
              size:11.0,
              color: Color(0xff999999),
            )
          ],
        ),
      );
    }
  }
}
