
import 'dart:collection';
import 'dart:convert';

import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:pull_to_refresh/pull_to_refresh.dart';
import 'package:shared_preferences/shared_preferences.dart';
// import 'package:flutter_android/Iconfont.dart';

import '../Iconfont.dart';
import '../dio/APIs.dart';
import '../dio/HttpUtils.dart';
import '../utils/Global.dart';
import '../utils/HexColor.dart';
import '../utils/TimeUtils.dart';
import '../widget/LoadStateLayout.dart';
import '../widget/MySmartRefresher.dart';
import '../widget/Toast.dart';
import 'AppDetailImg.dart';
import 'AppDetailProgress.dart';
import 'AppDetailWeb.dart';

class AppDetail extends StatefulWidget {
   String id = "";
   AppDetail(this.id, {super.key});
   @override
   State<StatefulWidget> createState() {
     return AppDetailState(id);
   }
}

class AppDetailState extends State with SingleTickerProviderStateMixin {
  String id = "";

  AppDetailState(this.id);

  TextEditingController serchController = TextEditingController();
  int clickindex = 0;
  LoadState _layoutState = LoadState.State_Loading;
  late TabController _controller;

  Map appDetailTopMap = HashMap(); //应用详情
  Map appDetailMap = HashMap(); //数据列表

  Map appDetailCountMap = HashMap(); //数量
  int pageSize = 15;
  int pageNo = 1;
  List<String> tabValues = ['申请记录', '待办', '已办', "草稿"];
  String starttime = "开始时间";
  String endTime = "结束时间";
  String formStatusId = "";
  // late WidgetPopu widgetPopu;
  DateTime? start;
  String startTimecurrt = "";
  String endTimecurrt = "";

  @override
  void initState() {
    super.initState();
    _controller = TabController(
      length: tabValues.length,
      vsync: this,
    );

    getDetail(id);
    getCount(id);
//     Future<String> userName = getSaveId() as Future<String> ;
//     if(userName!=null){
//       userName.then((String appId) {
//         getDetail(appId);
     getData("");
//         id = appId;
//         getCount(appId);
//       });
//     }else{
//       getCount(id);
//     }


    getLevel();
  }

  getLevel() async {
    HttpUtils.postJSON(context, APIs.My_ThingLevel, {
      "pageSize": pageSize,
      "pageNo": pageNo,
      "token": await Global.getData("token"),
    }, success: (data) async {
      setState(() {
        List responseJson = data;
        // myLevelList = responseJson.map((m) => MyLevel.fromMap(m)).toList();
      });
    }, fail: (code, msg) {});
  }

  //详情接口
  getDetail(String id) async {
    HttpUtils.postJSON(context, APIs.Appdetail_getDetail,
        {"id": id, "token": await Global.getData("token")}, //"reqType": "MOBILE",
        success: (data) async {
      setState(() {
        appDetailTopMap = data;
      });
    }, fail: (code, msg) {});
  }

  getCount(String id) async {
    HttpUtils.postJSON(context, APIs.Appdetail_count, {
      "appId": id,
      "token": await Global.getData("token"),
    }, success: (data) async {
      setState(() {
        appDetailCountMap = data;
        // _appDetailCountEntity = AppDetailCount.fromMap(data);
      });
    }, fail: (code, msg) {});
  }

  // getData(String starttime,String endTime,String levelId) async {
  getData(String levelId) async {
    HttpUtils.postJSON(context, APIs.Appdetail, {
      "current": 1,
      "pageSize": pageSize,
      "pageNo": pageNo,
      "appId": id,
      "reqType": "MOBILE",
      "key": "0.3352695441205704",
      "token": await Global.getData("token"),
      "keyWords":serchController.text,
      // "startTime":starttime,
      // "endTime":endTime,
      "levelId":levelId,
    }, success: (data) async {
      setState(() {
        _layoutState = LoadState.State_Success;
        appDetailMap = data;
        // _appDetailEntity = AppDetailBean.fromMap(data);
        // if (pageNo == _appDetailEntity?.totalPage) {
        if (pageNo == appDetailMap["totalPage"]) {
          refreshController.loadNoData();
        } else {
          refreshController.loadComplete();
        }
        refreshController.refreshCompleted();
      });
    }, fail: (code, msg) {});
  }

  //待办数据
  getWait(String starttime,String endTime,String levelId) async {
    HttpUtils.postJSON(context, APIs.Appdetail_wait, {
      "current": 1,
      "pageSize": pageSize,
      "pageNo": pageNo,
      "reqType": "MOBILE",
      "appId": id,
      "key": "0.3352695441205704",
      "token": await Global.getData("token"),
      "keyWords":serchController.text,
      "startTime":starttime,
      "endTime":endTime,
      "levelId":levelId,
    }, success: (data) async {
      setState(() {
        _layoutState = LoadState.State_Success;
        appDetailMap = data;
        if (pageNo == appDetailMap["totalPage"]) {
          refreshController.loadNoData();
        } else {
          refreshController.loadComplete();
        }
        refreshController.refreshCompleted();
      });
    }, fail: (code, msg) {});
  }

  //已办
  getHndel(String starttime,String endTime,String levelId) async {
    HttpUtils.postJSON(context, APIs.Appdetail_handel, {
      "current": 1,
      "pageSize": pageSize,
      "pageNo": pageNo,
      "reqType": "MOBILE",
      "appId": id,
      "key": "0.3352695441205704",
      "token": await Global.getData("token"),
      "keyWords":serchController.text,
      "startTime":starttime,
      "endTime":endTime,
      "levelId":levelId,
    }, success: (data) async {
      setState(() {
        _layoutState = LoadState.State_Success;
        appDetailMap = data;
        if (pageNo == appDetailMap["totalPage"]) {
          refreshController.loadNoData();
        } else {
          refreshController.loadComplete();
        }
        refreshController.refreshCompleted();
      });
    }, fail: (code, msg) {});
  }

  getDraft(String starttime,String endTime,String levelId) async {
    //草稿箱
    HttpUtils.postJSON(context, APIs.Appdetail_deaft, {
      "current": 1,
      "pageSize": pageSize,
      "pageNo": pageNo,
      "reqType": "MOBILE",
      "appId": id,
      "key": "0.3352695441205704",
      "token": await Global.getData("token"),
      "keyWords":serchController.text,
      "startTime":starttime,
      "endTime":endTime,
      "levelId":levelId,
    }, success: (data) async {
      setState(() {
        _layoutState = LoadState.State_Success;

        appDetailMap = data;
        // _appDetailEntity = AppDetailBean.fromMap(data);
        if (pageNo == appDetailMap["totalPage"]) {
          refreshController.loadNoData();
        } else {
          refreshController.loadComplete();
        }
        refreshController.refreshCompleted();
      });
    }, fail: (code, msg) {});
  }

  getColl() async {
    HttpUtils.postJSON(context, APIs.AppDetail_Coll,
        {"ids": id, "token":await Global.getData("token")}, success: (data) async {
      setState(() {
        if (data.toString() == "true") {
          appDetailTopMap["isCollection"] = true;
          appDetailTopMap["collectionNum"] += 1;
        }
      });
    }, fail: (code, msg) {});
  }

  getUnColl() async {
    HttpUtils.postJSON(context, APIs.AppDetail_UnColl,
        {"ids": id, "token": await Global.getData("token")}, success: (data) async {
      setState(() {
        if (data.toString() == "true") {
          appDetailTopMap["isCollection"] = false;
          appDetailTopMap["collectionNum"] -= 1;
        }
      });
    }, fail: (code, msg) {});
  }

  getSend(String id) async {
    HttpUtils.postJSON(context, APIs.Appdetail_send,
        {"ids": id, "token": await Global.getData("token")}, success: (data) async {
      setState(() {
        if (data.toString() == "true") {
          getDataAll(clickindex);
        } else {
          dilaogFail(context); //没有做发送失败数据的解析
        }
      });
    }, fail: (code, msg) {});
  }

  getDelet(String id) async {
    // final prefs = await SharedPreferences.getInstance();

    HttpUtils.postJSON(context, APIs.Appdetail_delet,
        {"ids": id, "token": await Global.getData("token")}, success: (data) async {
      setState(() {
        if (data.toString() == "true") {
          getDataAll(clickindex);
        }
      });
    }, fail: (code, msg) {});
  }

  getBack(String id) async {
    // final prefs = await SharedPreferences.getInstance();
    HttpUtils.postJSON(context, APIs.Appdetail_back, {
      "taskIds": id,
      "token": await Global.getData("token")
    }, success: (data) async {
      setState(() {
        if(data.toString()=="true"){
          getDataAll(clickindex);
        }else{

        }

      });
    }, fail: (code, msg) {});
  }

  RefreshController refreshController = RefreshController(initialRefresh: true);

  void onRefresh() async {
    pageNo = 1;
    getDataAll(clickindex);
  }

  void onLoading() async {
    if (appDetailMap!=null){
      if(pageNo < appDetailMap["totalPage"]) {
        pageNo++;
      }
    }
    getDataAll(clickindex);
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        title: const Text("应用详情",style: TextStyle(color: Colors.black),),
        centerTitle: true,
        backgroundColor: Colors.white,
        elevation: 0,
        iconTheme: const IconThemeData(
          color: Color(0xff333333), //修改颜色
        ),
      ),
      body: MySmartRefresher()
          .getRefresher(refreshController, onRefresh, onLoading, getResher()),
    );
  }

  Widget getResher() {
    return CustomScrollView(
      slivers: [
        SliverToBoxAdapter(
            child: Column(
                children: [
              Row(
            children: [
              Expanded(
                flex: 6,
                child: Container(
                  color: const Color(0xffF5F5F5),
                  margin: const EdgeInsets.only(left: 15, right: 15, top: 10),
                  padding: const EdgeInsets.only(left: 10, right: 10),
                  child: TextField(
                    controller: serchController,
                    decoration: InputDecoration(
                      fillColor: const Color(0xffF5F5F5),
                      hintText: "姓名",
                      suffixIcon: GestureDetector(
                        child: const Icon(
                          Icons.search,
                          color: Color(0xff666666),
                        ),
                        onTap: () {
                          pageSize = 15;
                          pageNo = 1;
                          getDataAll(clickindex);
                        },
                      ),
                      border: InputBorder.none,
                    ),
                  ),
                ),
              ),
              // Expanded(
              //   flex: 1,
              //   child: Container(
              //     margin: EdgeInsets.only(top: 20, bottom: 10),
              //     child: PopupWindowButton(
              //       offset: Offset(0, 50),
              //       buttonBuilder: (BuildContext context) {
              //         return Container(
              //           padding: EdgeInsets.only(right: 1),
              //           child: Text(
              //             "筛选",
              //             style: TextStyle(fontSize: 14, color: Colors.blue),
              //           ),
              //         );
              //       },
              //       windowBuilder: (BuildContext context,
              //           Animation<double> animation,
              //           Animation<double> secondaryAnimation) {
              //         return Container(
              //             margin: EdgeInsets.only(top: 20),
              //             color: Colors.transparent,
              //             child: widgetPopu = WidgetPopu());
              //       },
              //       onWindowShow: () {},
              //       onWindowDismiss: () {
              //         if (WidgetPopuState.isclick) {
              //           starttime = WidgetPopuState.starttime;
              //           endTime = WidgetPopuState.endTime;
              //           formStatusId = WidgetPopuState.formStatusId;
              //           // getDataAll(clickindex);
              //           if (clickindex == 0) {
              //             getData(starttime == "开始时间" ? "" : starttime, endTime == "结束时间" ? "" : endTime, formStatusId);
              //           } else if (clickindex == 1) {
              //             getWait(starttime == "开始时间" ? "" : starttime, endTime == "结束时间" ? "" : endTime, formStatusId);
              //           } else  if (clickindex == 2) {
              //             getHndel(starttime == "开始时间" ? "" : starttime, endTime == "结束时间" ? "" : endTime, formStatusId);
              //           }else {
              //             getDraft(starttime == "开始时间" ? "" : starttime, endTime == "结束时间" ? "" : endTime, formStatusId);
              //           }
              //           }
              //         }
              //     ),
              //   ),
              // )
            ],
          ),
        ])),
        SliverToBoxAdapter(
          child: getHeader(), //显示上面的内容
        ),
        SliverPersistentHeader(
            pinned: true,
            delegate: StickyTabBarDelegate(
              child: TabBar(
                tabs: tabValues.map((f) {
                  return SizedBox(
                    height: 160,
                    child: Stack(
                      children: [
                        Text(
                          f,
                          style: const TextStyle(fontSize: 15),
                        ),
                        f == "待办"
                            ? Container(
                                margin: const EdgeInsets.only(
                                  left: 30,
                                ),
                                width: 20,
                                height: 24,
                                decoration: const ShapeDecoration(
                                    color: Colors.red,
                                    shape: CircleBorder(
                                      side: BorderSide.none,
                                    )),
                                child: Container(
                                  width: double.infinity,
                                  height: double.infinity,
                                  alignment: Alignment.topCenter,
                                  child: Text(
                                      appDetailCountMap != null
                                          ? "${appDetailCountMap["waitCount"]}"
                                          : "",
                                      style: const TextStyle(
                                          fontSize: 12, color: Colors.white)),
                                ))
                            : const Text("")
                      ],
                    ),
                  );
                }).toList(),
                controller: _controller,
                indicatorColor: const Color(0xff1278C0),
                indicatorSize: TabBarIndicatorSize.tab,
                isScrollable: false,
                labelColor: const Color(0xff1278C0),
                unselectedLabelColor: Colors.black,
                indicatorWeight: 2.0,
                labelPadding:
                    const EdgeInsets.only(left: 10, right: 10, top: 10, bottom: 10),
                labelStyle: const TextStyle(height: 2),
                onTap: (index) {
                  clickindex = index;
                  pageNo = 1;
                  getDataAll(index);
                },
              ),
            )),
        SliverToBoxAdapter(
          child: Text(
            getTitleNumber(),
            style: const TextStyle(fontSize: 12, color: Color(0xff999999)),
            textAlign: TextAlign.right,
          ),
        ),
        SliverToBoxAdapter(
          //这个是再下面的内容，一层一层往下走的
          child: ListView.builder(
              physics: const NeverScrollableScrollPhysics(),
              shrinkWrap: true,
              itemCount:
              appDetailMap == null ? 0 : appDetailMap["rows"].length,
              itemBuilder: (BuildContext context, int index) {
                  return getList(appDetailMap["rows"][index]);
              }),
        ),
      ],
    );
  }

  String getTitleNumber() {
    if (clickindex == 0) {
      return "共${appDetailCountMap["applyCount"]}条数据     ";
    } else if (clickindex == 1) {
      return "共${appDetailCountMap["waitCount"]}条数据     ";
    } else if (clickindex == 2) {
      return "共${appDetailCountMap["handledCount"]}条数据     ";
    } else if (clickindex == 3) {
      return "共${appDetailCountMap["draftCount"]}条数据     ";
    }
    return "";
  }

  void getDataAll(int index) {
    if (index == 0) {
      getData("");
    } else if (index == 1) {
      getWait("","","");
    } else if (index == 2) {
      getHndel("","","");
    } else if (index == 3) {
      getDraft("","","");
    }
  }

  Widget getHeader() {
    return Column(crossAxisAlignment: CrossAxisAlignment.start, children: [
      Row(
        mainAxisAlignment: MainAxisAlignment.spaceBetween,
        children: [
          Row(
            children: [
              Container(
                  margin: const EdgeInsets.only(left: 15, right: 15, top: 15, bottom: 15),
                  //设置 child 居中
                  alignment: const Alignment(0, 0),
                  height: Global.getScale(context) * 55,
                  width: Global.getScale(context) * 55,
                  //边框设置
                  decoration: BoxDecoration(
                    //这个是设置背景的
                    //背景
                    color: const Color(0xff666666).withOpacity(0.06),
                    //设置四周圆角 角度 这里的角度应该为 父Container height 的一半
                    borderRadius: const BorderRadius.all(Radius.circular(25.0)),
                  ),
                  child: Global.getNetworkSvg(context,null!=appDetailTopMap?
                  appDetailTopMap["icon"].toString().contains("url") ? json.decode(appDetailTopMap["icon"])["url"]
                      : (APIs.LOGIN_BASE + (appDetailTopMap["icon"] ?? "")):"")),
              Align(
                alignment: Alignment.topLeft,
                child: Column(
                  crossAxisAlignment: CrossAxisAlignment.start,
                  children: [
                    Padding(
                      padding: const EdgeInsets.only(right: 10, bottom: 5, top: 10),
                      child: Text(
                        null != appDetailTopMap
                            ? appDetailTopMap["name"].toString()
                            : "",
                        style:
                            const TextStyle(color: Color(0xff333333), fontSize: 15),
                      ),
                    ),
                    Padding(
                      padding: const EdgeInsets.only(right: 10),
                      child: Row(
                        children: [
                          GestureDetector(
                            child: Image.asset(
                              appDetailTopMap["isCollection"] !=
                                          null &&
                                  appDetailTopMap["isCollection"]
                                  ? "images/ic_colll.png"
                                  : "images/ic_uncoll.png",
                              width: 15,
                              height: 15,
                            ),
                            onTap: () {
                              if (appDetailTopMap["isCollection"] != null &&
                                  appDetailTopMap["isCollection"]) {
                                //点击收藏
                                getUnColl();
                              } else {
                                getColl();
                              }
                            },
                          ),
                          Padding(
                            padding: const EdgeInsets.only(right: 10,left: 10),
                            child: Text(
                              appDetailTopMap != null
                                  ? "${appDetailTopMap["collectionNum"].toString()} 收藏"
                                  : "${0} 收藏",
                              style: const TextStyle(
                                  fontSize: 12, color: Color(0xff999999)),
                            ),
                          ),
                        ],
                      ),
                    )
                  ],
                ),
              ),
            ],
          ),
          Padding(
            padding: const EdgeInsets.only(left: 10, top: 10),
            child: GestureDetector(
                child: Image.asset(
                  "images/ic_send.png",
                  width: 59,
                  height: 36,
                ),
                onTap: () async {
                  HttpUtils.postJSON(context, APIs.checkRight,
                      {"appId": id, "token": await Global.getData("token")}, success: (data) async {
                        setState(() async {
                          if(data["isRight"]){
                            Global.openUrl(context,"/IfarmeAffair?id=${id}&get=mobile&token=${await Global.getData("token")}&hasSingle=${appDetailMap["hasSingle"]}");
                            // Global.openUrl(context,"/IfarmeAffair?id=${id}&get=mobile&token=${token}",false,3,(map){
                            //   setState(() {
                            //     if(map.toString()=="null"){
                            //       Navigator.of(context).pop();
                            //     }else{
                            //       if(map["canshu"]=="save"){
                            //         setState(() {
                            //           // Navigator.of(context).pop();
                            //           // getWait("", "", "");
                            //         });
                            //       }else if(map["canshu"]=="caogao"){
                            //         Navigator.of(context).pop();
                            //       }
                            //
                            //     }
                            //   });
                            // });

                          }else{

                            Toasts.showToast(data["info"]);
                          }
                        });
                      }, fail: (code, msg) {});
                }),
          )
        ],
      ),
      const Padding(
        padding: EdgeInsets.only(top: 15, left: 15, bottom: 5),
        child: Text.rich(
          TextSpan(children: [
            TextSpan(
                text: "备注:",
                style: TextStyle(color: Colors.blue, fontSize: 14)),
            TextSpan(
               text: " 暂无",
              // text: map["remark"] ?? " 无",
                // text: null != _appDetailTopEntity
                //     ? _appDetailTopEntity?.remark
                //     : "",
                style: TextStyle(color: Colors.black, fontSize: 14)),
          ]),
        ),
      ),
      Container(
        margin: const EdgeInsets.only(top: 10),
        width: double.infinity,
        height: 15,
        color: const Color(0xffF5F5F5),
      ),
      GestureDetector(
        child: Container(
            padding: const EdgeInsets.only(left: 15, right: 15, top: 20, bottom: 20),
            alignment: Alignment.topLeft,
            child: Row(
              mainAxisAlignment: MainAxisAlignment.spaceBetween,
              children: [
                const Text(
                  "查看办事流程",
                  style: TextStyle(
                      color: Color(0xff333333),
                      fontSize: 14,
                      fontWeight: FontWeight.bold),
                ),
                Image.asset(
                  "images/ic_right.png",
                  width: 15,
                  height: 15,
                )
              ],
            )),
        onTap: () {
          Navigator.push(context, MaterialPageRoute(builder: (context) {
            return AppDetailImg(id);
          }));
        },
      ),
      Container(
          margin: const EdgeInsets.only(left: 15, right: 15),
          width: double.infinity,
          height: 1,
          color: HexColor("#E5E5E5")
//        color: Color(#E5E5E5),
          ),
      appDetailMap["helpContent"]==null?const Text(""):GestureDetector(
        child: Container(
            padding: const EdgeInsets.only(left: 15, right: 15, top: 20, bottom: 20),
            alignment: Alignment.topLeft,
            child: Row(
              mainAxisAlignment: MainAxisAlignment.spaceBetween,
              children: [
                const Text(
                  "查看办事指南",
                  style: TextStyle(
                      color: Color(0xff333333),
                      fontSize: 14,
                      fontWeight: FontWeight.bold),
                ),
                Image.asset(
                  "images/ic_right.png",
                  width: 15,
                  height: 15,
                )
              ],
            )),
        onTap: () {
          // getAppDetailZN(id);
          Navigator.push(context, MaterialPageRoute(builder: (context) {
            return AppDetailWeb(appDetailMap["helpContent"],"办事指南");
          }));
        },
      ),
      Container(
        margin: const EdgeInsets.only(top: 1),
        width: double.infinity,
        height: 15,
        color: const Color(0xffF5F5F5),
      ),
    ]);
  }

  void getAppDetailZN(String id) async {
    Global.openUrl(context,"/h5View/ZlDetail?id=$id&token=${await Global.getData("token")}");
  }

  Widget getList(Map appDetailRow) {
    // print(appDetailRow.toString());

    return Column(
      children: [
        Container(
          padding: const EdgeInsets.only(left: 15, right: 15, top: 10, bottom: 10),
          color: const Color(0xffF5F5F5),
        ),
        Stack(
          children: [
            Row(
              children: [
                Container(
                    margin: const EdgeInsets.only(left: 15, right: 15, top: 15),
                    child: CircleAvatar(
                      backgroundImage: NetworkImage(appDetailRow["userHeader"] ==
                              null
                          ? ""
                          : json
                              .decode(appDetailRow["userHeader"])["downloadUrl"]),
                    )),
                Align(
                  alignment: Alignment.topLeft,
                  child: Column(
                    crossAxisAlignment: CrossAxisAlignment.start,
                    children: [
                      Container(
                        padding: const EdgeInsets.only(right: 10, bottom: 5, top: 10),
                        child: Text(
                          appDetailRow["userName"],
                          style:
                              const TextStyle(color: Color(0xff333333), fontSize: 15),
                        ),
                      ),
                      Container(
                          width: 200,
                          padding: const EdgeInsets.only(right: 10),
                          // child: Text("${ZyDateUtils.getDateYMd(appDetailRow["createTime"])}-${ZyDateUtils.getDateYMd(appDetailRow["statusName"])}",
                          // child: Text("${TimeUtils.timestampToDateStr(appDetailRow["createTime"], true)}-${TimeUtils.timestampToDateStr(appDetailRow["createTime"], true)}",
                          child: Text(TimeUtils.timestampToDateStr(appDetailRow["createTime"], true),
                            // ZyDateUtils.instance.getFormartData(
                            //         timeSamp: appDetailRow["createTime"],
                            //         format: "yyyy-MM-dd HH:mm:ss") +
                            //     "-" +
                            //     appDetailRow["statusName"],
                            style: const TextStyle(
                                color: Color(0xff999999), fontSize: 11),
                          ))
                    ],
                  ),
                )
              ],
            ),
            setStatus(appDetailRow["currentHandleInfo"])
           // setStatus("已回退")
          ],
        ),
        Row(
          children: [
            Padding(
              padding: const EdgeInsets.only(left: 15, right: 5, top: 15),
              child: Container(
                padding:
                    const EdgeInsets.only(left: 10, right: 10, top: 5, bottom: 5),
                color: HexColor(appDetailRow["formColor"]),
//                color: Colors.blue,
                child: Text(
                  appDetailRow["formLevel"],
                  style: const TextStyle(color: Colors.white),
                ),
              ),
            ),
            Padding(
                padding: const EdgeInsets.only(right: 15, top: 15),
                child: Text(
                  "${appDetailRow["appName"]}(${appDetailRow["code"]})",
                  style: const TextStyle(fontSize: 14, color: Color(0xff666666)),
                )),
          ],
        ),
        GestureDetector(
          child: Container(
            color: const Color(0xffF5F5F5),
            margin: const EdgeInsets.only(left: 15, right: 15, top: 10),
            padding: const EdgeInsets.only(left: 15, right: 15, top: 10, bottom: 10),
            alignment: Alignment.topLeft,
            child: getContent(appDetailRow),
          ),
          onTap: () {
            Navigator.push(context, MaterialPageRoute(builder: (context) {
              return AppDetailProgress(appDetailRow["id"],appDetailRow["currentHandleInfo"]);
            }));
          },
        ),
        getDethContent(appDetailRow),
        Container(
          margin: const EdgeInsets.only(top: 10),
          width: double.infinity,
          height: 0.5,
          color: const Color(0xffE5E5E5),
        ),
        Row(
          children: [
            Expanded(
              flex: 1,
              child: Container(
                alignment: Alignment.center,
//                padding:
//                    EdgeInsets.only(top: 10, bottom: 10),
                child: GestureDetector(
                  child: const Text(
                    "查看申请",
//                    textAlign: TextAlign.center,
//                    overflow: TextOverflow.ellipsis,
                    style: TextStyle(color: Color(0xff666666), fontSize: 13),
//                    style: TextStyle(color: Color(0xff666666)),
                  ),
                  onTap: () async {
                    if (clickindex == 3) {
                      getToken(id, appDetailRow["id"]);
                    } else {
                      // Global.openUrl(context,"/IfarmeAffairDetail?id=${appDetailRow.id}&get=mobile&token=${token}");
                      Global.openUrl(context,"/IfarmeAffairDetail?id=${appDetailRow["id"]}&token=${await Global.getData("token")}");
                    }
                  },
                ),
              ),
            ),
            Container(
              margin: const EdgeInsets.only(top: 10, bottom: 10),
              width: 1,
              height: 20,
              color: Color(0xffE5E5E5),
            ),
            clickindex == 2||appDetailRow["currentHandleResult"]=="已撤回"
                ? const Text("")
                : Expanded(
                    flex: 1,
                    child: Container(
                      alignment: Alignment.center,
//                      padding: EdgeInsets.only(right: 5, top: 10, bottom: 5),
                      child: GestureDetector(
                        child: const Text(
                          "...更多操作",
//                          style: TextStyle(color: Color(0xff666666), fontSize: 11),
                          style: TextStyle(color: Color(0xff666666)),
                        ),
                        onTap: () {
                          showModalBottomSheet(
                            context: context,
                            builder: (BuildContext context) {
                              return Container(
                                  height: 170.0,
                                  child: Column(
                                    mainAxisAlignment:
                                        MainAxisAlignment.spaceBetween,
                                    children: [
                                      Row(
                                        children: getPopu(
                                            appDetailRow["statusId"],
                                            appDetailRow["taskId"],
                                            appDetailRow["id"],
                                            context,appDetailRow["isBack"]),
                                      ),
                                      Container(
                                        color: const Color(0xffF5F5F5),
                                        width: double.infinity,
                                        height: 10,
                                      ),
                                      Container(
                                        padding: const EdgeInsets.only(
                                            bottom: 20, top: 10),
                                        child: GestureDetector(
                                          child: const Text("取消"),
                                          onTap: () {
                                            Navigator.pop(context);
                                            //发送验证码的点击事件
                                          },
                                        ),
                                      ),
                                    ],
                                  ));
                            },
                          );
                        },
                      ),
                    ),
                  )
          ],
        )
      ],
    );
  }

  Widget getDethContent(Map appDetailRow) {
    if (clickindex == 2) {
      return Container(
        color: const Color(0xffF5F5F5),
        margin: const EdgeInsets.only(left: 15, right: 15, top: 10),
        padding: const EdgeInsets.only(left: 15, right: 15, top: 10, bottom: 10),
        alignment: Alignment.topLeft,
        child: Row(
          children: [
            const Text(
              "我的处理结果：",
              textAlign: TextAlign.center,
              overflow: TextOverflow.ellipsis,
              style: TextStyle(color: Color(0xff999999), fontSize: 14),
            ),
            Expanded(child: Text(
              (appDetailRow["currentHandleResult"] ?? "暂无"),
              overflow: TextOverflow.ellipsis,
              maxLines: 1,
              style: const TextStyle(color: Color(0xff1278C0), fontSize: 14),
            ))
          ],
        ),
      );
    } else {
      return const Text("");
    }
  }

  Widget getContent(Map appDetailRow) {
    if (appDetailRow["statusId"] == "audited" ||
        appDetailRow["statusId"] == "bad_audited" ||
        appDetailRow["statusId"] == "invalid" ||
        appDetailRow["statusId"] == "termination") {
      return Row(children: [
        const Text(
          "当前环节：",
          style: TextStyle(color: Color(0xff999999), fontSize: 14),
        ),
        Expanded(child: Text(
          (appDetailRow["currentHandleResult"] ?? "暂无"),
          overflow: TextOverflow.ellipsis,
          maxLines: 1,
          style: const TextStyle(color: Color(0xff1278C0), fontSize: 14),
        ))
      ]);
    } else {
      return Row(
        children: [
          const Text(
            "当前环节：",
            style: TextStyle(color: Color(0xff999999), fontSize: 14),
          ),
          Expanded(child: Text(
            (appDetailRow["currentHandleResult"] ?? "暂无"),
            overflow: TextOverflow.ellipsis,
            maxLines: 1,
            style: const TextStyle(color: Color(0xff1278C0), fontSize: 14),
          ))
        ],
      );
    }
  }

  List<Widget> getPopu(
      String status, String id, String ids, BuildContext context,bool isBack) {
    List<Widget> list = [];
    if (clickindex == 0) {
      if(isBack){
        list.add(GestureDetector(
          child: Column(
            children: [
              Padding(
                padding: const EdgeInsets.only(left: 10, top: 10, bottom: 5, right: 10),
                child: Image.asset(
                  "images/ic_popback.png",
                  width: 50,
                  height: 50,
                ),
              ),
              const Padding(
                padding: EdgeInsets.only(left: 10, top: 5, bottom: 10, right: 10),
                child: Text("撤回"),
              ),
            ],
          ),
          onTap: () {
            dilaog(context, id);
          },
        ));
      }else {
        // Toast.toast(context, msg: "当前流程禁止撤回");
      }

//       list.add(GestureDetector(
//         child: Column(
//           children: const [
//             Padding(
//               padding: EdgeInsets.only(left: 10, top: 10, bottom: 5, right: 10),
//               child:
//                   Icon(Iconfont.multiplex, color: Color(0xff1278c0), size: 50),
//             ),
//             Padding(
//               padding: EdgeInsets.only(left: 10, top: 5, bottom: 10, right: 10),
//               child: Text("复用"),
//             ),
//           ],
//         ),
//         onTap: () {
// //            dilaog(context, id);
//           getToken(id, ids);
//         },
//       ));
    } else if (clickindex == 1) {
      list.add(GestureDetector(
        child: const Column(
          children: [
            Padding(
              padding: EdgeInsets.only(left: 10, top: 10, bottom: 5, right: 10),
              child: Icon(Iconfont.handle, color: Color(0xff1278c0), size: 50),
            ),
            Padding(
              padding: EdgeInsets.only(left: 10, top: 5, bottom: 10, right: 10),
              child: Text("处理"),
            ),
          ],
        ),
        onTap: () async {
//          getToken(id, ids);
          final token = await Global.getData("token");
          // Global.openUrl(context,"/IfarmeAffairDetail?id=${ids}&get=mobile&token=${token}");
          Global.openUrl(context,"/IfarmeAffairDetail?id=${ids}&token=${token}");

        },
      ));
    } else if (clickindex == 3) {
      list.add(GestureDetector(
        child: const Column(
          children: [
            Padding(
              padding: EdgeInsets.only(left: 10, top: 10, bottom: 5, right: 10),
              child:
                  Icon(Iconfont.delete, color: Color(0xffff5d5a), size: 50),
            ),
            Padding(
              padding: EdgeInsets.only(left: 10, top: 5, bottom: 10, right: 10),
              child: Text("删除"),
            ),
          ],
        ),
        onTap: () {
          dilaogDelet(context, ids);
        },
      ));
      list.add(GestureDetector(
        child: Column(
          children: const [
            Padding(
              padding: EdgeInsets.only(left: 10, top: 10, bottom: 5, right: 10),
              child: Icon(Iconfont.send, color: Color(0xff1278c0), size: 50),
            ),
            Padding(
              padding: EdgeInsets.only(left: 10, top: 5, bottom: 10, right: 10),
              child: Text("发送")
            ),
          ],
        ),
        onTap: () {
          dilaogSend(context, ids);
        },
      ));
    } else {
      if (status == "in_audit") {
        //这个是每一个itemd的处理状态，是紧急，还是一般
        list.add(GestureDetector(
          child: Column(
            children: [
              Padding(
                padding:
                    const EdgeInsets.only(left: 10, top: 10, bottom: 5, right: 10),
                child: Image.asset(
                  "images/ic_popback.png",
                  width: 50,
                  height: 50,
                ),
              ),
              const Padding(
                padding:
                    EdgeInsets.only(left: 10, top: 5, bottom: 10, right: 10),
                child: Text("撤回"),
              ),
            ],
          ),
          onTap: () {
            dilaog(context, id);
          },
        ));
//         list.add(GestureDetector(
//           child: Column(
//             children: const [
//               Padding(
//                 padding:
//                     EdgeInsets.only(left: 10, top: 10, bottom: 5, right: 10),
//                 child: Icon(Iconfont.multiplex,
//                     color: Color(0xff1278c0), size: 50),
//               ),
//               Padding(
//                 padding:
//                     EdgeInsets.only(left: 10, top: 5, bottom: 10, right: 10),
//                 child: Text("复用"),
//               ),
//             ],
//           ),
//           onTap: () {
// //            dilaog(context, id);
//             getToken(id, ids);
//           },
//         ));
      } else if (status == "in_audit") {
        list.add(GestureDetector(
          child: const Column(
            children: [
              Padding(
                padding:
                    EdgeInsets.only(left: 10, top: 10, bottom: 5, right: 10),
                child:
                    Icon(Iconfont.handle, color: Color(0xff1278c0), size: 50),
              ),
              Padding(
                padding:
                    EdgeInsets.only(left: 10, top: 5, bottom: 10, right: 10),
                child: Text("处理"),
              ),
            ],
          ),
          onTap: () {
            Navigator.pop(context);
            //发送验证码的点击事件
          },
        ));
      }
    }
    return list;
  }

  void getToken(String id, String formid) async {
    // Global.openUrl(context,"/IfarmeAffair?id=${id}&formId=${formid}&get=mobile&token=${token}");
    Global.openUrl(context,"/IfarmeAffair?id=${id}&formId=${formid}&token=${Global.getData("token")}",false,2,(map){
      setState(() {
        if(map["canshu"]=="fuyong"){
          Navigator.of(context).pop();
        }
      });
    });
  }

  //草稿箱发送
  void dilaogSend(widgetContext, String id) {
    showCupertinoDialog(
      context: context,
      builder: (context) {
        return CupertinoAlertDialog(content: const Text('是否确认发送'), actions: [
          CupertinoDialogAction(
            child: const Text(
              '取消',
              style: TextStyle(color: Color(0xff999999), fontSize: 14),
            ),
            onPressed: () {
              Navigator.of(context).pop();
            },
          ),
          CupertinoDialogAction(
            child: const Text(
              '确认',
              style: TextStyle(color: Color(0xff1278C0), fontSize: 14),
            ),
            onPressed: () {
              getSend(id);
              Navigator.of(context).pop();
              Navigator.of(widgetContext).pop();
            },
          ),
        ]);
      },
    );
  }

  void dilaogDelet(widgetContext, String id) {
    showCupertinoDialog(
      context: widgetContext,
      builder: (context) {
        return CupertinoAlertDialog(content: const Text('是否确认删除'), actions: [
          CupertinoDialogAction(
            child: const Text(
              '取消',
              style: TextStyle(color: Color(0xff999999), fontSize: 14),
            ),
            onPressed: () {
              Navigator.of(context).pop();
            },
          ),
          CupertinoDialogAction(
            child: const Text(
              '确认',
              style: TextStyle(color: Color(0xff1278C0), fontSize: 14),
            ),
            onPressed: () {
              getDelet(id);
              Navigator.of(context).pop();
              Navigator.of(widgetContext).pop();
            },
          ),
        ]);
      },
    );
  }

  void dilaog(widgetContext, String id) {
    showCupertinoDialog(
      context: widgetContext,
      builder: (context) {
        return CupertinoAlertDialog(content: const Text('是否确认撤回申请'), actions: [
          CupertinoDialogAction(
            child: const Text(
              '取消',
              style: TextStyle(color: Color(0xff999999), fontSize: 14),
            ),
            onPressed: () {
              Navigator.of(context).pop();
            },
          ),
          CupertinoDialogAction(
            child: const Text(
              '确认',
              style: TextStyle(color: Color(0xff1278C0), fontSize: 14),
            ),
            onPressed: () {

                getBack(id);
                Navigator.of(context).pop();
                Navigator.of(widgetContext).pop();

            },
          ),
        ]);
      },
    );
  }

  void dilaogFail(widgetContext) {
    showCupertinoDialog(
      context: widgetContext,
      builder: (context) {
        return CupertinoAlertDialog(content: const Text('该流程暂不可用,无法发送'), actions: [
          CupertinoDialogAction(
            child: const Text(
              '确认',
              style: TextStyle(color: Color(0xff1278C0), fontSize: 14),
            ),
            onPressed: () {
              Navigator.of(context).pop();
              Navigator.of(widgetContext).pop();
            },
          ),
        ]);
      },
    );
  }

  Widget setStatus(String status) {
    if (clickindex == 1) {
      if (status.isEmpty) {
        return const Text("");
      } else {
        if (status == "待审核" || status == "已指定") {
          return Positioned(
            right: 0,
            top: 0,
            child: Image.asset(
              "images/reviewed.png",
              width: 60,
              height: 60,
            ),
          );
        } else if (status == "已回退") {
          return Positioned(
            right: 0,
            child: Image.asset(
              "images/returned.png",
              width: 60,
              height: 60,
            ),
          );
        } else if (status == "已终止") {
          return Positioned(
            right: 0,
            child: Image.asset(
              "images/terminated.png",
              width: 60,
              height: 60,
            ),
          );
        } else if (status == "已挂起") {
          return Positioned(
            right: 0,
            child: Image.asset(
              "images/suspended.png",
              width: 60,
              height: 60,
            ),
          );
        } else if (status == "已撤销") {
          return Positioned(
            right: 0,
            child: Image.asset(
              "images/rescinded.png",
              width: 60,
              height: 60,
            ),
          );
        } else if (status == "已恢复") {
          return Positioned(
            right: 0,
            child: Image.asset(
              "images/recovered.png",
              width: 60,
              height: 60,
            ),
          );
        } else if (status == "已改派") {
          return Positioned(
            right: 0,
            child: Image.asset(
              "images/reassigned.png",
              width: 60,
              height: 60,
            ),
          );
        } else if (status == "已结束") {
          return Positioned(
            right: 0,
            child: Image.asset(
              "images/itsover.png",
              width: 60,
              height: 60,
            ),
          );
        }
      }
      return const Text("");
    } else {
      return const Text("");
    }
  }
}

class StickyTabBarDelegate extends SliverPersistentHeaderDelegate {
  final Widget child;

  StickyTabBarDelegate({required this.child});

  @override
  Widget build(
      BuildContext context, double shrinkOffset, bool overlapsContent) {
    return Container(
      color: Colors.white,
      child: child,
    );
  }

  @override
  double get maxExtent => 50;

  @override
  double get minExtent => 50;

  @override
  bool shouldRebuild(SliverPersistentHeaderDelegate oldDelegate) {
    return true;
  }
}
