
import 'dart:collection';

import 'package:flutter/material.dart';
import '../Iconfont.dart';
import '../dio/APIs.dart';
import '../dio/HttpUtils.dart';
import '../utils/Global.dart';
import 'AppDetailImg.dart';


class AppDetailProgress extends StatefulWidget {
  String id;
  String start ="";

  AppDetailProgress(this.id,this.start);

  @override
  State<StatefulWidget> createState() {
    return AppDetailProgressState(id,start);
  }
}

class AppDetailProgressState extends State {
  String id = "";
  String start;
  bool isReady = false;
  String  appId = "";//流程图id
  String  nextUsers = "";//下一步審核人

  AppDetailProgressState(this.id,this.start);

  // AppDetailProgressBean _appDetailEntity;
  Map map  = HashMap();

  @override
  void initState() {
    super.initState();
    getTop();
    getId();
  }

  getTop() async {
    HttpUtils.postJSON(context,APIs.Appdetail_progressnew, {
      "id": id,
      "token": await Global.getData("token")
    }, success: (data) async {
      setState(() {
        map = data;
        nextUsers = map["nextUsers"];
        isReady = true;
        // _appDetailEntity = AppDetailProgressBean.fromMap(data);
      });
    }, fail: (code, msg) {});
  }
  getId() async {
    HttpUtils.postJSON(context,APIs.Appdetail_progress, {
      "id": id,
      "token":  await Global.getData("token")
    }, success: (data) async {
      setState(() {
        appId = data["appId"];
        // _appDetailEntity = AppDetailProgressBean.fromMap(data);
      });
    }, fail: (code, msg) {});
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        title: const Text("查看办事记录",style: TextStyle(color: Colors.black),),
        centerTitle: true,
        backgroundColor: Colors.white,
        elevation: 0,
        iconTheme: const IconThemeData(
          color: Color(0xff333333), //修改颜色
        ),
      ),
      body: isReady?Stack(
        children: [
          ListView.builder(
              // physics: new NeverScrollableScrollPhysics(),
              // shrinkWrap: true,
              // itemCount: _appDetailEntity == null
              itemCount:  map["taskInfo"].length,
              itemBuilder: (BuildContext context, int index) {
                // return getList(_appDetailEntity.taskInfo[index],index,_appDetailEntity.taskInfo.length);
                return getList(map["taskInfo"][index],index,map["taskInfo"].length);
              }),
          Positioned(
              right: 10,
              top: 20,
              child: Container(
                  color: Colors.blue,
                  padding:
                  const EdgeInsets.only(left: 10, top: 5, bottom: 5, right: 10),
                  child: GestureDetector(
                    child: const Text(
                      "进度图",
                      style: TextStyle(color: Colors.white, fontSize: 14),
                    ),
                    onTap: () {

                      Navigator.push(context, MaterialPageRoute(builder: (context) {
                        // return AppDetailImg(_appDetailEntity.appId);
                        // return AppDetailImg(map["appId"]);
                        return AppDetailImg(appId);
                        // return AppDetailImg(appId,id);
                      }));
                    },
                  )))
        ],
      ):add(),
    );
  }

  Widget getStatusIcon(int index,int endindex){
    if(index==0){
      return const Icon( Iconfont.over,color: Color(0xff1278c0),size:30);
    }else {
      if(index+1==endindex&&start =="已结束"){
        return const Icon( Iconfont.over,color: Color(0xff1278c0),size:30);
      }else{
        return const Icon( Iconfont.flow,color: Color(0xff1278c0),size:30);
      }
    }
  }

  static String getTimeMM(String a) {
    String stime = a;
    var strtime =
    DateTime.fromMillisecondsSinceEpoch(int.parse(stime));//将拿到的时间戳转化为日期
    var sdatetime = strtime.toLocal().toString();

    return  sdatetime;
  }
  //加载状态
  static Widget add(){
    return Center(
        child: Column(
          mainAxisAlignment: MainAxisAlignment.center,
          children: const [
            Text(
              // '正在加载中...',
              '正在加载中...',
              style: TextStyle(color: Color(0xFF000000), fontSize: 18.0),
            ),
          ],
        ));

  }

  Widget getList(Map mapInfo ,int index,int endindex) {

    return Row(
      crossAxisAlignment: CrossAxisAlignment.start,
      children: [
        Column(
          children: [
            Padding(
              padding: const EdgeInsets.only(left: 10, top: 10, right: 10,bottom: 0),
              // child: Text(ZyDateUtils.instance.getFormartData(
              //     timeSamp: ZyDateUtils.instance.getTimeStap(formartData: mapInfo["startTime"].toString()),
              //     format: "MM-dd")),
              child: Text(getTimeMM(mapInfo["startTime"].toString()).substring(6,10)),
            ),
            Padding(
              padding: EdgeInsets.only(left: 10, right: 10),
              child: Text(getTimeMM(mapInfo["startTime"].toString()).substring(11,19)),
              // child: Text(ZyDateUtils.instance.getFormartData(
              //     timeSamp: ZyDateUtils.instance.getTimeStap(formartData:mapInfo["startTime"].toString()),
              //     format: "HH:mm:ss")),
            ),
          ],
        ),
        Column(
          children: [
            Container(
              color: Color(0xffCCCCCC),
              width: 1,
              height: 10,
            ),
            Padding(
              padding: EdgeInsets.only(left: 10, right: 10),
              child:getStatusIcon(index,endindex) ,
            ),
            Container(
              color: Color(0xffCCCCCC),
              width: 1,
              height: 80,
            )
          ],
        ),
        Column(
          crossAxisAlignment: CrossAxisAlignment.start,
          children: [
            Padding(
              padding: EdgeInsets.only(left: 10, right: 10, top: 10),
              child: Text(
                mapInfo["name"],
                style: TextStyle(color: Color(0xff333333), fontSize: 16),
              ),
            ),
            Padding(
              padding: EdgeInsets.only(left: 10, right: 10, top: 5),
              child: Text(
                  "处理人员：" +
                      ((endindex==(index+1))?nextUsers:mapInfo["assignee"] == null
                          ? "暂无"
                          : mapInfo["assignee"]),
                  style: TextStyle(color: Color(0xff999999), fontSize: 14)),
            ),
            Padding(
              padding: EdgeInsets.only(left: 10, right: 10, top: 5),
              // child: Text("处理结果：" + (mapInfo["status"]==null?"暂无":mapInfo["status"]),
              child: Text("处理结果：" + (mapInfo["status"]??"暂无"),
                  style: TextStyle(color: Color(0xff999999), fontSize: 14)),
            ),
            // Padding(
            //   padding: EdgeInsets.only(left: 10, right: 10, top: 5),
            //   child: Text(
            //       "审核意见：" +
            //           (mapInfo["taskVariable"] == null
            //               ? "暂无"
            //               : mapInfo["reason"] ??
            //               "暂无"),
            //       style: TextStyle(color: Color(0xff999999), fontSize: 14)),
            // ),
          ],
        ),
      ],
    );
  }

}
