
import 'dart:collection';
import 'dart:convert';
import 'package:flutter/material.dart';
import '../Iconfont.dart';
import '../dio/APIs.dart';
import '../dio/HttpUtils.dart';
import '../dio/DioUtils.dart';
import '../utils/Global.dart';
import '../widget/Toast.dart';
class CodeInterface extends StatefulWidget {


  @override
  State<StatefulWidget> createState() {
    return CodeInterfaceState();
  }
}
//更换邮箱界面
class CodeInterfaceState extends State<CodeInterface> {


  final TextEditingController emailController = TextEditingController();
  final TextEditingController emailCodeController = TextEditingController();



  @override
  void initState() {
    super.initState();
  }

  //获取y验证码
  registerSend(String value) async {
    HttpUtils.postJSON(context, APIs.registerSend, {
      "email": value,
      "noNeedToken": true
    }, success: (data) async {
      setState(() {
        if (data["code"] == 200) {

          Toasts.showToast(data["获取成功！"]);
        }else{

          Toasts.showToast(data["msg"]);
        }
      });
    }, type: Type.JSON, fail: (code, msg) {});
  }
  //修改验证码
  update() async {
    Map jsParam = {"email": emailController.text,"verCode":emailCodeController.text};
    String value  = jsonEncode(jsParam);
    HttpUtils.postJSON(
        context, "${APIs.update}?token=${await Global.getData("token")}", {
      "typeKey": 5,
      "content": {"avatar": value}
    }, success: (data) async {
      setState(() {
        Navigator.pop(context);
      });
    }, fail: (code, msg) {}, type: Type.JSON);
  }



  @override
  Widget build(BuildContext context) {
    return Scaffold(

      appBar: AppBar(
        centerTitle: false,
        backgroundColor: Colors.white,
        title: const Text(
          "修改邮箱",
          style: TextStyle(color: Colors.black, fontSize: 18),
        ),
        elevation: 0,
        leading: IconButton(
          icon: const Icon(
            Icons.arrow_back,
            color: Colors.black,
          ),
          onPressed: () {
            Navigator.pop(context);
          },
        ),//标题头阴影  0 为无
      ),
      backgroundColor: Colors.white,
      body: Column(
        crossAxisAlignment: CrossAxisAlignment.start,
        children: [


          GestureDetector(
            child: Row(
              children: [
                // Container(
                //     padding: const EdgeInsets.only(left: 30, right: 20, top: 40),
                //     child: Text("邮箱",style: TextStyle(
                //         color: Colors.black, fontSize: Global.getScale(context) *15))
                // ),
                GestureDetector(
                  child: Row(
                    children: [
                      Container(
                          padding: const EdgeInsets.only(left: 30, right: 20, top: 10),
                          child: Text("邮箱",style: TextStyle(
                              color: Colors.black, fontSize: Global.getScale(context) *15))
                      ),
                      // setTextField(phoneController, phone),
                    ],
                  ),
                  onTap: () {},
                ),

                setTextField(emailController, "请输入"),
                // Expanded(flex: 2, child: Container(
                //   margin: const EdgeInsets.only(left: 0, top: 10, right: 20, bottom: 0),
                //   padding: const EdgeInsets.only(left: 0, top: 10, right: 0, bottom: 10),
                //   child: const Padding(
                //       padding: EdgeInsets.only(right: 10),
                //       child: Text(
                //         "请输入",
                //         style: TextStyle(fontSize: 14, color: Color(0xff999999)),
                //       )),
                // )),
                GestureDetector(
                  child: const Text("发送验证码   "),
                  onTap: () {
                  emailController.text.isEmpty?
                  Toasts.showToast("请输入邮箱号"):
                  registerSend(emailController.text);
                },
                ),

              ],
            ),

          ),

          Container(
            margin: const EdgeInsets.only(
                left: 10, top: 20, bottom: 20, right: 10),
            child: Container(
              //边框设置
                decoration: BoxDecoration(
                  //背景
                  color: const Color(0xff00946B),
                  //设置四周圆角 角度
                  borderRadius:
                  const BorderRadius.all(Radius.circular(25.0)),
                  //设置四周边框
                  border: Border.all(
                    width: 1,
                    color: const Color(0xff00946B),
                  ),
                  // width: 1, color: Colors.white70),
                ),
                // margin: const EdgeInsets.only(left: 10, right: 10, bottom: 20),
                padding: const EdgeInsets.all(10),
                width: double.infinity,
                child: GestureDetector(
                  child: const Text(
                    "修 改",
                    style: TextStyle(color: Colors.white),
                    textAlign: TextAlign.center,
                  ),
                  onTap: () {
                    if (emailController.text.isEmpty) {
                      Toasts.showToast("请输入邮箱");
                    } else if (emailCodeController.text.isEmpty) {
                      Toasts.showToast("请输入邮箱验证码");
                    }else {
                      update();
                    }
                  },
                )),
          )
        ],
      ),
    );
  }
  //右侧输入框
  static Widget setTextField(
      TextEditingController phoneController, String content) {
    if (content != "请输入") {
      phoneController.text = content;
    }
    return Expanded(
        flex: 1,
        child: Container(
            width: double.infinity,
            margin: const EdgeInsets.only(left: 20, top: 0),
            child:Container(
              width: double.infinity,
              margin: const EdgeInsets.only(left: 0, top: 0, right: 20, bottom: 0),
              child: TextField(
                keyboardType: TextInputType.number, //数字键盘
                maxLines: 1,
                controller: phoneController,
                decoration: InputDecoration(
                    hintText: content,
                    border: InputBorder.none,
                    hintStyle: const TextStyle(color: Color(0xff999999), fontSize: 14)),
              ),
            )
        )
    );

  }
}
