import 'dart:collection';
import 'dart:convert';

import 'package:event_bus/event_bus.dart';
import 'package:flutter/material.dart';
import 'package:intl/intl.dart';
import 'package:pull_to_refresh/pull_to_refresh.dart';
import 'package:textileclothing/Iconfont.dart';
import 'package:textileclothing/User/DesignerAuthentication.dart';
import 'package:textileclothing/User/appnew.dart';
import 'package:textileclothing/utils/Global.dart';
import 'dart:convert' as convert;

import '../dio/APIs.dart';
import '../dio/HttpUtils.dart';
import '../dio/DioUtils.dart';
// import 'package:textileclothing/dio/DioUtils.dart';

import '../home/BusContent.dart';
import '../widget/MySmartRefresher.dart';
import '../widget/Toast.dart';
import 'AccountAuthentication.dart';
import 'DesignerInfo.dart';
import 'MyCollection.dart';
import 'Userinfo.dart';
import 'editPassword.dart';

class MyUser extends StatefulWidget {
  @override
  State<StatefulWidget> createState() {
    return UserState();
  }
}

class UserState extends State {
  RefreshController refreshController = RefreshController();
  Map mapinfo = HashMap();
  List<dynamic> listType = [];
  bool isReady = false;
  var bus = EventBus();
  String typeName = APIs.typename;
  Map dataMap = HashMap();

  void _onRefresh() async {
    isReady = false;
    getRole();
    getMyInfo();
    getSqlColumn();
  }
  //个人信息
  getMyInfo() async {
    // final token = await Global.getData("token");
    HttpUtils.postJSON(
        context,
        "${APIs.Myinfo_Info}?token=${await Global.getData("token")}",
        {}, success: (data) async {
      setState(() {
        // isReady = true;
        mapinfo = data["data"];
        // Global.saveData("userTag", mapinfo["userTag"]);
        // Global.saveData("name", mapinfo["nickName"]);
        // Global.saveData("birthday", DateTime.parse(mapinfo["birthDay"]).microsecondsSinceEpoch.toString());
        refreshController.refreshCompleted();
        refreshController.loadComplete();
        // myInfoEntity = MyInfoBean.fromMap(data);
      });
    }, fail: (code, msg) {}, type: Type.JSON);
  }

  getSqlColumn() async {
    Map jsParam = {"timeStemp": "1682579667383"};
    var str = convert.jsonEncode(jsParam);
    HttpUtils.postJSON(context, APIs.getSqlColumn, {
      "json": "IGkDVEMLKCJ",
      "type": "1",
      "token": await Global.getData("token"),
      "param": str,
    }, success: (data) async {
      setState(() {
        isReady = true;
        dataMap = data;
      });
    }, fail: (code, msg) {});
  }


  getRole() async {
    HttpUtils.postJSON(context, APIs.getRole, {
      "sqlKey": "IQKxhORhLAg",
      "random": "0.8727875452060703",
      "token": await Global.getData("token"),
    }, success: (data) async {
      setState(() {
        listType = data;
      });
    }, fail: (code, msg) {});
  }

  void _onLoading() async {
    refreshController.loadComplete();
  }

  @override
  void initState() {
    super.initState();
    getRole();
    getMyInfo();
    getSqlColumn();
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
        backgroundColor: Colors.white70,
        body: Stack(children: [
          //子类
          const Image(
              image: AssetImage("images/backnew.png"), fit: BoxFit.fitWidth),
          // Container(
          //   width: double.infinity,
          // )
          getMyWidget(),

          // MySmartRefresher().getRefresherNo(
          //     refreshController, _onRefresh, _onLoading, getMyWidget(), true)
        ]));
  }

  Widget getMyWidget() {
    if (!isReady) {
      return Global.add();
    } else {
      // print(object)
      return Container(
          alignment: Alignment.topCenter,
          margin: const EdgeInsets.only(top:60),
          child: Column(
            children: [
              Expanded(
                  flex: 4,
                  child: Column(
                    children: [
                      GestureDetector(
                        child: Row(
                          mainAxisAlignment: MainAxisAlignment.spaceBetween,
                          children: [
                            Row(
                              children: [
                                Container(
                                    margin: const EdgeInsets.only(
                                        left: 10, top: 20, right: 5),
                                    child: ClipOval(
                                        child: FadeInImage.assetNetwork(
                                      placeholder: 'images/avatar.png',
                                      image:
                                          Global.getisEmpty(mapinfo["avatar"])
                                              ? ""
                                              : json.decode(
                                                  mapinfo["avatar"])["url"],
                                      width: Global.getScale(context) * 58,
                                      height: Global.getScale(context) * 58,
                                      fit: BoxFit.cover,
                                    ))),
                                Container(
                                  margin: const EdgeInsets.only(
                                    left: 5,
                                    top: 20,
                                  ),
                                  child: Column(
                                    crossAxisAlignment:
                                        CrossAxisAlignment.start,
                                    children: [
                                      Row(children: [
                                        Container(
                                          margin: const EdgeInsets.only(top: 5),
                                          child: Text(mapinfo["realname"],
                                            style: TextStyle(
                                                color: Colors.black,
                                                fontSize:
                                                Global.getScale(context) *
                                                    14),
                                          ),
                                        ),
                                      ],),
                                      Row(children: [
                                        Container(
                                          margin: const EdgeInsets.only(top: 5),
                                          child: Text(mapinfo["account"] ?? "",
                                          // child: Text("账号："+ mapinfo["account"] ?? "",
                                            style: TextStyle(
                                                color: Colors.black,
                                                fontSize:
                                                Global.getScale(context) *
                                                    14),
                                          ),
                                        ),
                                        Container(
                                            margin: const EdgeInsets.only(left: 8,top: 10),
                                            decoration: BoxDecoration(
                                              gradient: const LinearGradient(
                                                  colors: [
                                                    Color(0xffFFB932),
                                                    Color(0xffFFD632)
                                                  ]),
                                              //设置渐变色
                                              color: Colors.white,
                                              //背景
                                              borderRadius:
                                              const BorderRadius.all(
                                                  Radius.circular(25.0)),
                                              //设置四周圆角 角度
                                              border: Border.all(
                                                  width: 1,
                                                  color:  const Color(0xffFFB932)), //设置四周边框Colors.white70
                                            ),
                                            child: Container(
                                              margin: const EdgeInsets.only(
                                                  left: 10,
                                                  top: 2,
                                                  right: 10,
                                                  bottom: 2),
                                              child: Text(typeName,
                                                style: TextStyle(
                                                    height: 1.6,
                                                    color: Colors.black,
                                                    fontSize:
                                                    Global.getScale(context) *
                                                        11),
                                              ),
                                            ))
                                      ],)

                                    ],
                                  ),
                                ),
                              ],
                            ),
                            Container(
                                margin: const EdgeInsets.only(
                                    top: 20, left: 10, bottom: 10, right: 20),
                                //边框设置
                                decoration: BoxDecoration(
                                  //背景
                                  // color: Colors.white,
                                  //设置四周圆角 角度
                                  borderRadius: const BorderRadius.all(
                                      Radius.circular(25.0)),
                                  //设置四周边框
                                  border: Border.all(
                                      width: 1, color: Colors.white70),
                                ),
                                child: Row(
                                    children: [
                                  Container(
                                      margin: const EdgeInsets.only(
                                          top: 5, left: 10, bottom: 5),
                                      child: const Image(
                                          image:
                                              AssetImage('images/switchnew.png'),
                                          height: 18,
                                          width: 18)),
                                  Container(
                                      margin: const EdgeInsets.only(
                                          right: 10,
                                          top: 5,
                                          left: 5,
                                          bottom: 5),
                                      child: Text("切换身份",
                                          style: TextStyle(
                                              color: Colors.black,
                                              fontSize:
                                                  Global.getScale(context) *
                                                      13)))
                                ]))
                          ],
                        ),
                        onTap: () {
                          Global.showMyDialogWithListView(listType, context,
                              (type) {
                            setState(() {
                              APIs.typename = type;
                              typeName = APIs.typename ;
                              Global.eventBus.fire(type);
                            });
                          });
                        },
                      ),
                      GestureDetector(
                        child: Container(
                            height: Global.getScale(context) * 70,
                            alignment: Alignment.center,
                            margin: const EdgeInsets.only(
                                left: 15, right: 15, top: 50),
                            child: const Image(
                                image: AssetImage("images/attestation.png"))),
                        onTap: () {
                          Navigator.push(context,
                              MaterialPageRoute(builder: (context) {
                            return const AccountAuthentication();
                          }));
                        },
                      ),
                      GestureDetector(
                        behavior: HitTestBehavior.opaque,
                        child: getContainer("账号信息", "images/myimg.png"),
                        onTap: () {
                          Navigator.push(context,
                              MaterialPageRoute(builder: (context) {
                                return  Userinfo();
                              }));
                        },
                      ),
                      Global.getPartingLine(),
                      typeName == "普通用户"? Container():
                      // aaa(false):aaa(true),
                      GestureDetector(
                        behavior: HitTestBehavior.opaque,
                        child: getTypeName(),
                        onTap: () async {
                          if (typeName == "企业用户") {
                            if (dataMap["brandConfigure"][0]["isCertified"] ==
                                0 &&
                                dataMap["brandConfigure"][0]
                                ["isExistingProcess"] ==
                                    0) {
                              //未认证——发起页面——id:map["appId"]
                              Toasts.showToast("暂未认证，请先去认证！");
                            } else {
                              Global.appUrl(context,
                                  "/IfarmeAffair?id=${dataMap["brandConfigure"][0]["modifyAppId"]}&isFlow=false&token=${await Global.getData("token")}");
                            }
                            // Navigator.push(context, MaterialPageRoute(builder: (context) {
                            //   return  DesignerInfo();
                            // }));
                          } else if (typeName == "设计师用户") {
                            if (dataMap["designerConfigure"][0]
                            ["isCertified"] ==
                                0 &&
                                dataMap["designerConfigure"][0]
                                ["isExistingProcess"] ==
                                    0) {
                              //未认证——发起页面——id:map["appId"]
                              Toasts.showToast("暂未认证，请先去认证！");
                            } else {
                              Global.appUrl(context,
                                  "/IfarmeAffair?id=${dataMap["designerConfigure"][0]["modifyAppId"]}&isFlow=false&token=${await Global.getData("token")}");
                            }
                          } else if (typeName == "工厂用户") {
                            if (dataMap["factoryConfigure"][0]["isCertified"] ==
                                0 &&
                                dataMap["factoryConfigure"][0]
                                ["isExistingProcess"] ==
                                    0) {
                              //未认证——发起页面——id:map["appId"]
                              Toasts.showToast("暂未认证，请先去认证！");
                            } else {
                              Global.appUrl(context,
                                  "/IfarmeAffair?id=${dataMap["factoryConfigure"][0]["modifyAppId"]}&isFlow=false&token=${await Global.getData("token")}");
                            }
                          }
                        },
                      ),
                      typeName == "普通用户"?Container():Global.getPartingLine(),
                      GestureDetector(
                        behavior: HitTestBehavior.opaque,
                        child: getContainer("账号密码", "images/account.png"),
                        onTap: () {
                          Navigator.push(context,
                              MaterialPageRoute(builder: (context) {
                                return editPassword(mapinfo["account"]);
                              }));
                        },
                      ),
                      Global.getPartingLine(),
                      GestureDetector(
                          behavior: HitTestBehavior.opaque,
                          child: getContainer("我的收藏", "images/collect.png"),
                          onTap: () {
                            Navigator.push(context,
                                MaterialPageRoute(builder: (context) {
                                  return const MyCollection();
                                }));
                          }),
                      Global.getPartingLine(),
                      GestureDetector(
                          behavior: HitTestBehavior.opaque,
                          child: getContainer("我的应用", "images/application.png"),
                          onTap: () {
                            Navigator.push(context,
                                MaterialPageRoute(builder: (context) {
                                  return  appnew();
                                }));
                          }),
                      Global.getPartingLine(),
                    ],
                  )),
            ],
          ));
    }
  }

  Widget getTypeName() {
    if (typeName == "企业用户") {
      return getContainer("企业基本信息", "images/info.png");
    } else if (typeName == "设计师用户") {
      return getContainer("设计师基本信息", "images/info.png");
    } else if (typeName == "工厂用户"){
      return getContainer("工厂基本信息", "images/info.png");
    }else{
      return const Text("");
    }
  }

  Widget getContainer(String name, String img) {
    return Row(
      mainAxisAlignment: MainAxisAlignment.spaceBetween,
      children: [
        Container(
          margin: const EdgeInsets.only(left: 20, top: 20),
          child: Row(
            children: [
              Container(
                margin: const EdgeInsets.only(right: 10),
                child: Image(
                  image: AssetImage(img),
                  width: 20,
                  height: 20,
                ),
                // child: const Icon(Iconfont.topicSet,
                //     color: Color(0xff333333), size: 20),
              ),
              Text(
                name,
                style: const TextStyle(
                    fontSize: 14,
                    color: Color(0xff333333),
                    fontWeight: FontWeight.bold),
              )
            ],),),
        Container(
          margin: const EdgeInsets.only(left: 20, top: 20, right: 20),
          child:
          // const Row(
          //   children: [
              const Icon(
                Icons.arrow_forward_ios,
                size: 20.0,
                color: Color(0xff999999),
              )
            // ],
          // ),
        )
      ],
    );
  }
}
