import 'dart:collection';
import 'dart:convert';
import 'package:dio/dio.dart';
import 'package:event_bus/event_bus.dart';
import 'package:flutter/foundation.dart';
import 'package:flutter/services.dart';
import 'package:image_picker/image_picker.dart';
import 'package:intl/intl.dart';

// import 'package:textileclothing/Login/presenter/LoginPresenter.dart';
import 'package:textileclothing/utils/Global.dart';

// import 'package:image_picker/image_picker.dart';
import 'package:flutter/material.dart';
import 'package:textileclothing/Login/BaseLogin.dart';

// import 'package:textileclothing/bean/home/BusContent.dart';
import 'package:textileclothing/dio/APIs.dart';
import 'package:textileclothing/dio/HttpUtils.dart';

// import 'package:textileclothing/tools/JhPickerTool.dart';
import 'package:textileclothing/dio/DioUtils.dart';
import 'package:toast/toast.dart';
import 'package:zhiyong_plugin/zhiyong_plugin.dart';

import '../main.dart';
import '../widget/Toast.dart';
import 'CodeInterface.dart';

class Userinfo extends StatefulWidget {

  @override
  State<StatefulWidget> createState() {
    return UserinfoState();
  }
}

class UserinfoState extends State {
  Map mapinfo = HashMap();
  bool isLoading = false;

  // final TextEditingController _unameController = TextEditingController();
  final TextEditingController unameController = TextEditingController();
  // final TextEditingController _passwordController = TextEditingController();
  // final TextEditingController _passwordController1 = TextEditingController();
  final TextEditingController phoneController = TextEditingController();
  // final TextEditingController emailController = TextEditingController();
  // final TextEditingController emailCodeController = TextEditingController();



  String name = "请输入"; //昵称
  String phone = "请输入"; //手机号码
  String mailbox = "请输入"; //邮箱


  String sex = "请选择";//性别
  String mingzu = "请选择";//民族
  String birthday = "请选择";//生日
  Map sexMap = HashMap();
  Map mzMap = HashMap();
  int sexIndex = -1;
  int mzIndex = -1;


  @override
  void initState() {
    super.initState();
    getMyInfo();

    getSexList("XB");
    getSexList("MZ");
  }

  @override
  void deactivate() {
    super.deactivate();
    // var bool = ModalRoute.of(context)?.isCurrent;
    // if (bool) {
    // getMyInfo();
    // }
  }

  //获取性别
  getSexList(String value) async {
    HttpUtils.postJSON(context, APIs.getSex, {
      "appCode": "uia",
      "key": value,
      "noNeedToken": true
    }, success: (data) async {
      setState(() {
        if (value.contains("XB")) {
          sexMap = data;
        } else if (value.contains("MZ")) {
          mzMap = data;
        }
      });
    }, type: Type.JSON, fail: (code, msg) {});
  }



  //更新头像
  getUpFile(List<int> imageData, String name) async {
    MultipartFile multipartFile = MultipartFile.fromBytes(
      imageData,
      filename: name,
    );
    // FormData formData = FormData.fromMap({"uploadFile":await MultipartFile.fromFile(//这里记得加awaitpath, filename: name, contentType:MediaType('image',suffix) ), });
    // BaseOptions option = BaseOptions(
    //     contentType: 'image/png', responseType: ResponseType.plain);
    FormData formData = FormData.fromMap({"file": multipartFile});
    Dio dio = Dio();
    var response = await dio.post(
        "${APIs.My_UpFile}?token=${await Global.getData("token")}",
        data: formData);
    if (response.statusCode == 200) {
      upAvaerhttp(jsonEncode(response.data["data"]));
    } else {}

    return;
  }

  // upAvaerhttp(String avater,String id) async {
  //   HttpUtils.postJSON(context, APIs.My_UpAvaer, {
  //     "uaaUserId": id,
  //     // "avatar": {"avatar": avater}
  //     "avatar": avater
  //   }, success: (data) async {
  //     setState(() {
  //       bus.fire(BusContent(1));
  //       getMyInfo();
  //     });
  //   }, fail: (code, msg) {}, type: Type.FORM);
  // }

  upAvaerhttp(String avater) async {
    // String token = await Global.getData("token");
    HttpUtils.postJSON(
        context, "${APIs.My_UpAvaer}?token=${await Global.getData("token")}", {
      "typeKey": 1,
      "content": {"avatar": avater}
    }, success: (data) async {
      setState(() {
        getMyInfo();
      });
    }, fail: (code, msg) {}, type: Type.JSON);
  }

  //更新个人信息
  getEditInfo(int type, String key, String data) async {
    // String token = await Global.getData("token");
    HttpUtils.postJSON(
        context, "${APIs.My_EditPass}?token=${await Global.getData("token")}", {
      "typeKey": type,
      "content": {key: data}
    }, success: (data) async {
      setState(() {
        // baseBeanEntity = BaseBean.fromMap(data);
        if (data["code"] == "0") {
          Toasts.showToast("操作成功");
          getMyInfo();
        }
      });
    }, fail: (code, msg) {}, type: Type.JSON);
  }

  //个人信息
  getMyInfo() async {
    // String token = await Global.getData("token");
    HttpUtils.postJSON(
        context,
        "${APIs.Myinfo_Info}?token=${await Global.getData("token")}",
        {"token": await Global.getData("token")}, success: (data) async {
      setState(() {
         isLoading = true;
        mapinfo = data["data"];

      });
    }, fail: (code, msg) {}, type: Type.JSON);
  }

  @override
  Widget build(BuildContext context) {
    return isLoading?Scaffold(
        appBar: AppBar(
          centerTitle: false,
          backgroundColor: Colors.white,
          title: const Text(
            "个人信息",
            style: TextStyle(color: Colors.black, fontSize: 18),
          ),
          elevation: 0,
          leading: IconButton(
            icon: const Icon(
              Icons.arrow_back,
              color: Colors.black,
            ),
            onPressed: () {
              Navigator.pop(context);
            },
          ), //标题头阴影  0 为无
        ),
        // backgroundColor: Colors.white,
        body: mapinfo["userTag"]=="student"?setInfo():setInfoStudent()
    ):Global.add();
  }

  Widget setInfo(){
    return SingleChildScrollView(
      child: Container(
          alignment: Alignment.topCenter,
          color: Colors.white,
          padding: const EdgeInsets.only(top: 40),
          child: Column(
            children: [
              //头像
              GestureDetector(
                child: Row(
                  mainAxisAlignment: MainAxisAlignment.spaceBetween,
                  children: [
                    Container(
                      margin: const EdgeInsets.only(left: 20, top: 20),
                      child: const Row(
                        children: [
                          Text(
                            "头像",
                            style: TextStyle(
                                fontSize: 14, color: Color(0xff333333)),
                          )
                        ],
                      ),
                    ),
                    Container(
                      margin: const EdgeInsets.only(
                          left: 20, top: 20, right: 20),
                      child: Row(
                        children: [
                          FadeInImage.assetNetwork(
                            placeholder: 'images/avatar.png',
                            image: mapinfo["avatar"] == null ||
                                mapinfo["avatar"] == ""
                                ? ""
                                : json.decode(mapinfo["avatar"])["url"],
                            width: 50,
                            height: 50,
                            fit: BoxFit.cover,
                          ),
                          const Icon(
                            Icons.arrow_forward_ios,
                            color: Color(0xff999999),
                          )
                        ],
                      ),
                    )
                  ],
                ),
                onTap: () {
                  showModalBottomSheet(
                    context: context,
                    builder: (BuildContext context) {
                      return SizedBox(
                          height: 160.0,
                          child: Column(
                            mainAxisAlignment:
                            MainAxisAlignment.spaceBetween,
                            children: [
                              GestureDetector(
                                child: Container(
                                  padding: const EdgeInsets.only(
                                      bottom: 10, top: 10),
                                  child: const Text("拍照"),
                                ),
                                onTap: () async {
                                  /*    if (kIsWeb) {
                                        final result =
                                            await ImagePickerWeb().getImage();
                                      getUpFile(result.image_memory,result.image_upload.name);
                                      } else {*/
                                  final result = await ImagePicker()
                                      .pickImage(
                                      source: ImageSource.camera);
                                  result?.readAsBytes().then((value) =>
                                      getUpFile(value, result.name));

                                  //}
                                },
                              ),
                              Container(
                                color: const Color(0xffF5F5F5),
                                width: double.infinity,
                                height: 1,
                              ),
                              GestureDetector(
                                  child: Container(
                                    padding: const EdgeInsets.only(
                                        bottom: 10, top: 10),
                                    child: const Text(
                                      "从手机相册选择",
                                      style: TextStyle(
                                          color: Color(0xff1278C0)),
                                    ),
                                  ),
                                  onTap: () async {
                                    Navigator.pop(context);
                                    final result = await ImagePicker()
                                        .pickImage(
                                        source: ImageSource.gallery);
                                    result?.readAsBytes().then((value) =>
                                        getUpFile(value, result.name));
                                  }),
                              Container(
                                color: const Color(0xffF5F5F5),
                                width: double.infinity,
                                height: 10,
                              ),
                              GestureDetector(
                                child: Container(
                                  padding: const EdgeInsets.only(
                                      bottom: 10, top: 10),
                                  child: const Text("取消"),
                                ),
                                onTap: () {
                                  Navigator.pop(context);
                                  //发送验证码的点击事件
                                },
                              ),
                            ],
                          ));
                    },
                  );
                },
              ),
              Container(
                margin: const EdgeInsets.only(left: 20, right: 20, top: 20),
                width: double.infinity,
                height: 0.5,
                color: const Color(0xffE5E5E5),
              ),
              Row(
                //姓名
                mainAxisAlignment: MainAxisAlignment.spaceBetween,
                children: [
                  Container(
                    margin: const EdgeInsets.only(left: 20, top: 20),
                    child: const Row(
                      children: [
                        Text(
                          "姓名",
                          style: TextStyle(
                              fontSize: 14, color: Color(0xff333333)),
                        )
                      ],
                    ),
                  ),
                  Container(
                    margin:
                    const EdgeInsets.only(left: 20, top: 20, right: 20),
                    child: Row(
                      children: [
                        Padding(
                            padding: const EdgeInsets.only(right: 10),
                            child: Text(
                              Global.getisEmpty(mapinfo["realname"])
                                  ? ""
                                  : mapinfo["realname"],
                              // myInfoEntity.data.realname,
                              style: const TextStyle(
                                  fontSize: 14, color: Color(0xff999999)),
                            )),
                      ],
                    ),
                  )
                ],
              ),
              Container(
                margin: const EdgeInsets.only(left: 20, right: 20, top: 20),
                width: double.infinity,
                height: 0.5,
                color: const Color(0xffE5E5E5),
              ),
              //学工学号
              Row(
                mainAxisAlignment: MainAxisAlignment.spaceBetween,
                children: [
                  Container(
                    margin: const EdgeInsets.only(left: 20, top: 20),
                    child: const Row(
                      children: [
                        Text(
                          "账号",
                          style: TextStyle(
                              fontSize: 14, color: Color(0xff333333)),
                        )
                      ],
                    ),
                  ),
                  Container(
                    margin:
                    const EdgeInsets.only(left: 20, top: 20, right: 20),
                    child: Row(
                      children: [
                        Padding(
                            padding: const EdgeInsets.only(right: 10),
                            child: Text(
                              Global.getisEmpty(mapinfo["account"])
                                  ? ""
                                  : mapinfo["account"],
                              style: const TextStyle(
                                  fontSize: 14, color: Color(0xff999999)),
                            )),
                      ],
                    ),
                  )
                ],
              ),
              Container(
                margin: const EdgeInsets.only(left: 20, right: 20, top: 20),
                width: double.infinity,
                height: 0.5,
                color: const Color(0xffE5E5E5),
              ),
              //部门院系
              Row(
                mainAxisAlignment: MainAxisAlignment.spaceBetween,
                children: [
                  Container(
                    margin: const EdgeInsets.only(left: 20, top: 20),
                    child: const Row(
                      children: [
                        Text(
                          "民族",
                          style: TextStyle(
                              fontSize: 14, color: Color(0xff333333)),
                        )
                      ],
                    ),
                  ),
                  Container(
                    margin:
                    const EdgeInsets.only(left: 20, top: 20, right: 20),
                    child: Row(
                      children: [
                        Padding(
                            padding: const EdgeInsets.only(right: 10),
                            child: Text(
                              Global.getisEmpty(mapinfo["nationName"])
                                  ? ""
                                  : mapinfo["nationName"],
                              style: const TextStyle(
                                  fontSize: 14, color: Color(0xff999999)),
                            )),
                      ],
                    ),
                  )
                ],
              ),
              Container(
                margin: const EdgeInsets.only(left: 20, right: 20, top: 20),
                width: double.infinity,
                height: 0.5,
                color: const Color(0xffE5E5E5),
              ),
              //生日
              GestureDetector(
                child: Row(
                  mainAxisAlignment: MainAxisAlignment.spaceBetween,
                  children: [
                    Container(
                      margin: const EdgeInsets.only(left: 20, top: 20),
                      child: const Row(
                        children: [
                          Text(
                            "生日",
                            style: TextStyle(
                                fontSize: 14, color: Color(0xff333333)),
                          )
                        ],
                      ),
                    ),
                    Container(
                      margin: const EdgeInsets.only(
                          left: 20, top: 20, right: 20),
                      child: Row(
                        children: [
                          Padding(
                              padding: const EdgeInsets.only(right: 10),
                              child: Text(
                                Global.getisEmpty(mapinfo["birthDay"])
                                    ? "无"
                                    : mapinfo["birthDay"],
                                style: const TextStyle(
                                    fontSize: 14, color: Color(0xff999999)),
                              )),
                          // const Icon(
                          //   Icons.arrow_forward_ios,
                          //   color: Color(0xff999999),
                          // )
                        ],
                      ),
                    )
                  ],
                ),
                onTap: () {
//                       JhPickerTool.showDatePicker(context,
//                           dateType: DateType.YMD,
//                           minValue: DateTime(1980, 10, 10),
//                           maxValue: DateTime(2023, 10, 10),
// //                            value: DateTime(2020, 10, 10),
//                           clickCallback: (var str, var time) {
//                         getEditInfo(2, "birthDay",
//                             time.millisecondsSinceEpoch.toString());
//                       });
                },
              ),

              Container(
                margin: const EdgeInsets.only(left: 20, right: 20, top: 20),
                width: double.infinity,
                height: 0.5,
                color: const Color(0xffE5E5E5),
              ),
              //手机号
              GestureDetector(
                child: Row(
                  mainAxisAlignment: MainAxisAlignment.spaceBetween,
                  children: [
                    Container(
                      margin: const EdgeInsets.only(left: 20, top: 20),
                      child: const Row(
                        children: [
                          Text(
                            "性别",
                            style: TextStyle(
                                fontSize: 14, color: Color(0xff333333)),
                          )
                        ],
                      ),
                    ),
                    Container(
                      margin: const EdgeInsets.only(
                          left: 20, top: 20, right: 20),
                      child: Row(
                        children: [
                          Padding(
                              padding: const EdgeInsets.only(right: 10),
                              child: Text(
                                Global.getisEmpty(mapinfo["sexName"])
                                    ? "无"
                                    : mapinfo["sexName"],
                                style: const TextStyle(
                                    fontSize: 14, color: Color(0xff999999)),
                              )),
                          // const Icon(
                          //   Icons.arrow_forward_ios,
                          //   color: Color(0xff999999),
                          // )
                        ],
                      ),
                    )
                  ],
                ),
                onTap: () {
                  // Navigator.push(context,
                  //     MaterialPageRoute(builder: (context) {
                  //   return BindUserData(0);
                  // }));
                },
              ),
              Container(
                margin: const EdgeInsets.only(left: 20, right: 20, top: 20),
                width: double.infinity,
                height: 0.5,
                color: const Color(0xffE5E5E5),
              ),
              //邮箱
              GestureDetector(
                child: Row(
                  mainAxisAlignment: MainAxisAlignment.spaceBetween,
                  children: [
                    Container(
                      margin: const EdgeInsets.only(left: 20, top: 20),
                      child: const Row(
                        children: [
                          Text(
                            "邮箱",
                            style: TextStyle(
                                fontSize: 14, color: Color(0xff333333)),
                          )
                        ],
                      ),
                    ),
                    Container(
                      margin: const EdgeInsets.only(
                          left: 20, top: 20, right: 20),
                      child: Row(
                        children: [
                          Padding(
                              padding: const EdgeInsets.only(right: 10),
                              child: Text(
                                Global.getisEmpty(mapinfo["email"])
                                    ? "无"
                                    : mapinfo["email"],
                                style: const TextStyle(
                                    fontSize: 14, color: Color(0xff999999)),
                              )),
                          // const Icon(
                          //   Icons.arrow_forward_ios,
                          //   color: Color(0xff999999),
                          // )
                        ],
                      ),
                    )
                  ],
                ),
                onTap: () {
                  // Navigator.push(context,
                  //     MaterialPageRoute(builder: (context) {
                  //   return BindUserData(1);
                  // }));
                },
              ),
              Container(
                margin: const EdgeInsets.only(left: 20, right: 20, top: 20),
                width: double.infinity,
                height: 0.5,
                color: const Color(0xffE5E5E5),
              ),

              // Container(
              //   margin: const EdgeInsets.only(left: 10, right: 10, top: 30),
              //   width: double.infinity,
              //   child: MaterialButton(
              //     color: const Color(0xff0076C3),
              //     highlightColor: Colors.blue[700],
              //     colorBrightness: Brightness.dark,
              //     splashColor: Colors.grey,
              //     child: const Text("修改密码"),
              //     onPressed: () {
              //       Navigator.push(context,
              //           MaterialPageRoute(builder: (context) {
              //         return EditPassword("", 2);
              //       }));
              //     },
              //   ),
              // ),

              //手机号
              GestureDetector(
                child: Container(
                  margin: const EdgeInsets.only(
                      left: 10, right: 10, top: 10, bottom: 20),
                  width: double.infinity,
                  child: MaterialButton(
                    color: Color(APIs.themeColors),
                    highlightColor: Colors.blue[700],
                    colorBrightness: Brightness.dark,
                    splashColor: Colors.grey,
                    child: const Text("退出登录"),
                    onPressed: () {
                      Navigator.pushAndRemoveUntil(
                        context,
                        MaterialPageRoute(
                            builder: (context) => BaseLogin()),
                            (route) => route == null,
                      );
                    },
                  ),
                ),
                onTap: () {
                  Navigator.pushAndRemoveUntil(
                    context,
                    MaterialPageRoute(
                        builder: (context) => BaseLogin()),
                        (Route<dynamic> route) => false,
                  );
                },
              ),
            ],
          )),
    );
  }




  //界面内容
  Widget setInfoStudent() {
    return SingleChildScrollView(
      child: Container(
          alignment: Alignment.topCenter,
          child: Column(
            children: [
              GestureDetector(
                child: Row(
                  children: [
                    getTextStyle14("账号"),

                    Container(
                      margin:
                      const EdgeInsets.only(left: 20, top: 20, right: 20),
                      child: Row(
                        children: [
                          Padding(
                              padding: const EdgeInsets.only(right: 10),
                              child: Text(
                                Global.getisEmpty(mapinfo["account"])
                                    ? ""
                                    : mapinfo["account"],
                                style: const TextStyle(
                                    fontSize: 14, color: Color(0xff999999)),
                              )),
                        ],
                      ),
                    ),
                    // setTextField(_unameController, "请输入"),
                  ],
                ),
                onTap: () {},
              ),
              getLine(),
              GestureDetector(
                child: Row(
                  children: [
                    getTextStyle14("昵称"),
                    setTextField(unameController, name),
                  ],
                ),
                onTap: () {},
              ),
              // getLine(),
              // GestureDetector(
              //   child: Row(
              //     children: [
              //       getTextStyle14("密码"),
              //       setTextField(_passwordController, "请输入"),
              //     ],
              //   ),
              //   onTap: () {},
              // ),
              // getLine(),
              // GestureDetector(
              //   child: Row(
              //     children: [
              //       getTextStyle14("确认密码"),
              //       setTextField(_passwordController1, "请输入"),
              //     ],
              //   ),
              //   onTap: () {},
              // ),
              getLine(),
              GestureDetector(
                child: Row(
                  children: [
                    getTextStyle14("手机号"),
                    setTextField(phoneController, phone),
                  ],
                ),
                onTap: () {},
              ),
              getLine(),
              GestureDetector(
                child: Row(
                  children: [
                    getTextStyle14("性别"),
                    Expanded(flex: 2, child: getTextStyle14conent(sex)),
                    const Expanded(
                      flex: 1,
                      child: Icon(
                        Icons.arrow_forward_ios,
                        color: Color(0xff999999),
                      ),
                    )
                  ],
                ),
                onTap: () {
                  showBottomPopu(sexMap, 0);
                },
              ),
              getLine(),
              GestureDetector(
                  child: Row(
                    mainAxisAlignment: MainAxisAlignment.spaceBetween,
                    children: [
                      getTextStyle14("生日"),
                      Expanded(flex: 2, child: getTextStyle14conent(birthday)),
                      Expanded(
                        flex: 1,
                        child: Container(
                            width: 20,
                            height: 20,
                            margin: const EdgeInsets.only(bottom: 2),
                            child: Image.asset(
                              "images/times.png",
                            )),
                      ),
                    ],
                  ),
                  onTap: () {
                    Future<DateTime?> selectedDate = selectDate(context);
                    selectedDate.then((dateTime) {
                      setState(() {
                        // dateTime.
                        birthday = DateFormat('yyyy-MM-dd').format(dateTime!);// as String;//dateTime.toString();
                        print(birthday);
                      });
                    });
                  }

              ),
              getLine(),
              GestureDetector(
                child: Row(
                  children: [
                    getTextStyle14("民族"),
                    Expanded(flex: 2, child: getTextStyle14conent(mingzu)),
                    const Expanded(
                      flex: 1,
                      child: Icon(
                        Icons.arrow_forward_ios,
                        color: Color(0xff999999),
                      ),
                    ),
                  ],
                ),
                onTap: () {
                  showBottomPopu(mzMap, 1);
                },
              ),
              getLine(),
              GestureDetector(
                child: Row(
                  children: [
                    getTextStyle14("邮箱"),
                    Expanded(flex: 2, child: getTextStyle14conent(mailbox)),
                    const Expanded(
                      flex: 1,
                      child: Icon(
                        Icons.arrow_forward_ios,
                        color: Color(0xff999999),
                      ),
                    ),
                    // getTextStyle14("邮箱"),
                    // setTextField(emailController, "请输入"),
                    // const Text("发送验证码"),
                  ],
                ),
                onTap: () {

                  Navigator.push(context,
                      MaterialPageRoute(builder: (context) {
                        return CodeInterface();
                      }));
                  // emailController.text.isEmpty?
                  // Toasts.showToast("请输入邮箱号"):
                  // registerSend(emailController.text);
                },
              ),
              // getLine(),
              // GestureDetector(
              //   child: Row(
              //     children: [
              //       getTextStyle14("邮箱验证码"),
              //       setTextField(emailCodeController, "请输入"),
              //     ],
              //   ),
              //   onTap: () {},
              // ),
              Container(
                margin: const EdgeInsets.only(
                    left: 10, top: 20, bottom: 20, right: 10),
                child: Container(
                  //边框设置
                    decoration: BoxDecoration(
                      //背景
                      color: const Color(0xff00946B),
                      //设置四周圆角 角度
                      borderRadius:
                      const BorderRadius.all(Radius.circular(25.0)),
                      //设置四周边框
                      border: Border.all(
                        width: 1,
                        color: const Color(0xff00946B),
                      ),
                      // width: 1, color: Colors.white70),
                    ),
                    // margin: const EdgeInsets.only(left: 10, right: 10, bottom: 20),
                    padding: const EdgeInsets.all(10),
                    width: double.infinity,
                    child: GestureDetector(
                      child: const Text(
                        "修 改",
                        style: TextStyle(color: Colors.white),
                        textAlign: TextAlign.center,
                      ),
                      onTap: () {
                        // if (_unameController.text.isEmpty) {
                          // Toasts.showToast("请输入账号");
                        // } else
                          if (unameController.text.isEmpty) {
                          Toasts.showToast("请输入昵称");
                        // } else if (_passwordController.text.isEmpty) {
                        //   Toasts.showToast("请输入密码");
                        // } else if (_passwordController1.text.isEmpty) {
                        //   Toasts.showToast("请再次输入密码");
                        // } else if (_passwordController1.text!=_passwordController.text) {
                        //   Toasts.showToast("两次输入密码不对");
                        }else if (phoneController.text.isEmpty) {
                          Toasts.showToast("请输入手机号");
                        }  else if (sexIndex == -1) {
                          Toasts.showToast("请选择性别");
                        }else if (birthday =="请选择") {
                          Toasts.showToast("请选择生日");
                        } else if (mzIndex == -1) {
                          Toasts.showToast("请选择民族");
                        // } else if (emailController.text.isEmpty) {
                        //   Toasts.showToast("请输入邮箱");
                        // } else if (emailCodeController.text.isEmpty) {
                        //   Toasts.showToast("请输入邮箱验证码");
                        }else {
                            modifyUserInfo();
                        }
                      },
                    )),
              ),
              Container(
                margin: const EdgeInsets.only(
                    left: 10, top: 20, bottom: 20, right: 10),
                child: Container(
                  //边框设置
                    decoration: BoxDecoration(
                      //背景
                      color: const Color(0xff00946B),
                      //设置四周圆角 角度
                      borderRadius:
                      const BorderRadius.all(Radius.circular(25.0)),
                      //设置四周边框
                      border: Border.all(
                        width: 1,
                        color: const Color(0xff00946B),
                      ),
                      // width: 1, color: Colors.white70),
                    ),
                    // margin: const EdgeInsets.only(left: 10, right: 10, bottom: 20),
                    padding: const EdgeInsets.all(10),
                    width: double.infinity,
                    child: GestureDetector(
                      child: const Text(
                        "退出登录",
                        style: TextStyle(color: Colors.white),
                        textAlign: TextAlign.center,
                      ),
                      onTap: () {
                        Navigator.pushAndRemoveUntil(
                          context,
                          MaterialPageRoute(
                              builder: (context) => BaseLogin()),
                              (Route<dynamic> route) => false,
                        );
                      },
                    )),
              )
            ],
          )),
    );
  }
  // HttpUtils.postJSON(context, APIs.getRegister, {
  // "account": _unameController.text,
  // "birthDay": birthday,
  // "email": emailController.text,
  // "emailCode": emailCodeController.text,
  // "mainOrgPostId": "",
  // "mobilePhone": phoneController.text,
  // "nationCode": mzMap["data"][mzIndex]["dictKey"].toString(),
  // "newPassword": _passwordController1.text,
  // "noNeedToken": true,
  // "password": _passwordController.text,
  // "realname": unameController.text,
  // "mainOrgPostId": '1613427188973961216',
  // "roleIds": ["1613410898024595456"],
  // "sexCode": sexMap["data"][sexIndex]["dictKey"].toString()

  //修改基础信息
  modifyUserInfo() async {
    HttpUtils.postJSON(
        context, "${APIs.modifyUserInfo}?token=${await Global.getData("token")}", {
      "id": mapinfo["id"],
      "realname": unameController.text,
      "phone": phoneController.text,
      "sexCode": sexMap["data"][sexIndex]["dictKey"].toString(),
      "birthDay": birthday,
      "nationCode": mzMap["data"][mzIndex]["dictKey"].toString(),
    }, success: (data) async {
      setState(() {
        Map map = data;
        if(map["data"]){
          Navigator.pop(context);
        }else{
          
        }


      });
    }, fail: (code, msg) {}, type: Type.JSON);
  }


  static Widget getTextStyle14(String name) {
    return Container(
      width: 100,
      margin: const EdgeInsets.only(left: 20, top: 10),
      child: Row(
        children: [
          Text(
            name,
            style: const TextStyle(fontSize: 16, color: Color(0xff333333)),
          )
        ],
      ),
    );
  }


  //右侧输入框
  static Widget setTextField(
      TextEditingController phoneController, String content) {
    if (content != "请输入") {
      phoneController.text = content;
    }
    return Expanded(
        flex: 1,
        child: Container(
            width: double.infinity,
            margin: const EdgeInsets.only(left: 20, top: 10),
            child:Container(
              width: double.infinity,
              margin: const EdgeInsets.only(left: 0, top: 10, right: 20, bottom: 0),
              child: TextField(
                keyboardType: TextInputType.number, //数字键盘
                maxLines: 1,
                controller: phoneController,
                decoration: InputDecoration(
                    hintText: content,
                    border: InputBorder.none,
                    hintStyle: const TextStyle(color: Color(0xff999999), fontSize: 14)),
              ),
            )
        )
    );

  }
  static Widget getLine() {
    return Container(
      margin: const EdgeInsets.only(left: 20, right: 20, top: 10),
      width: double.infinity,
      height: 0.5,
      color: const Color(0xffE5E5E5),
    );
  }


  static Widget getTextStyle14conent(String name) {
    return Container(
      margin: const EdgeInsets.only(left: 0, top: 10, right: 20, bottom: 0),
      padding: const EdgeInsets.only(left: 0, top: 10, right: 0, bottom: 10),
      child: Padding(
          padding: const EdgeInsets.only(right: 10),
          child: Text(
            name,
            style: const TextStyle(fontSize: 14, color: Color(0xff999999)),
          )),
    );
  }

  //性别弹出框
  showBottomPopu(Map map, int type) {
    showModalBottomSheet(
      context: context,
      builder: (BuildContext context) {
        return SizedBox(
            height: 200.0,
            child: SingleChildScrollView(
              child: Column(
                  mainAxisAlignment: MainAxisAlignment.spaceBetween,
                  children: [
                    ListView.builder(
                        physics: const NeverScrollableScrollPhysics(), // 禁用滑动事件
                        shrinkWrap: true,
                        itemCount: map["data"].length ?? 0,
                        itemBuilder: (BuildContext context, int index) {
                          return GestureDetector(
                            child: Container(
                              alignment: Alignment.center,
                              padding:
                              const EdgeInsets.only(bottom: 10, top: 10),
                              child: Text(
                                  map["data"][index]["dictName"].toString()),
                            ),
                            onTap: () {
                              setState(() {
                                if (type == 0) {
                                  sex =
                                      map["data"][index]["dictName"].toString();
                                  sexIndex = index;
                                } else if (type == 1) {
                                  mingzu =
                                      map["data"][index]["dictName"].toString();
                                  mzIndex = index;
                                }
                                Navigator.pop(context);
                              });
                            },
                          );
                        }),
                  ]),
            ));
      },
    );
  }

  Future<DateTime?> selectDate(BuildContext context) async {
    DateTime? picked = await showDatePicker(
        context: context,
        initialDate: DateTime.now(),
        firstDate: DateTime(1960),
        lastDate: DateTime(2030)
    );
    return picked;
  }
}
