import 'dart:collection';
import 'dart:convert';

import 'package:flutter/foundation.dart';
import 'package:flutter/material.dart';
import 'package:kumi_popup_window/kumi_popup_window.dart';

import 'package:pull_to_refresh/pull_to_refresh.dart';

import '../dio/APIs.dart';
import '../dio/HttpUtils.dart';
import '../utils/Global.dart';
import '../widget/MySmartRefresher.dart';
import 'AppDetail.dart';

class appnew extends StatefulWidget {
  @override
  State<StatefulWidget> createState() {
    return appState();
  }
}

class appState extends State with AutomaticKeepAliveClientMixin {
  Map map = HashMap();
  bool isRefresh = false;
  final TextEditingController _unameController = TextEditingController();
  RefreshController refreshController = RefreshController();
  ScrollController scrollController = ScrollController();
  List listinfo = [];
  List listTitle = []; //筛选类型名称
  int clickindex = 0;
  int listindex = 0;
  String aaa = "";

  bool isRefreshlist = false; //筛选请求
  GlobalKey btnKey = GlobalKey();
  KumiPopupWindow? popupWindow;

  @override
  void initState() {
    super.initState();
    getDatas("");
    getListurl("");
  }

  //获取筛选标题栏
  getDatas(String key) async {
    HttpUtils.postJSON(context, APIs.baseApp, {
      "token": await Global.getData("token"),
      "isPc": false,
      "keyWords": key
    }, success: (data) async {
      isRefresh = true;
      setState(() {
        listTitle.clear();
        isRefreshlist = true;
        map = data;
        listinfo.addAll(map["info"]);
        listTitle.addAll(listinfo);
        refreshController.refreshCompleted();
        refreshController.loadComplete();
      });
    }, fail: (code, msg) {});
  }

  getListurl(String groupId) async {
    HttpUtils.postJSON(context, APIs.getList, {
      "token": await Global.getData("token"),
      "isPc": false,
      "groupId": groupId,
    }, success: (data) async {
      isRefresh = true;
      setState(() {
        isRefreshlist = true;
        map = data;
        refreshController.refreshCompleted();
        refreshController.loadComplete();
      });
    }, fail: (code, msg) {});
  }

  Widget getHeader() {
    return Row(
      children: [
        Expanded(
          flex: 8,
          child: Container(
            color: const Color(0xffF5F5F5),
            margin: const EdgeInsets.only(right: 15, bottom: 10, top: 10),
            padding: const EdgeInsets.only(left: 10, right: 10),
            height: 40,
            child: TextField(
              controller: _unameController,
              decoration: InputDecoration(
                fillColor: const Color(0xffF5F5F5),
                hintText: "应用",
                suffix: GestureDetector(
                  child: const Icon(
                    Icons.search,
                    color: Color(0xff666666),
                  ),
                  onTap: () {
                    // _layoutState = LoadState.State_Loading; //这个就是获取中
                    getDatas(_unameController.text);
                  },
                ),
                border: InputBorder.none,
              ),
            ),
          ),
        ),
        Expanded(
          flex: 1,
          child: GestureDetector(
            child: const Text("筛选",style: TextStyle(fontSize: 14,color: Colors.blue),),
            onTap: () {
              showPopupWindow(
                          context,
                          //childSize:Size(240, 800),
                          gravity: KumiPopupGravity.centerBottom,
                          //curve: Curves.elasticOut,
                          bgColor: Colors.grey.withOpacity(0),
                          // bgColor: Colors.white,
                          clickOutDismiss: true,
                          clickBackDismiss: true,
                          customAnimation: false,
                          customPop: false,
                          customPage: false,
                          // targetRenderBox: (btnKey.currentContext.findRenderObject() as RenderBox),
                          //needSafeDisplay: true,
                          underStatusBar: false,
                          underAppBar: true,
                          //offsetX: -180,
                          //offsetY: 50,
                          duration: const Duration(milliseconds: 300),
                          onShowStart: (pop) {
                            // print("showStart");
                          },
                          onShowFinish: (pop) {
                            // print("showFinish");
                          },
                          onDismissStart: (pop) {
                            // print("dismissStart");
                          },
                          onDismissFinish: (pop) {
                            // print("dismissFinish");
                          },
                          onClickOut: (pop) {
                            // print("onClickOut");
                          },
                          onClickBack: (pop) {
                            // print("onClickBack");
                          },
                          childFun: (pop) {
                            return StatefulBuilder(
                                key: GlobalKey(),
                                builder: (popContext, popState) {
                                  // return GestureDetector(
                                  //             opacity: animation,
                                  //             child: SizeTransition(
                                  //               sizeFactor: animation,
                                  //               child: Container(
                                  //                 margin:
                                  //                 EdgeInsets.only(top: Global.getScale(context) * 20),
                                  //                 color: Colors.transparent,
                                  //                 child: _widgetPopu(),
                                  //               ),
                                  //             ),
                                  //           );
                                  return GestureDetector(
                                    onTap: () {
                                      //isSelect.value = !isSelect.value;
                                      popState(() {
                                        aaa = "sasdasd";
                                      });
                                    },
                                    child: Container(
                                      margin:
                                      EdgeInsets.only(top: Global.getScale(context) * 50),
                                      color: Colors.transparent,
                                      child: _widgetPopu(),
                                    ),
                                    // Container(
                                    //   padding: const EdgeInsets.all(2),
                                    //   height: 800,
                                    //   width: 300,
                                    //   color: Colors.blue,
                                    //   alignment: Alignment.center,
                                    //   child: _widgetPopu(),
                                    // ),
                                  );
                                });
                          },
                        );
            },
          ),
        ),
      ],
    );
  }

  void _onRefresh() async {
    //下拉刷新
    getDatas("");
    getListurl("");
  }

  void _onLoading() async {
    refreshController.loadComplete(); //上拉完成
  }

  @override
  Widget build(BuildContext context) {


    return Scaffold(
        backgroundColor: Colors.white,
        appBar: AppBar(
          title: const Text(
            "我的应用",
            style: TextStyle(color: Colors.black),
          ),
          backgroundColor: Colors.white,
          elevation: 0,
          leading: IconButton(
            icon: const Icon(
              Icons.arrow_back,
              color: Colors.black,
            ),
            onPressed: () {
              Navigator.pop(context);
            },
          ),
        ),
        body: getbody(map),
    );
//     return Scaffold(
//       appBar: AppBar(
//         backgroundColor: const Color(0x00000000),
//         leading: const Text("我的应用"),
//         leadingWidth: 0,
//         // title: getHeader(),
//         centerTitle: true,
// //          backgroundColor: Colors.white,
//         elevation: 0,
//         iconTheme: const IconThemeData(
//           color: Color(0xff333333), //修改颜色
//         )
//       ),
//       backgroundColor: Colors.white,
//       body: getbody(map),
//     );
  }

  Widget _widgetPopu() {
    if (!isRefreshlist) {
      return Global.add();
    } else {
      return Scaffold(
          backgroundColor: Colors.transparent,
          body: Column(
            children: [
              Expanded(
                flex: 4,
                child: Container(
                  height: 400,
                  color: Colors.white,
                  child: ListView.builder(
                      itemCount: listTitle.length + 1,
                      itemBuilder: (BuildContext context, int index) {
                        if (index == 0) {
                          return getList("全部应用", index, "");
                        } else {
                          return getList(listTitle[index - 1]["name"], index,
                              listTitle[index - 1]["id"]);
                        }
                      }),
                ),
              ),
              Expanded(
                flex: 6,
                child:GestureDetector(
                  child:Container(
                    color: const Color(0x90eeeeee),
                  ),
                  onTap: (){
                    Navigator.pop(context);
                  },
                ) ,
              )
            ],
          ));
    }
  }

  Widget getList(String name, int index, String id) {
    int color;
    if (clickindex == index) {
      color = 0xff1278C0;
    } else {
      color = 0xff666666;
    }
    return Column(
      children: [
        Container(
            color: Colors.white,
            alignment: Alignment.center,
            padding: const EdgeInsets.only(top: 15, bottom: 15),
            child: GestureDetector(
              child: Text(
                name,
                style: TextStyle(color: Color(color), fontSize: 14),
              ),
              onTap: () {
                setState(() {
                  clickindex = index;
                });
                if (clickindex == 0 && listTitle.length != 0) {
                  getListurl("");
                } else {
                  getListurl(id);
                }
                Navigator.pop(context);
              },
            )),
        Container(
          color: const Color(0xffe5e5e5),
          width: double.infinity,
          height: 1,
        )
      ],
    );
  }

  Widget getbody(Map map) {
    if (!isRefresh) {
      return Global.add();
    } else {
      return Stack(
        children: [
          MySmartRefresher().getRefresherNOUp(
              refreshController,
              _onRefresh,
              _onLoading,
              Container(
                margin: const EdgeInsets.only(left: 15, right: 15),
                child: SingleChildScrollView(
                  controller: scrollController,
                  child: ListView.builder(
                      physics: const NeverScrollableScrollPhysics(),
                      shrinkWrap: true,
                      itemCount: map["info"].length,
                      itemBuilder: (BuildContext context, int index) {
                        // return Text("data");
                        return getConntentNew(map["info"][index]);
                        // return getConntent(map["info"][index].name, index);
                      }),
                ),
              )),
        ],
      );
    }
  }

  Widget getConntentNew(Map mapinfo) {
    return SingleChildScrollView(
      child: Column(
        crossAxisAlignment: CrossAxisAlignment.start,
        children: [
          Padding(
            padding: const EdgeInsets.only(top: 1, bottom: 10),
            child: Text(
              mapinfo["name"],
              style: const TextStyle(
                  color: Color(0xff333333),
                  fontSize: 15,
                  fontWeight: FontWeight.bold),
            ),
          ),
          GridView.builder(
              shrinkWrap: true,
              physics: const NeverScrollableScrollPhysics(),
              itemCount: mapinfo["unifiedAppModels"].length,
              padding: const EdgeInsets.only(top: 10),
              gridDelegate: const SliverGridDelegateWithFixedCrossAxisCount(
                //横轴元素个数
                crossAxisCount: 4,
                childAspectRatio: 0.75,
                //纵轴间距
                mainAxisSpacing: 10,
//                mainAxisSpacing: 10,
              ),
              itemBuilder: (BuildContext context, int index) {
                return getGrideNew(mapinfo["unifiedAppModels"][index]);
              }),
        ],
      ),
    );
  }

  void getToken(String id, bool isFlow) async {
    // final token = await Global.getData("token");
    Global.openUrl(context,"/IfarmeAffair?id=${id}&isFlow=false&token=${await Global.getData("token")}");
    // Global.openUrl(context,"/IfarmeAffair?id=${id}&isFlow=false&token=$token");
  }

  Widget getGrideNew(Map mapitem) {
    return GestureDetector(
      child: Stack(
        children: [
          Column(
            children: [
              Container(
                  margin: const EdgeInsets.only(left: 5, top: 5),
                  //设置 child 居中
                  alignment: const Alignment(0, 0),
                  height: Global.getScale(context) * 55,
                  width: Global.getScale(context) * 55,
                  //边框设置
                  decoration: BoxDecoration(
                    //背景
                    color: const Color(0xff666666).withOpacity(0.06),
                    //设置四周圆角 角度 这里的角度应该为 父Container height 的一半
                    borderRadius: const BorderRadius.all(Radius.circular(25.0)),
                  ),
                  child: kIsWeb?Global.getNetworkSvg(
                      context,
                      mapitem["icon"].toString().contains("filePath")
                          ? APIs.imgFile+jsonDecode(mapitem["icon"])["filePath"]
                          : (APIs.imgFile +
                          (mapitem["icon"] ?? ""))):Global.getNetworkSvg(
                      context,
                      mapitem["icon"].toString().contains("url")
                          ? jsonDecode(mapitem["icon"])["url"]
                          : (APIs.LOGIN_BASE +
                          (mapitem["icon"] ?? ""))),
              ),
              Column(
                  verticalDirection: VerticalDirection.down,
                  children: [
                Text(
//                    appModel.name.substring(0, 4),
                  mapitem["name"].length > 4
                      ? mapitem["name"].substring(0, 4)
                      : mapitem["name"],
                  style: const TextStyle(
                      height: 1.8, fontSize: 13, color: Color(0xff333333)),
                ),
                Text(
                  mapitem["name"].length > 8
                      ? mapitem["name"].substring(4, 7) + "..."
                      : mapitem["name"].length < 4
                          ? ""
                          : mapitem["name"].substring(4),
                  style: const TextStyle(
                      height: 1.2, fontSize: 13, color: Color(0xff333333)),
                ),
              ]),
            ],
          ),
          mapitem["isFlow"] &&
                  mapitem["flowCount"] != null &&
                  mapitem["flowCount"] != "0"
              ? Container(
                  margin: const EdgeInsets.only(
                    left: 35,
                  ),
                  width: 20,
                  height: 20,
                  decoration: mapitem["isFlow"]
                      ? const ShapeDecoration(
                          color: Colors.red,
                          shape: CircleBorder(
                            side: BorderSide.none,
                          ))
                      : null,
                  child: Container(
                    width: double.infinity,
                    height: double.infinity,
                    alignment: Alignment.topCenter,
                    child: Text(mapitem["flowCount"] ?? "",
                        style:
                            const TextStyle(fontSize: 12, color: Colors.white)),
                  ))
              : const Text("")
        ],
      ),
      onTap: () {
        Navigator.push(context, MaterialPageRoute(builder: (context) {
          return AppDetail(mapitem["id"]);
        }));
        // APIs.appId = mapitem["id"];

        // Navigator.of(context)
        //     .pushNamed("/MyHome/AppDetail");
      //   if (mapitem["typeId"] == "outside") {
      //     Global.openUrloutside(context, mapitem["url"], false, (map) {
      //       setState(() {
      //         if (map["canshu"] == "pull") {
      //           getDatas("");
      //         }
      //         //fuyong
      //       });
      //     });
      //   } else if (mapitem["typeId"] == "app") {
      //     if (mapitem["isFlow"]) {
      //       // String v = "";
      //       // v.replaceAll("https://sso.yazjy.com", "");
      //       Navigator.of(context)
      //           .pushNamed("/MyHome/AppDetail", arguments: mapitem["id"]);
      //     } else {
      //       getToken(mapitem["id"], mapitem["isFlow"]);
      //     }
      //   }
      },
    );
  }

  @override
  bool get wantKeepAlive => true;
}
