
import 'dart:collection';
import 'package:flutter/material.dart';
import '../Iconfont.dart';
import '../dio/APIs.dart';
import '../dio/HttpUtils.dart';
import '../dio/DioUtils.dart';
import '../utils/Global.dart';
import '../widget/Toast.dart';
class editPassword extends StatefulWidget {

  String username;

  editPassword(this.username);

  @override
  State<StatefulWidget> createState() {
    return EditPasswordState();
  }
}
//账号密码
class EditPasswordState extends State<editPassword> {

  bool obscureText = true;
  bool obscuretoText = true;
  var info = "";
  final TextEditingController _unameController = TextEditingController();
  final TextEditingController _unameAgeController = TextEditingController();
  final TextEditingController _passwordController = TextEditingController();

  @override
  void initState() {
    super.initState();
  }

  //修改密码
  getMyInfo() async {
    // final token = await Global.getData("token");
    HttpUtils.postJSON(
        context,
        "${APIs.My_EditPass}?token=${await Global.getData("token")}",{
          "typeKey": 3,
        "content": {
        "oldPwd": _passwordController.text,
        "newPwd": _unameController.text
          }
        }, success: (data) async {
      setState(() {
        if (data["data"]) {
          Toasts.showToast("密码修改成功");
          ModalRoute.withName("/BaseLogin");
          Navigator.of(context).pushNamed("/BaseLogin");

        }else{
          info = data["message"];//baseBeanEntity.message;
        }
      });
    }, fail: (code, msg) {}, type: Type.JSON);
  }


  @override
  Widget build(BuildContext context) {
    return Scaffold(

      appBar: AppBar(
        centerTitle: false,
        backgroundColor: Colors.white,
        title: const Text(
          "账号密码",
          style: TextStyle(color: Colors.black, fontSize: 18),
        ),
        elevation: 0,
        leading: IconButton(
          icon: const Icon(
            Icons.arrow_back,
            color: Colors.black,
          ),
          onPressed: () {
            Navigator.pop(context);
          },
        ),//标题头阴影  0 为无
      ),
      backgroundColor: Colors.white,
      body: Column(
        crossAxisAlignment: CrossAxisAlignment.start,
        children: [
          // Padding(
          //   padding: const EdgeInsets.only(top: 37, left: 21),
          //   child: Column(
          //     crossAxisAlignment: CrossAxisAlignment.start,
          //     children: const [
          //       Text(
          //         "修改密码",
          //         style: TextStyle(
          //             fontSize: 18,
          //             color: Color(0xff333333),
          //             fontWeight: FontWeight.bold),
          //       ),
          //       Text(
          //         "请勿与旧密码相同",
          //         style: TextStyle(
          //           fontSize: 12,
          //           color: Color(0xff999999),
          //         ),
          //       )
          //     ],
          //   ),
          // ),
          Container(
              padding: const EdgeInsets.only(left: 30, right: 20, top: 40),
              child: Text("账号    ${widget.username}",style: TextStyle(
                color: Colors.black, fontSize: Global.getScale(context) *15))
          ),
          Padding(
            padding: const EdgeInsets.only(left: 20, right: 20, top: 10),
            child: TextField(
              controller: _passwordController,
              decoration: const InputDecoration(
                hintText: "请输入旧密码",
                prefixIcon: Image(image: AssetImage('images/password.png'),height: 18,width: 18),
                // prefixIcon: Icon( Iconfont.password,color: Color(0xff1278c0),size:15),
                enabledBorder: UnderlineInputBorder(
                  borderSide: BorderSide(color: Color(0xffe6e6e6)),
                ),
                focusedBorder:UnderlineInputBorder(
                  borderSide: BorderSide(color: Color(0xffe6e6e6)),
                ),
              ),
              onChanged: (v) {},
            ),
          ),
          Padding(
            padding: const EdgeInsets.only(left: 20, right: 20, top: 20),
            child: TextField(
              obscureText: obscureText,
              controller: _unameController,
              decoration: InputDecoration(
                hintText: "请输入新密码",
                  prefixIcon: const Image(image: AssetImage('images/password.png'),height: 18,width: 18),
                // prefixIcon: const Icon( Iconfont.password,color:  Color(0xff1278c0),size:15),
                enabledBorder: const UnderlineInputBorder(
                  borderSide: BorderSide(color: Color(0xffe6e6e6)),
                ),
                focusedBorder: const UnderlineInputBorder(
                  borderSide: BorderSide(color: Color(0xffe6e6e6)),
                ),
                  suffixIcon: GestureDetector(
                      child:
                      obscureText?const Icon( Iconfont.closeEye,color: Color(0xff1278c0),size:15):const Icon( Iconfont.openEye,color: Color(0xff1278c0),size:15),
                      onTap: () {
                        setState(() {
                          obscureText = !obscureText;
                        });
                      })
              ),
              onChanged: (v) {},
            ),
          ),
          Padding(
            padding: const EdgeInsets.only(left: 20, right: 20, top: 20),
            child: TextField(
              obscureText:obscuretoText,
              controller: _unameAgeController,
              decoration: InputDecoration(
                hintText: "确认新密码",
                // prefixIcon:image: AssetImage('images/password.png'),height: 18,width: 18),
                // prefixIcon: const Icon( Iconfont.password,color: Color(0xff1278c0),size:15),
                prefixIcon: const Image(image: AssetImage('images/password.png'),height: 18,width: 18),
                enabledBorder: const UnderlineInputBorder(
                  borderSide: BorderSide(color: Color(0xffe6e6e6)),
                ),
                focusedBorder: const UnderlineInputBorder(
                  borderSide: BorderSide(color: Color(0xffe6e6e6)),
                ),
                  suffixIcon: GestureDetector(
                      child:
                      obscuretoText?const Icon( Iconfont.closeEye,color: Color(0xff1278c0),size:15):const Icon( Iconfont.openEye,color: Color(0xff1278c0),size:15),
                      onTap: () {
                        setState(() {
                          obscuretoText = !obscuretoText;
                        });
                      })
              ),
              onChanged: (v) {},
            ),
          ),
          Padding(
            padding: const EdgeInsets.only(left: 20, right: 20, top: 10),
            child: Text(
              info,
              style: const TextStyle(fontSize: 11, color: Colors.red),
            ),
          ),
          Container(
            margin: const EdgeInsets.only(left: 20, right: 20, top: 40),
            width: double.infinity,
            child: MaterialButton(
              color: Color(APIs.themeColors),
              highlightColor: Colors.blue[700],
              colorBrightness: Brightness.dark,
              splashColor: Colors.grey,
              child: const Text("确定修改"),
              onPressed: () {
                if (_passwordController.text == null) {
                  setState(() {
                    info = "请输入旧密码";
                  });
                } else if (_unameController.text == null) {
                  setState(() {
                    info = "请输入新密码";
                  });
                } else if (_unameAgeController.text == null) {
                  setState(() {
                    info = "请确认密码";
                  });
                } else if (_unameController.text != _unameAgeController.text) {
                  setState(() {
                    info = "两次新密码不同";
                  });
                } else {
                    getMyInfo();
                }
              },
            ),
          ),
        ],
      ),
    );
  }
}
