import 'dart:collection';
import 'dart:convert';
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:flutter_html/flutter_html.dart';
import 'package:pull_to_refresh/pull_to_refresh.dart';

import 'package:textileclothing/dio/DioUtils.dart';
import '../Iconfont.dart';
import '../dio/APIs.dart';
import '../dio/HttpUtils.dart';
import '../utils/Global.dart';

class HomeSerch extends StatefulWidget {
  @override
  State<StatefulWidget> createState() {
    return HomeSerchState();
  }
}

class HomeSerchState extends State with SingleTickerProviderStateMixin {
  TextEditingController serchController = TextEditingController();
  // List<String> list = ["应用", "公告", "新闻", "接口", "标准"];
  // late TabController controller;
  // int type = 0;
  bool isserch = false;
  List<String> serchList = [];
  Map mapNewsList = HashMap(); //新闻列表
  Map _mapNewsList = HashMap(); //新闻列表
  int pageSize = 15;
  int newsNumber = 1;
  late ScrollController scrollController;

  @override
  void initState() {
    super.initState();
    // controller = TabController(
    //   length: list.length,
    //   vsync: this,
    // );
    scrollController = ScrollController();
    scrollController.addListener(() {
      int offset = scrollController.position.pixels.toInt();
      // 如果滑动到底部
      if (scrollController.position.pixels == scrollController.position.maxScrollExtent) {
        _onLoading();
      }
    });
    setState(() {

    });
  }

  //文章新闻列表
  // getNewsList() async {
  //   HttpUtils.postJSON(context,
  //       "${APIs.Home_New}?token=${await Global.getData("token")}", {
  //         "pageSize": pageSize,
  //         "pageNo": newsNumber,
  //         "filter": {"enddate": "", "field": "", "startdate": ""},
  //         "query": {
  //           "highlightIn": true,
  //           "indexName": "news_article_index",
  //           "keywords": serchController.text,
  //           "returnFields": "*",
  //           "searchFields": "*",
  //         }
  //       }, success: (data) async {
  //         setState(() {
  //           mapNewsList = data["data"];
  //           setRefresher(newsNumber, data["data"]);
  //         });
  //       }, fail: (code, msg) {}, type: Type.JSON);
  // }

  getNewsList() async {
    HttpUtils.postJSON(context,APIs.Home_New,{
        // "${}?token=${await Global.getData("token")}", {
          "pageSize": pageSize,
          "pageNo": newsNumber,
          "statusKey": "2",
          "channelId": "7,9,10,11,12,14",
          "hasInclude": false,
          "randomKey": "0.6243110362923858",
          "token": await Global.getData("token")
        }, success: (data) async {
          setState(() {
            mapNewsList = data["data"];
            setRefresher(newsNumber, data["data"]);
          });
        }, fail: (code, msg) {}, type: Type.JSON);
  }
  RefreshController refreshController = RefreshController();

  void _onRefresh() async {
    pageSize = 15;
    newsNumber = 1;
    getNewsList();
    // if (type == 0) {
    // } else if (type == 1) {
    //   // noticeNumber = 1;
    //   // getNotice();
    // } else if (type == 2) {
    // } else if (type == 3) {
    //   // mapdataNumber = 1;
    //   // getdatainterface();
    // } else {
      // databNumber = 1;
      // getDatab();
    // }
  }

  void _onLoading() async {
      if (newsNumber < mapNewsList["totalPage"]) {
        newsNumber++;
      }
      getNewsList();

  }

  void setRefresher(int number, Map mapdata) {
    if (number == 1) {
      _mapNewsList = mapdata;
    } else {
      _mapNewsList.update(
          "rows", (value) => _mapNewsList["rows"] + mapdata["rows"]);
      mapNewsList = _mapNewsList;
    }
    if (number == mapdata["totalPage"]) {
      refreshController.loadNoData();
    } else {
      refreshController.loadComplete();
    }
    refreshController.refreshCompleted();
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      backgroundColor: Colors.white,
      // backgroundColor: const Color(0xff00946B),
      appBar: AppBar(
        title: const Text("搜索"),
        centerTitle: true,
        backgroundColor: const Color(0xff00946B),
        elevation: 0,
      ),
      body: CustomScrollView(
        controller: scrollController,
        slivers: [
          getHeader(),
          getDestory(),
          isserch
              ? SliverToBoxAdapter(child: Container())
              : getDestoryList(),
          isserch ? getNumber() : SliverToBoxAdapter(child: Container()),
          isserch
              ? getListContent()
              : SliverToBoxAdapter(child: Container()),
        ],
      ),
    );
  }

  List<String> getShared = [];

  getCount() async {
    var serch = await Global.getData("serch");
    if (serch == null) {
      getShared = [];
    } else {
      List list = json.decode(serch);
      List<String> cardbeanList = list.map((m) => m.toString()).toList();
      setState(() {
        getShared = cardbeanList;
      });
    }
  }

  Widget getNumber() {
    return SliverToBoxAdapter(
        child: Container(
          color: const Color(0xffF5F5F5),
          padding: const EdgeInsets.only(right: 10, top: 10, bottom: 10),
          child: Text(
            "共${getLength()}条",
            textAlign: TextAlign.right,
            style: const TextStyle(color: Color(0xff999999)),
          ),
        ));
  }

  String getLength() {
    if (mapNewsList.isNotEmpty) {
      return mapNewsList["total"];
    } else {
      return "0";
    }
  }

  //历史记录
  Widget getDestory() {
    return SliverToBoxAdapter(
        child: Column(
          children: [
            Row(
              mainAxisAlignment: MainAxisAlignment.spaceBetween,
              children: [
                Container(
                  padding: const EdgeInsets.only(left: 15, right: 10, top: 15),
                  child: const Text("历史记录"),
                ),
                GestureDetector(
                  child: Container(
                    padding: const EdgeInsets.only(left: 15, right: 15, top: 15),
                    child: const Icon(Iconfont.delete_xiao,
                        color: Color(0xffff5d5a), size: 20),
                  ),
                  onTap: () async {
                    Global.removeData("serch");
                    setState(() {
                      getShared.clear();
                    });
                  },
                )
              ],
            ),
          ],
        ));
  }

  Widget getDestoryList() {
    return SliverToBoxAdapter(
        child: GridView.builder(
          shrinkWrap: true,
          itemCount: getShared.length,
          physics: const NeverScrollableScrollPhysics(),
          padding: const EdgeInsets.only(left: 16, top: 10),
          gridDelegate: const SliverGridDelegateWithFixedCrossAxisCount(
            crossAxisCount: 5,
            childAspectRatio: 3.5,
          ),
          itemBuilder: (context, index) {
            return GestureDetector(
              child: Container(
                alignment: Alignment.center,
                margin: const EdgeInsets.only(left: 5, right: 5),
                color: const Color(0xffF5F5F5),
                child: Text(
                  getShared[index],
                  style: const TextStyle(color: Color(0XFF666666), fontSize: 14),
                ),
              ),
              onTap: () {
                serchController.text = getShared[index];
              },
            );
          },
        ));
  }

  //搜索框
  Widget getHeader() {
    return SliverToBoxAdapter(
        child: Container(
          margin: const EdgeInsets.only(left: 15, right: 15, top: 10),
          child: TextField(
            controller: serchController,
            decoration: InputDecoration(
              filled: true,
              fillColor: const Color(0xffF5F5F5),
              hintText: "新闻",
              suffixIcon: GestureDetector(
                child: const Icon(Icons.search),
                onTap: () async {
                  serchList.clear();
                  var serch = await Global.getData("serch");

                  if (serch != null) {
                    bool ishave = false;
                    List list = json.decode(serch);
                    list.forEach((element) {
                      if (element == serchController.text) {
                        ishave = true;
                      }
                    });
                    if (!ishave) {
                      serchList.add(serchController.text);
                    }
                    List<String> cardbeanList =
                    list.map((m) => m.toString()).toList();
                    serchList.addAll(cardbeanList);
                  } else {
                    serchList.add(serchController.text);
                  }
                  Global.saveData("serch", json.encode(serchList));
                  getNewsList();
                  getCount();
                  setState(() {
                    isserch = true;
                  });
                },
              ),
              border: InputBorder.none,
            ),
            onChanged: (e) {
              setState(() {
                if (e.isNotEmpty) {
                } else {
                  isserch = false;
                }
              });
            },
          ),
        ));
  }

  Widget getListContent() {
      //文章新闻
      return SliverToBoxAdapter(
        child: ListView.builder(
            physics: const NeverScrollableScrollPhysics(),
            shrinkWrap: true,
            itemCount: mapNewsList["rows"].length ?? 0,
            padding: const EdgeInsets.only(left: 10, right: 10),
            itemBuilder: (BuildContext context, int index) {
              return getsearchNewsList(mapNewsList["rows"][index]);
            }),
      );

    }
  }

  //文章新闻
  Widget getsearchNewsList(Map map) {
    return GestureDetector(
      child: Column(
        mainAxisAlignment: MainAxisAlignment.start,
        children: [
          Container(
            alignment: Alignment.topLeft,
            margin: const EdgeInsets.only(top: 10),
            // child: Text(map["title"]),
            child: Html(data: map["title"]),
          ),
          Container(
            margin: const EdgeInsets.only(top: 10),
            child: Row(
//            mainAxisAlignment: MainAxisAlignment.spaceBetween,
              children: [
                const Text(""),
                Expanded(child: Text(map["userName"] ?? "")),
                const Text("时间",
                    // ZyDateUtils.instance.getFormartData(
                    //     timeSamp: int.parse(map["publishTime"]),
                    //     format: "yyyy年MM月dd日 HH:mm:ss"),
                    textAlign: TextAlign.center,
                    overflow: TextOverflow.ellipsis)
              ],
            ),
          ),
          Container(
            margin: const EdgeInsets.only(top: 10),
            width: double.infinity,
            height: 0.5,
            color: const Color(0xffE5E5E5),
          ),
        ],
      ),
      // getnewList(
      //     map["title"], int.parse(map["publishDate"])),
      onTap: () {
        setonTap(map["id"]);
      },
    );
  }

  void setonTap(String id) async {
    //新闻
    // final token = await Global.getData("token");
    // Global.openUrl(context, "/h5View/detail?id=$id&token=${await Global.getData("token")}");
  }