import 'dart:collection';

import 'package:flutter/material.dart';
import 'package:textileclothing/dio/APIs.dart';
import 'package:textileclothing/dio/HttpUtils.dart';
import 'package:textileclothing/utils/Global.dart';
import 'package:flutter_html/flutter_html.dart';

class NewNoticeInfo extends StatefulWidget {

  @override
  State<StatefulWidget> createState() {
    return NewNoticeInfoState();
  }
}

class NewNoticeInfoState extends State {
  Map map = HashMap();
  bool isRefresh = false;


  @override
  void initState() {
    super.initState();
      getArticleById();
  }

  //新闻详情
  getArticleById() async {
    HttpUtils.postJSON(context, APIs.getArticleById, {
      "token": await Global.getData("token"),
      "articleId": await Global.getData("id"),
    }, success: (data) async {
      setState(() {
        isRefresh = true;
        map = data;
      });
    }, fail: (code, msg) {});
  }
  //收藏
  _collectionArticle(bool isRead) async {
    HttpUtils.postJSON(context, APIs.collectionArticle, {
      "token": await Global.getData("token"),
      "isCollection":isRead,
      "id": await Global.getData("id"),
    }, success: (data) async {
      setState(() {
        if(data){
          getArticleById();
        }
      });
    }, fail: (code, msg) {});
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        centerTitle: true,
        title: const Text(
          "新闻详情",
          style: TextStyle(color: Colors.white, fontSize: 18),
        ),
//          elevation: 0,   标题头阴影  0 为无
      ),
      backgroundColor: Colors.white,
      body: !isRefresh?Global.add(): SingleChildScrollView(
          // alignment: Alignment.topCenter,
          padding: const EdgeInsets.only(top: 10),
          child: Column(
            children: [
              Container(
                margin: const EdgeInsets.only(left: 10, top: 20),
                child: Text(map["title"],
                style: const TextStyle(fontSize: 15, color: Color(0xff333333),
                    fontWeight: FontWeight.bold),
                  )
            ),

              Container(
                margin: const EdgeInsets.only(left: 10,top: 10,right: 10),
                child: Row(
                  children: [
                    const Expanded(
                      flex: 5,
                      child: Text("时间",
                        style:
                        TextStyle(fontSize: 14, color: Color(0xff333333)),
                      ),
                    ),
                    GestureDetector(
                        child: Expanded(
                          flex: 5,
                          child: Text(map["userName"]==null?"发布人：":"发布人："+map["userName"],
                            style:
                            const TextStyle(fontSize: 14, color: Color(0xff333333)),
                          ),
                        ),
                    )

                  ],
                ),),
              Container(
                margin: const EdgeInsets.only(left: 10,top: 10,right: 10),
                child: Row(
                  children: [
                    Expanded(
                      flex: 5,
                      child: Text("来源："+map["articleSource"],
                        style:
                        const TextStyle(fontSize: 14, color: Color(0xff333333)),
                      ),
                    ),
                    GestureDetector(
                        child: const Expanded(
                          flex: 5,
                          child: Text("",
                            style:
                            TextStyle(fontSize: 14, color: Color(0xff333333)),
                          ),
                        ),
                    )
                  ],
                ),
              ),
              Container(
                margin: const EdgeInsets.only(top:10,left: 10,bottom: 10,right: 10),
                child: Row(
                  children: [
                    Expanded(
                      flex: 7,
                      child: Text(map["viewCount"]+" 阅读",
                        style:
                        const TextStyle(fontSize: 14, color: Color(0xff333333)),
                      ),
                    ),
                    GestureDetector(
                        child: Expanded(
                          flex: 3,
                          child: Text(map["isCollection"]?" 取消收藏":" 点击收藏",
                            style:
                            const TextStyle(fontSize: 14, color: Color(0xff333333)),
                          ),
                        ),
                        onTap: () {
                          if(map["isCollection"]){
                            _collectionArticle(false);
                          }else{
                            _collectionArticle(true);
                          }

                        }
                    )

                  ],
                ),),
              Container(
                margin: const EdgeInsets.only(top: 10,left: 10),
                child: Html(data: map["content"]??"")
              )

            ],
          )),
    );
  }
}
