import 'dart:collection';
import 'dart:convert';

import 'package:flutter/foundation.dart';
import 'package:flutter/material.dart';
import 'dart:async';
import 'dart:io';
import 'package:textileclothing/utils/Global.dart';
import '../dio/APIs.dart';
import '../dio/HttpUtils.dart';
import '../widget/HexColor.dart';
import 'LoginUi.dart';
/**
 * 登录界面
 */
class BaseLogin extends StatefulWidget {

  @override
  State<StatefulWidget> createState() {
    return BaseLoginState();
  }
}

class BaseLoginState extends State{

  Map bannerMap = HashMap();
  setUserPs() async {

    var username = await Global.getData("username");
    if (username != null) {
      loginUi.loginPresenter.unameController.text = username;
    }


    var password = await Global.getData("password");
    if (password != null) {
      loginUi.loginPresenter.passwordController.text = password;
    }


    String? x = await Global.getData("ischeck");
    if(x!=null) {
      var ic = x == "true" ? true : false;
      loginUi.loginPresenter.setIsCheck(ic);
    }
  }
  @override
  void initState() {
    super.initState();
    setUserPs();
    readBanner();
  }

  static int getColorFromHex(String hexColor) {
    if (hexColor.startsWith("#")) {
      hexColor = hexColor.toUpperCase().replaceAll("#", "");
    } else {
      hexColor = hexColor.toUpperCase();
    }
    if (hexColor.length == 6) {
      hexColor = "FF$hexColor";
    }
    return int.parse(hexColor, radix: 16);
  }
  static int fromHex(String hexString) {
    final buffer = StringBuffer();
    if (hexString.length == 6 || hexString.length == 7) buffer.write('ff');
    buffer.write(hexString.replaceFirst('#', ''));
    return int.parse(buffer.toString(), radix: 16);
  }
  void readBanner() async {
    HttpUtils.postJSON(context, APIs.query, {
      "token": await Global.getData("token"),
      "isWeb": true,
    }, success: (data) async {
      setState(() {
        bannerMap = data;
        // replaceXXX
        APIs.themeColor = jsonDecode(bannerMap["theme"])["color"].replaceAll("#","");
        // APIs.themeColors = int.parse(jsonDecode(bannerMap["theme"])["color"].replaceAll("#","0xff"),radix:16);
        APIs.themeColors = getColorFromHex(APIs.themeColor);
      });
    }, fail: (code, msg) {});
  }
  LoginUi loginUi =  LoginUi();

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      backgroundColor: Colors.white,
        body: SingleChildScrollView(
            child:Stack(
              //层叠布局
              children: [
                Column(
                  children: [
                    Container(
                      alignment: Alignment.topCenter,

                      margin: const EdgeInsets.only(top: 60),
                      child: const Image(
                        // image: AssetImage("images/logo.png"),
                        image: AssetImage("images/ic_launcher.png"),
                        width: 80,
                        height: 80,
                      ),
                    ),
                    // Container(
                    //   alignment: Alignment.topCenter,
                    //   margin: const EdgeInsets.only(top: 60),
                    //   child: Text("登录"),
                    // ),
//            Decoration
                    Container(
                      margin: const EdgeInsets.only(left: 15, right: 15, top: 10),
                      // decoration: BoxDecoration(
                      //     border: Border.all(color: const Color(0xFF9E9E9E), width: 0.5),
                      //     borderRadius:
                      //     const BorderRadius.all(Radius.circular(10)), // 也可控件一边圆角大小
                      //     color: Colors.white,
                      //     boxShadow: const [
                      //       BoxShadow(
                      //           color: Color(0xFF9E9E9E),
                      //           blurRadius: 2.0,
                      //           spreadRadius: 1.0)
                      //     ]),
                      child: loginUi ,
                    )
                  ],
                ),
              ],
            )));

  }


}
