
import 'dart:async';
import 'dart:convert';

import 'package:flutter/material.dart';
import 'package:textileclothing/dio/APIs.dart';
import 'package:textileclothing/dio/HttpUtils.dart';
import 'package:textileclothing/utils/Global.dart';
import 'package:textileclothing/widget/Toast.dart';
import 'package:shared_preferences/shared_preferences.dart';
import 'package:textileclothing/dio/DioUtils.dart';
import 'package:textileclothing/Iconfont.dart';
import 'FortPassWord.dart';
import 'LockSucess.dart';

class CheckUser extends StatefulWidget {
  @override
  State<StatefulWidget> createState() {
    return CheckUserState(postid, state);
  }

  String postid;
  int state;

  CheckUser(this.postid, this.state);
}

class CheckUserState extends State {
//  BaseBeanEntity baseBeanEntity;
  final TextEditingController _unameController = TextEditingController();
  final TextEditingController _passwordController = TextEditingController();
  String postId;
  int state;
  var info = "";

 late Timer? _countdownTimer;
  String _codeCountdownStr = '发送验证码';
  int _countdownNum = 59;

  CheckUserState(this.postId, this.state);

  //发送验证码
  getSendCodeForget() async {
    //常用应用
    HttpUtils.postJSON(context,APIs.Login_forgetCode, {"str": _unameController.text},
        success: (data) async {
          setState(() {
            if (data["code"] == "0") {
              reGetCountdown();
              // Toast.toast(context, msg: "验证码已发送");
            } else {
              info = data["message"];
            }
          });
        }, fail: (code, msg) {}, type: Type.JSON);
  }

  //请求解锁接口
  getUnlock(String userid) async {
    final token = await Global.getData("token");
    HttpUtils.postJSON(context,APIs.Login_unlock + "?token=" +token!, {"ids": [userid]},
        success: (data) async {
          setState(() {
            Navigator.push(context,
                MaterialPageRoute(builder: (context) {
                  return LockSucess();
                }));
          });
        }, fail: (code, msg) {}, type: Type.JSON);
  }

  //验证验证码
  getValidCodeForget() async {
    HttpUtils.postJSON(context,APIs.Login_VaildforgetCode, {
      "str": _unameController.text,
      "code": _passwordController.text
    }, success: (data) async {
      final prefs = await SharedPreferences.getInstance();
      setState(()  {
        if (data["code"] == "0") {
          Global.saveData("token", data['data']['token']);
          Global.saveData("tgt", data['data']['tgt']);
          if(state==2) {
            Navigator.push(context,
                MaterialPageRoute(builder: (context) {
                  return FortPassWord();
                }));
          }else{
            var userid = data['data']['userId'];
            getUnlock(userid+"");

          }
        } else {
          info =data["message"];
        }
      });
    }, fail: (code, msg) {}, type: Type.JSON);
  }

  @override
  void dispose() {
    if (_countdownTimer != null) {
      _countdownTimer?.cancel();
    }
  }

  void reGetCountdown() {
    setState(() {
      if (_countdownTimer != null) {
        return;
      }
      // Timer的第一秒倒计时是有一点延迟的，为了立刻显示效果可以添加下一行。
      _codeCountdownStr = '${_countdownNum--}秒后再次发送';
      _countdownTimer = Timer.periodic(const Duration(seconds: 1), (timer) {
        setState(() {
          if (_countdownNum > 0) {
            _codeCountdownStr = '${_countdownNum--}秒后再次发送';
          } else {
            _codeCountdownStr = '获取验证码';
            _countdownNum = 59;
            _countdownTimer?.cancel();
            _countdownTimer = null;
          }
        });
      });
    });
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        title: Text(postId),
        centerTitle: true,
        backgroundColor: Colors.white,
        iconTheme: const IconThemeData(
          color: Color(0xff333333), //修改颜色
        )
      ),
      backgroundColor: Colors.white,
      body: Column(
        crossAxisAlignment: CrossAxisAlignment.start,
        children: [
          const Padding(
            padding: EdgeInsets.only(top: 37, left: 21),
            child: Column(
              crossAxisAlignment: CrossAxisAlignment.start,
              children: [
                Text(
                  "请先使用绑定的邮箱",
                  style: TextStyle(
                      fontSize: 18,
                      color: Color(0xff333333),
                      fontWeight: FontWeight.bold),
                ),
                Text("验证身份",
                    style: TextStyle(
                        fontSize: 18,
                        color: Color(0xff333333),
                        fontWeight: FontWeight.bold)),
              ],
            ),
          ),
          Padding(
            padding: const EdgeInsets.only(left: 20, right: 20, top: 40),
            child: TextField(
              controller: _unameController,
              decoration: const InputDecoration(
                hintText: "请输入邮箱号",
                prefixIcon: Icon( Iconfont.mobile_phone,color: Color(0xff1278c0),size:15),
                enabledBorder: UnderlineInputBorder(
                  borderSide: BorderSide(color: Color(0xffe6e6e6)),
                ),
                focusedBorder: UnderlineInputBorder(
                  borderSide: BorderSide(color: Color(0xffe6e6e6)),
                ),
              ),
              onChanged: (v) {},
            ),
          ),
          Padding(
              padding: const EdgeInsets.only(left: 20, right: 20, top: 10),
              child: Stack(
                alignment: Alignment.centerRight,
                children: [
                  TextField(
                    controller: _passwordController,
                    style: const TextStyle(fontSize: 14),
                    decoration: const InputDecoration(
                      hintText: "请输入验证码",
                      prefixIcon: Icon( Iconfont.verifyCode,color: Color(0xff1278c0),size:15),
                      enabledBorder: UnderlineInputBorder(
                        borderSide: BorderSide(color: Color(0xffe6e6e6)),
                      ),
                      focusedBorder: UnderlineInputBorder(
                        borderSide: BorderSide(color: Color(0xffe6e6e6)),
                      ),
                    ),
                    onChanged: (v) {},
                  ),
                  Container(
                      padding: EdgeInsets.only(right: 10),
                      child: GestureDetector(
                        child: Text(_codeCountdownStr,
                            style: TextStyle(
                                color: _countdownNum == 59
                                    ? Colors.blue
                                    : Color(0xff999999))),
                        onTap: () {
                          //发送验证码的点击事件
                          setState(() {
                            if (_countdownNum == 59) {
                              if (_unameController.text == "") {
                                setState(() {
                                  info = "请输入手机号/邮箱";
                                });
                              } else {
                                if (_unameController.text.length == 0) {
                                  info = "请输入手机号/邮箱";
                                } else {
                                  getSendCodeForget();
                                }
                              }
                            }
                          });
                        },
                      ))
                ],
              )),
          Container(
              alignment: Alignment.topLeft,
              margin: EdgeInsets.only(left: 20, top: 15),
              child: GestureDetector(
                child: Text.rich(
                  TextSpan(children: [
                    TextSpan(
                        text: info,
                        style: TextStyle(color: Colors.red, fontSize: 12)),
                  ]),
                ),
              )),
          Container(
            margin: EdgeInsets.only(left: 20, right: 20, top: 20),
            width: double.infinity,
            child: MaterialButton(
              color: Color(0xff0076C3),
              highlightColor: Colors.blue[700],
              colorBrightness: Brightness.dark,
              splashColor: Colors.grey,
              child: Text("验证"),
              onPressed: () {
                setState(() {
                  if (_unameController.text.length == 0) {
                    info = "请输入手机号/邮箱";
                  } else if (-_passwordController.text.length == 0) {
                    info = "请输入验证码";
                  } else {
                    getValidCodeForget();
                  }
                });
              },
            ),
          ),
        ],
      ),
    );
  }
}
