import 'package:flutter/material.dart';
import 'package:textileclothing/dio/APIs.dart';
import 'package:textileclothing/dio/HttpUtils.dart';
import 'package:textileclothing/utils/Global.dart';
import 'package:textileclothing/widget/Toast.dart';
import 'package:shared_preferences/shared_preferences.dart';
import 'package:textileclothing/dio/DioUtils.dart';
import 'package:textileclothing/Iconfont.dart';
class FortPassWord extends StatefulWidget {
  @override
  State<StatefulWidget> createState() {
    return FortPassWordState();
  }
}

class FortPassWordState extends State {
  final TextEditingController _unameController = TextEditingController();
  final TextEditingController _passwordController = TextEditingController();
  var info = "";

  getSendCode() async {
    // final token = await Global.getData("token");
    HttpUtils.postJSON(context,"${APIs.loginForgetPass}?token=${await Global.getData("token")}",
        {"password": _unameController.text}, success: (data) async {
          setState(() {
            if (data["code"] == "0") {
              // Toast.toast(context, msg: "修改成功");
              Navigator.of(context).pushNamed("/home");
            } else {
              info = data["message"];
            }
          });
        }, fail: (code, msg) {}, type: Type.JSON);
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        title: const Text("忘记密码",style: TextStyle(color: Colors.black),),
        centerTitle: true,
        backgroundColor: Colors.white,
        iconTheme: const IconThemeData(
          color: Color(0xff333333), //修改颜色
        )
      ),
      backgroundColor: Colors.white,
      body: Column(
        crossAxisAlignment: CrossAxisAlignment.start,
        children: [
          const Padding(
            padding: EdgeInsets.only(top: 37, left: 21),
            child: Column(
              crossAxisAlignment: CrossAxisAlignment.start,
              children: [
                Text(
                  "请重新设置新密码",
                  style: TextStyle(
                      fontSize: 18,
                      color: Color(0xff333333),
                      fontWeight: FontWeight.bold),
                ),
              ],
            ),
          ),
          Padding(
            padding: const EdgeInsets.only(left: 20, right: 20, top: 40),
            child: TextField(
              controller: _unameController,
              style: const TextStyle(fontSize: 14),
              decoration: const InputDecoration(
                hintText: "请输入新密码",
                 prefixIcon: Icon( Iconfont.password,color: Color(0xff1278c0),size:15),
                enabledBorder: UnderlineInputBorder(
                  borderSide: BorderSide(color: Color(0xffe6e6e6)),
                ),
                focusedBorder: UnderlineInputBorder(
                  borderSide: BorderSide(color: Color(0xffe6e6e6)),
                ),
              ),
              onChanged: (v) {},
            ),
          ),
          Padding(
              padding: const EdgeInsets.only(left: 20, right: 20, top: 10),
              child: Stack(
                alignment: Alignment.centerRight,
                children: [
                  TextField(
                    controller: _passwordController,
                    style: const TextStyle(fontSize: 14),
                    decoration: const InputDecoration(
                      hintText: "确认新密码",
                      prefixIcon: Icon( Iconfont.password,color: Color(0xff1278c0),size:15),
                      enabledBorder: UnderlineInputBorder(
                        borderSide: BorderSide(color: Color(0xffe6e6e6)),
                      ),
                      focusedBorder: UnderlineInputBorder(
                        borderSide: BorderSide(color: Color(0xffe6e6e6)),
                      ),
                    ),
                    onChanged: (v) {},
                  ),
                ],
              )),
          Container(
              alignment: Alignment.topLeft,
              margin: const EdgeInsets.only(left: 20, top: 15),
              child: GestureDetector(
                child: Text.rich(
                  TextSpan(children: [
                    TextSpan(
                        text: info,
                        style: const TextStyle(color: Colors.red, fontSize: 12)),
                  ]),
                ),
              )),
          Container(
            margin: const EdgeInsets.only(left: 20, right: 20, top: 20),
            width: double.infinity,
            child: MaterialButton(
              color: const Color(0xff0076C3),
              highlightColor: Colors.blue[700],
              colorBrightness: Brightness.dark,
              splashColor: Colors.grey,
              child: const Text("确定"),
              onPressed: () {
                setState(() {
                  if (_unameController.text.isEmpty) {
                    info = "请输入新密码";
                  } else if (-_passwordController.text.length == 0) {
                    info = "请确认密码";
                  } else if (_passwordController.text !=
                      _unameController.text) {
                    info = "两次密码不同";
                  } else {
                    getSendCode();
                  }
                });
              },
            ),
          ),
        ],
      ),
    );
  }
}
