import 'dart:math';

import 'package:flutter/foundation.dart';
import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'package:toast/toast.dart';

import '../widget/HexColor.dart';
import 'CheckUser.dart';
import 'package:textileclothing/dio/APIs.dart';
import 'package:textileclothing/login/LoginPresenter.dart';
import 'package:textileclothing/utils/Global.dart';
import 'package:textileclothing/Iconfont.dart';
import 'package:textileclothing/widget/loading/LoadingDialog.dart';

import 'ForgotPassword.dart';
import 'Register.dart';

class LoginUi extends StatefulWidget {
  late LoginUiState loginPresenter;

  @override
  State<StatefulWidget> createState() {
    loginPresenter = LoginUiState();
    return loginPresenter;
  }
}

class LoginUiState extends LoginPresenter {
  bool obscureText = true;

  @override
  void initState() {
    super.initState();
    isAoutLogin = false;
    checkLogin();
  }

  bool getischeck() {
    if (!kIsWeb) {
      if (APIs.username != "" && APIs.password != "") {
        return true;
      } else {
        return false;
      }
    }
    return false;
  }

  checkLogin() async {
    // username =  (await Global.getData("username"))!;
    // password =  (await Global.getData("password"))!;
    // final token =  await Global.getData("token");
    final username = await Global.getData("username");
    final password = await Global.getData("password");
    final bool? ischeck = await Global.getDataBool("ischeck");
    if(ischeck != null&&ischeck){
      unameController.text = username!;
      passwordController.text = password!;
      setState(() {
        this.ischeck = ischeck;
      });
    }

    if (!kIsWeb) {
      if (username != null && password != null) {
        isAoutLogin = true;
        // Navigator.pushNamed(context, '/MyHome');
        LoadingDialog().showLoadingDialog(context);
        getLogin(username, password);
      } else {}
    }
    // if(username!=null&& password!=null){
    //   if(!kIsWeb){
    //     getnewLogin();
    //     // Navigator.pushNamed(context, '/MyHome');
    //     // Navigator.of(context).pushNamed("/home");
    //   }else{
    //
    //
    //   }
    // }else{

    // }
  }

  setIsCheck(bool check) {
    setState(() {
      ischeck = check;
    });
  }

  //公共圆角控件
  Widget baseBorderRadius(Widget child, EdgeInsetsGeometry edgeInsetsGeometry) {
    return Container(
      margin: edgeInsetsGeometry,
      //边框设置
      decoration: BoxDecoration(
        //背景
        color: const Color(0xffF4F6F9),
        //设置四周圆角 角度
        borderRadius: const BorderRadius.all(Radius.circular(25.0)),
        //设置四周边框
        border: Border.all(
          width: 1,
          color: const Color(0xffF4F6F9),
        ),
      ),
      child: child,
    );
  }

  //用户名控件
  Widget userNameTextFiled() {
    return Container(
        margin: const EdgeInsets.only(left: 10, right: 10),
        padding: const EdgeInsets.only(left: 10, right: 10),
        child: Row(
          children: [
            const Image(
                image: AssetImage('images/username.png'),
                height: 18,
                width: 18),
            Container(
              padding: const EdgeInsets.only(left: 10, right: 10),
              child: Text("用户名",
                  style: TextStyle(
                      color: const Color(0xffA7AFC9),
                      fontSize: Global.getScale(context) * 14)),
            ),
            Expanded(
              child: TextField(
                controller: unameController,
                style: const TextStyle(fontSize: 16),
                decoration: const InputDecoration(
                  hintText: "请输入",
                  hintStyle: TextStyle(color: Color(0xffA0A9C7)),
                  border: InputBorder.none,
                ),
              ),
            ),
          ],
        ));
  }

  //密码控件
  Widget passWordTextFiled() {
    if (code.isEmpty) {
      for (int i = 0; i < 4; i++) {
        code = "$code${Random().nextInt(9)} ";
      }
    }
    return Container(
        margin: const EdgeInsets.only(left: 10, right: 10),
        padding: const EdgeInsets.only(left: 10, right: 10),
        child: Row(
          children: [
            const Image(
                image: AssetImage('images/password.png'),
                height: 18,
                width: 18),
            Container(
              padding: const EdgeInsets.only(left: 10, right: 10),
              child: Text("密    码",
                  style: TextStyle(
                      color: const Color(0xffA7AFC9),
                      fontSize: Global.getScale(context) * 14)),
            ),
            Expanded(
              child: TextField(
                controller: passwordController,
                style: const TextStyle(fontSize: 16),
                obscureText: obscureText,
                decoration: InputDecoration(
                  hintText: "请输入",
                  hintStyle: const TextStyle(color: Color(0xffA0A9C7)),
                  border: InputBorder.none,
                  enabledBorder: const UnderlineInputBorder(
                    borderSide: BorderSide(color: Color(0xffe6e6e6)),
                  ),
                  focusedBorder: const UnderlineInputBorder(
                    borderSide: BorderSide(color: Color(0xffe6e6e6)),
                  ),
                  suffixIcon: GestureDetector(
                      child: obscureText
                          ? const Icon(Iconfont.closeEye,
                              color: Color(0xffA7AFC9), size: 15)
                          : const Icon(Iconfont.openEye,
                              color: Color(0xffA7AFC9), size: 15),
                      onTap: () {
                        setState(() {
                          obscureText = !obscureText;
                        });
                      }),
                ),
              ),
            ),
          ],
        ));
  }

  //验证码控件
  Widget codeTextFiled() {
    return Container(
        margin: const EdgeInsets.only(left: 10, right: 10),
        padding: const EdgeInsets.only(left: 10, right: 10),
        child: Row(
          children: [
            const Image(
                image: AssetImage('images/code.png'), height: 18, width: 18),
            Container(
              padding: const EdgeInsets.only(left: 10, right: 10),
              child: Text("验证码",
                  style: TextStyle(
                      color: const Color(0xffA7AFC9),
                      fontSize: Global.getScale(context) * 14)),
            ),
            Expanded(
              child: TextField(
                controller: ageController,
                style: const TextStyle(fontSize: 16),
                decoration: InputDecoration(
                  hintText: "请输入",
                  hintStyle: const TextStyle(color: Color(0xffA0A9C7)),
                  border: InputBorder.none,
                  enabledBorder: const UnderlineInputBorder(
                    borderSide: BorderSide(color: Color(0xffe6e6e6)),
                  ),
                  focusedBorder: const UnderlineInputBorder(
                    borderSide: BorderSide(color: Color(0xffe6e6e6)),
                  ),
                  suffixIcon: GestureDetector(
                    child: Container(
                      decoration: BoxDecoration(
                        border: Border.all(
                            width: 2.0, color: const Color(0xffE6E6E6)),
                        color: const Color(0xffE6E6E6),
                        borderRadius:
                            const BorderRadius.all(Radius.circular(5.0)),
                      ),
                      width: 90,
                      padding: const EdgeInsets.only(left: 10, right: 10),
                      margin: const EdgeInsets.only(bottom: 10),
                      child: Center(
                        child: Text(
                          code,
                          style: const TextStyle(
                              color: Color(0xff666666),
                              fontStyle: FontStyle.italic),
                        ),
                      ),
                    ),
                    onTap: () {
                      code = "";
                      for (int i = 0; i < 4; i++) {
                        code = "$code${Random().nextInt(9)} ";
                      }
                      setState(() {
                        code;
                      });
                    },
                  ),
                ),
              ),
            ),
            //GestureDetector(
            // child: Container(
            // margin: const EdgeInsets.only(left: 10, right: 10),
            // child: const Image(image: AssetImage('images/refresh.png'), height: 18, width: 18),
            //), onTap: () {
            // code = "";
            // for (int i = 0; i < 4; i++) {
            //   code = "$code${Random().nextInt(9)} ";
            // }
            // setState(() {
            //   code;
            // });
            // },
            //),
          ],
        ));
  }

  @override
  Widget build(BuildContext context) {
    ToastContext().init(context);
    // getischeck()?getnewLogin():
    return Column(
      children: [
        Container(
          margin: const EdgeInsets.only(top: 10),
          child: Text(
            // Global.getData("appname").toString(),
            APIs.appName,
            style: TextStyle(
                color: Colors.black, fontSize: Global.getScale(context) * 21),
          ),
        ),
        baseBorderRadius(userNameTextFiled(),
            const EdgeInsets.only(left: 10, right: 10, top: 40, bottom: 10)),
        baseBorderRadius(passWordTextFiled(),
            const EdgeInsets.only(left: 10, right: 10, top: 10, bottom: 10)),
        baseBorderRadius(codeTextFiled(),
            const EdgeInsets.only(left: 10, right: 10, top: 10, bottom: 10)),
        Container(
          margin:
              const EdgeInsets.only(left: 10, right: 10, top: 10, bottom: 20),
          child: Row(
            children: [
              Checkbox(
                value: ischeck,
                onChanged: (check) {
                  Global.saveDatatoBool("ischeck", check!);
                  setState(() {
                    ischeck = check!;
                  });
                },
              ),
              const Text("记住密码")
            ],
          ),
        ),
        // getTip(),
        Container(
            //边框设置
            decoration: BoxDecoration(
              //背景
              color: Color(APIs.themeColors),
              //设置四周圆角 角度
              borderRadius: const BorderRadius.all(Radius.circular(25.0)),
              //设置四周边框
              border: Border.all(
                width: 1,
                color: Color(APIs.themeColors),
              ),
              // width: 1, color: Colors.white70),
            ),
            // margin: const EdgeInsets.only(left: 10, right: 10, bottom: 20),
            padding: const EdgeInsets.all(10),
            width: double.infinity,
            child: GestureDetector(
              child: const Text(
                "登 录",
                style: TextStyle(color: Colors.white),
                textAlign: TextAlign.center,
              ),
              onTap: () {
                getLoginData();
              },
            )),
        Row(
          mainAxisAlignment: MainAxisAlignment.spaceBetween,
          children: [
            Container(
                padding: const EdgeInsets.only(
                    left: 20, right: 10, top: 20, bottom: 20),
                child: GestureDetector(
                  child: const Text("在线注册",
                      style: TextStyle(color: Color(0xff00946B))),
                  onTap: () {
                    Navigator.push(context,
                        MaterialPageRoute(builder: (context) {
                      return Register();
                    }));
                  },
                )),
            Container(
                padding: const EdgeInsets.only(
                    left: 10, right: 20, top: 20, bottom: 20),
                child: GestureDetector(
                  child: const Text("忘记密码?",
                      style: TextStyle(color: Color(0xffFF862F))),
                  onTap: () {
                    Navigator.push(context,
                        MaterialPageRoute(builder: (context) {
                      return const ForgotPassword();
                    }));
                  },
                )),
          ],
        ),
        // Container(
        //   margin: const EdgeInsets.only(left: 10, right: 10, top: 10),
        //   child: Row(
        //     children: [
        //       Checkbox(
        //         value: ischeckprivacy,
        //         onChanged: (check) {
        //           // Global.saveData("ischeckprivacy", check.toString());
        //           setState(() {
        //             ischeckprivacy = check!;
        //           });
        //         },
        //       ),
        //       GestureDetector(
        //         child: const Text("是否同意隐私条例", style: TextStyle(color: Colors.blue)),
        //         onTap: () {
        //           // Navigator.push(context,
        //           //     MaterialPageRoute(builder: (context) {
        //           //       return PrivacyRegulations();
        //           //     }));
        //         },
        //       )
        //       // const Text("")
        //     ],
        //   ),
        // ),
      ],
    );
    // getischeck()?getnewLogin():
  }

  //是否输入验证码
  Widget inputCode() {
    // code = "";
    if (code.isEmpty) {
      for (int i = 0; i < 4; i++) {
        code = "$code${Random().nextInt(9)} ";
      }
    }
    // if (number < 3) {
    //   return Text("");
    // } else {
    return Padding(
      padding: const EdgeInsets.only(left: 10, right: 10, top: 10, bottom: 10),
      child: TextField(
        controller: ageController,
        decoration: InputDecoration(
          hintText: "请输入",
          enabledBorder: const UnderlineInputBorder(
            borderSide: BorderSide(color: Color(0xffe6e6e6)),
          ),
          focusedBorder: const UnderlineInputBorder(
            borderSide: BorderSide(color: Color(0xffe6e6e6)),
          ),
          suffixIcon: GestureDetector(
            child: Container(
              decoration: BoxDecoration(
                border: Border.all(width: 2.0, color: const Color(0xffE6E6E6)),
                color: const Color(0xffE6E6E6),
                borderRadius: const BorderRadius.all(Radius.circular(5.0)),
              ),
              width: 90,
              padding: const EdgeInsets.only(left: 10, right: 10),
              margin: const EdgeInsets.only(bottom: 10),
              child: Center(
                child: Text(
                  code,
                  style: const TextStyle(
                      color: Color(0xff666666), fontStyle: FontStyle.italic),
                ),
              ),
            ),
            onTap: () {
              code = "";
              for (int i = 0; i < 4; i++) {
                code = "$code${Random().nextInt(9)} ";
              }
              setState(() {
                code;
              });
            },
          ),
        ),
      ),
    );
    // }
  }

  //登录提示信息
  Widget getTip() {
    if (faileState != 200) {
      if (faileState == 4003) {
        return Container(
          alignment: Alignment.topLeft,
          margin: const EdgeInsets.only(left: 10, bottom: 10),
          child: GestureDetector(
            child: Text.rich(
              TextSpan(children: [
                TextSpan(
                    text: tip,
                    style: const TextStyle(color: Colors.red, fontSize: 12)),
                tip != null && tip.contains("您的密码已过期，请立即修改密码")
                    ? const TextSpan(
                        text: " 修改密码",
                        style: TextStyle(color: Colors.blue, fontSize: 12))
                    : const TextSpan(text: ""),
              ]),
            ),
            onTap: () {
              if (tip != null && tip.contains("您的密码已过期，请立即修改密码")) {
                // Navigator.push(context, MaterialPageRoute(builder: (context) {
                //   return EditPassword(userid, 1);
                // }));
              }
            },
          ),
        );
      } else {
        return Container(
          alignment: Alignment.topLeft,
          margin: const EdgeInsets.only(left: 10, bottom: 10),
          child: GestureDetector(
            child: Text.rich(
              TextSpan(children: [
                TextSpan(
                    text: tip,
                    style: const TextStyle(color: Colors.red, fontSize: 12)),
                tip.contains("账号已锁定")
                    ? const TextSpan(
                        text: " 点击这里解锁",
                        style: TextStyle(color: Colors.blue, fontSize: 12))
                    : const TextSpan(text: ""),
              ]),
            ),
            onTap: () {
              if (tip != null && tip.contains("账号已锁定")) {
                Navigator.push(context, MaterialPageRoute(builder: (context) {
                  return CheckUser("解锁账号", 1);
                }));
              }
            },
          ),
        );
      }
    } else {
      return const Text("");
    }
  }
}
