import 'dart:async';
import 'dart:collection';
import 'package:flutter/material.dart';
import 'package:intl/intl.dart';
import 'package:textileclothing/dio/APIs.dart';
import 'package:textileclothing/dio/HttpUtils.dart';
import 'package:textileclothing/widget/Toast.dart';
import 'package:textileclothing/dio/DioUtils.dart';

class Register extends StatefulWidget {
  @override
  State<StatefulWidget> createState() {
    return CheckUserState();
  }
}

class CheckUserState extends State {
  final TextEditingController _unameController = TextEditingController();
  final TextEditingController unameController = TextEditingController();
  final TextEditingController _passwordController = TextEditingController();
  final TextEditingController _passwordController1 = TextEditingController();
  final TextEditingController phoneController = TextEditingController();
  final TextEditingController emailController = TextEditingController();
  final TextEditingController emailCodeController = TextEditingController();

  String age = "请选择"; //
  String sex = "请选择";
  String mingzu = "请选择";//民族
  String birthday = "请选择";//生日
  Map sexMap = HashMap();
  Map mzMap = HashMap();
  int sexIndex = -1;
  int mzIndex = -1;


  //获取性别
  getSexList(String value) async {
    HttpUtils.postJSON(context, APIs.getSex, {
      "appCode": "uia",
      "key": value,
      "noNeedToken": true
    }, success: (data) async {
      setState(() {
        if (value.contains("XB")) {
          sexMap = data;
        } else if (value.contains("MZ")) {
          mzMap = data;
        }
      });
    }, type: Type.JSON, fail: (code, msg) {});
  }

  //获取y验证码
  registerSend(String value) async {
    HttpUtils.postJSON(context, APIs.registerSend, {
      "email": value,
      "noNeedToken": true
    }, success: (data) async {
      setState(() {
        if (data["code"] == 200) {

        }else{

          Toasts.showToast(data["msg"]);
        }
      });
    }, type: Type.JSON, fail: (code, msg) {});
  }

  //注册
  getRegisterList() async {
    HttpUtils.postJSON(context, APIs.getRegister, {
      "account": _unameController.text,
      "birthDay": birthday,
      "email": emailController.text,
      "emailCode": emailCodeController.text,
      "mainOrgPostId": "",
      "mobilePhone": phoneController.text,
      "nationCode": mzMap["data"][mzIndex]["dictKey"].toString(),
      "newPassword": _passwordController1.text,
      "noNeedToken": true,
      "password": _passwordController.text,
      "realname": unameController.text,
      "mainOrgPostId": '1613427188973961216',
      "roleIds": ["1613410898024595456"],
      "sexCode": sexMap["data"][sexIndex]["dictKey"].toString()
    }, success: (data) async {
      setState(() {
        if (data["code"] == "0") {
          showDialog(
            context: context,
            builder: (context) {
              return AlertDialog(
                title: const Text('注册成功'),
                content: const Text('注册成功，您可以继续使用本产品'),
                actions: [
                  ElevatedButton(
                      child: const Text("知道了"),
                      onPressed: () async {
                        Navigator.of(context).pop();// 关闭对话框
                        Navigator.pop(context);
                      }
                  ),
                ],
              );
            },
          );

        }else{
          showDialog(
            context: context,
            builder: (context) {
              return AlertDialog(
                title: const Text('注册失败'),
                content: Text(data["message"]),
                actions: [
                  ElevatedButton(
                      child: const Text("知道了"),
                      onPressed: () async {
                        Navigator.of(context).pop();// 关闭对话框
                      }
                  ),
                  ElevatedButton(
                      child: const Text("重试"),
                      onPressed: () async {
                        Navigator.of(context).pop();// 关闭对话框
                      }
                  ),
                ],
              );
            },
          );
          Toasts.showToast(data["msg"]);
        }
      });
    }, type: Type.JSON, fail: (code, msg) {});
  }

  @override
  void initState() {
    super.initState();
    getSexList("XB");
    getSexList("MZ");
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        title: const Text(
          "注册",
          style: TextStyle(color: Colors.black),
        ),
        backgroundColor: Colors.white,
        elevation: 0,
        leading: IconButton(
          icon: const Icon(
            Icons.arrow_back,
            color: Colors.black,
          ),
          onPressed: () {
            Navigator.pop(context);
          },
        ),
      ),
      backgroundColor: Colors.white,
      body: getconentNo(),
    );
  }
  Future<DateTime?> selectDate(BuildContext context) async {
    DateTime? picked = await showDatePicker(
        context: context,
        initialDate: DateTime.now(),
        firstDate: DateTime(1960),
        lastDate: DateTime(2030)
    );
    return picked;
  }

  //界面内容
  Widget getconentNo() {
    return SingleChildScrollView(
      child: Container(
          alignment: Alignment.topCenter,
          child: Column(
            children: [
              GestureDetector(
                child: Row(
                  children: [
                    getTextStyle14("账号"),
                    setTextField(_unameController, "请输入"),
                  ],
                ),
                onTap: () {},
              ),
              getLine(),
              GestureDetector(
                child: Row(
                  children: [
                    getTextStyle14("昵称"),
                    setTextField(unameController, "请输入"),
                  ],
                ),
                onTap: () {},
              ),
              getLine(),
              GestureDetector(
                child: Row(
                  children: [
                    getTextStyle14("密码"),
                    setTextField(_passwordController, "请输入"),
                  ],
                ),
                onTap: () {},
              ),
              getLine(),
              GestureDetector(
                child: Row(
                  children: [
                    getTextStyle14("确认密码"),
                    setTextField(_passwordController1, "请输入"),
                  ],
                ),
                onTap: () {},
              ),
              getLine(),
              GestureDetector(
                child: Row(
                  children: [
                    getTextStyle14("手机号"),
                    setTextField(phoneController, "请输入"),
                  ],
                ),
                onTap: () {},
              ),
              getLine(),
              GestureDetector(
                child: Row(
                  children: [
                    getTextStyle14("性别"),
                    Expanded(flex: 2, child: getTextStyle14conent(sex)),
                    const Expanded(
                      flex: 1,
                      child: Icon(
                        Icons.arrow_forward_ios,
                        color: Color(0xff999999),
                      ),
                    )
                  ],
                ),
                onTap: () {
                  showBottomPopu(sexMap, 0);
                },
              ),
              getLine(),
              GestureDetector(
                child: Row(
                  mainAxisAlignment: MainAxisAlignment.spaceBetween,
                  children: [
                    getTextStyle14("生日"),
                    Expanded(flex: 2, child: getTextStyle14conent(birthday)),
                    Expanded(
                      flex: 1,
                      child: Container(
                          width: 20,
                          height: 20,
                          margin: const EdgeInsets.only(bottom: 2),
                          child: Image.asset(
                            "images/times.png",
                          )),
                    ),
                  ],
                ),
                onTap: () {
                    Future<DateTime?> selectedDate = selectDate(context);
                    selectedDate.then((dateTime) {
                      setState(() {
                        // dateTime.
                        birthday = DateFormat('yyyy-MM-dd').format(dateTime!);// as String;//dateTime.toString();
                        print(birthday);
                      });
                  });
                }

              ),
              getLine(),
              GestureDetector(
                child: Row(
                  children: [
                    getTextStyle14("民族"),
                    Expanded(flex: 2, child: getTextStyle14conent(mingzu)),
                    const Expanded(
                      flex: 1,
                      child: Icon(
                        Icons.arrow_forward_ios,
                        color: Color(0xff999999),
                      ),
                    ),
                  ],
                ),
                onTap: () {
                  showBottomPopu(mzMap, 1);
                },
              ),
              getLine(),
              GestureDetector(
                child: Row(
                  children: [
                    getTextStyle14("邮箱"),
                    setTextField(emailController, "请输入"),
                    const Text("发送验证码"),
                  ],
                ),
                onTap: () {
                  emailController.text.isEmpty?
                  Toasts.showToast("请输入邮箱号"):
                  registerSend(emailController.text);
                },
              ),
              // GestureDetector(
              //   child: Row(
              //     children: [
              //       getTextStyle14("邮箱"),
              //       setTextField(emailController, "请输入"),
              //     ],
              //   ),
              //   onTap: () {},
              // ),
              getLine(),
              GestureDetector(
                child: Row(
                  children: [
                    getTextStyle14("邮箱验证码"),
                    setTextField(emailCodeController, "请输入"),
                  ],
                ),
                onTap: () {},
              ),
              Container(
                margin: const EdgeInsets.only(
                    left: 10, top: 20, bottom: 20, right: 10),
                child: Container(
                    //边框设置
                    decoration: BoxDecoration(
                      //背景
                      color: const Color(0xff00946B),
                      //设置四周圆角 角度
                      borderRadius:
                          const BorderRadius.all(Radius.circular(25.0)),
                      //设置四周边框
                      border: Border.all(
                        width: 1,
                        color: const Color(0xff00946B),
                      ),
                      // width: 1, color: Colors.white70),
                    ),
                    // margin: const EdgeInsets.only(left: 10, right: 10, bottom: 20),
                    padding: const EdgeInsets.all(10),
                    width: double.infinity,
                    child: GestureDetector(
                      child: const Text(
                        "注 册",
                        style: TextStyle(color: Colors.white),
                        textAlign: TextAlign.center,
                      ),
                      onTap: () {
                        if (_unameController.text.isEmpty) {
                          Toasts.showToast("请输入账号");
                        } else if (unameController.text.isEmpty) {
                          Toasts.showToast("请输入昵称");
                        } else if (_passwordController.text.isEmpty) {
                          Toasts.showToast("请输入密码");
                        } else if (_passwordController1.text.isEmpty) {
                          Toasts.showToast("请再次输入密码");
                        } else if (_passwordController1.text!=_passwordController.text) {
                          Toasts.showToast("两次输入密码不对");
                        }else if (phoneController.text.isEmpty) {
                          Toasts.showToast("请输入手机号");
                        }  else if (sexIndex == -1) {
                          Toasts.showToast("请选择性别");
                        }else if (birthday =="请选择") {
                          Toasts.showToast("请选择生日");
                        } else if (mzIndex == -1) {
                          Toasts.showToast("请选择民族");
                        } else if (emailController.text.isEmpty) {
                          Toasts.showToast("请输入邮箱");
                        } else if (emailCodeController.text.isEmpty) {
                          Toasts.showToast("请输入邮箱验证码");
                        }else {
                          getRegisterList();
                        }
                      },
                    )),
              )
            ],
          )),
    );
  }

  static Widget getLine() {
    return Container(
      margin: const EdgeInsets.only(left: 20, right: 20, top: 10),
      width: double.infinity,
      height: 0.5,
      color: const Color(0xffE5E5E5),
    );
  }

  static Widget getTextStyle14(String name) {
    return Container(
      width: 100,
      margin: const EdgeInsets.only(left: 20, top: 10),
      child: Row(
        children: [
          Text(
            name,
            style: const TextStyle(fontSize: 16, color: Color(0xff333333)),
          )
        ],
      ),
    );
  }

  //右侧输入框
  static Widget setTextField(
      TextEditingController phoneController, String content) {
    if (content != "请输入") {
      phoneController.text = content;
    }
    return Expanded(
        flex: 1,
        child: Container(
          width: double.infinity,
          margin: const EdgeInsets.only(left: 20, top: 10),
          child:Container(
            width: double.infinity,
            margin: const EdgeInsets.only(left: 0, top: 10, right: 20, bottom: 0),
            child: TextField(
              keyboardType: TextInputType.number, //数字键盘
              maxLines: 1,
              controller: phoneController,
              decoration: InputDecoration(
                  hintText: content,
                  border: InputBorder.none,
                  hintStyle: const TextStyle(color: Color(0xff999999), fontSize: 14)),
            ),
          )
        )
    );

  }

  static Widget getTextStyle14conent(String name) {
    return Container(
      margin: const EdgeInsets.only(left: 0, top: 10, right: 20, bottom: 0),
      padding: const EdgeInsets.only(left: 0, top: 10, right: 0, bottom: 10),
      child: Padding(
          padding: const EdgeInsets.only(right: 10),
          child: Text(
            name,
            style: const TextStyle(fontSize: 14, color: Color(0xff999999)),
          )),
    );
  }

  //性别弹出框
  showBottomPopu(Map map, int type) {
    showModalBottomSheet(
      context: context,
      builder: (BuildContext context) {
        return SizedBox(
            height: 200.0,
            child: SingleChildScrollView(
              child: Column(
                  mainAxisAlignment: MainAxisAlignment.spaceBetween,
                  children: [
                    ListView.builder(
                        physics: const NeverScrollableScrollPhysics(), // 禁用滑动事件
                        shrinkWrap: true,
                        itemCount: map["data"].length ?? 0,
                        itemBuilder: (BuildContext context, int index) {
                          return GestureDetector(
                            child: Container(
                              alignment: Alignment.center,
                              padding:
                                  const EdgeInsets.only(bottom: 10, top: 10),
                              child: Text(
                                  map["data"][index]["dictName"].toString()),
                            ),
                            onTap: () {
                              setState(() {
                                if (type == 0) {
                                  sex =
                                      map["data"][index]["dictName"].toString();
                                  sexIndex = index;
                                } else if (type == 1) {
                                  mingzu =
                                      map["data"][index]["dictName"].toString();
                                  mzIndex = index;
                                }
                                Navigator.pop(context);
                              });
                            },
                          );
                        }),
                  ]),
            ));
      },
    );
  }
}
