import 'dart:async';
import 'dart:collection';
import 'package:flutter/material.dart';
import 'package:intl/intl.dart';
import 'package:textileclothing/dio/APIs.dart';
import 'package:textileclothing/dio/HttpUtils.dart';
import 'package:textileclothing/widget/Toast.dart';
import 'package:textileclothing/dio/DioUtils.dart';

import '../Iconfont.dart';
import '../utils/Global.dart';
import 'BaseLogin.dart';

class SetPassword extends StatefulWidget {
  const SetPassword({super.key});


  @override
  State<StatefulWidget> createState() {
    return SetPasswordState();
  }
}

class SetPasswordState extends State {
  final TextEditingController passwordController = TextEditingController();
  final TextEditingController newPasswordController = TextEditingController();

  bool obscureText = true;
  bool newObscureText = true;

  //修改新密码接口
  checkPhoneOrEmailLogin(String code) async {
    HttpUtils.postJSON(context, APIs.updatePass, {
      "newPass": code,
      "noNeedToken": true,
      "userId": APIs.userId,
    }, success: (data) async {
      setState(() {
        if (data["data"]!=null&&data["data"]) {
        // if (data["code"] == "0") {
          showDialog(
            context: context,
            builder: (context) {
              return AlertDialog(
                title: const Text('重置密码成功'),
                content: const Text('重置成功，去登录页面'),
                actions: [
                  ElevatedButton(
                      child: const Text("知道了"),
                      onPressed: () async {
                        Navigator.push(context,
                            MaterialPageRoute(builder: (context) {
                              return  BaseLogin();
                            }));
                        // Navigator.of(context).pop();// 关闭对话框

                        ModalRoute.withName("/BaseLogin");
                        Navigator.of(context).pushNamed("/BaseLogin");
                        // Navigator.pop(context);
                      }
                  ),
                ],
              );
            },
          );

        }else{
          Toasts.showToast(data["message"]);
        }
      });
    }, type: Type.JSON, fail: (code, msg) {});
  }

  @override
  void initState() {
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        title: const Text(
          "重置密码",
          style: TextStyle(color: Colors.black),
        ),
        backgroundColor: Colors.white,
        elevation: 0,
        leading: IconButton(
          icon: const Icon(
            Icons.arrow_back,
            color: Colors.black,
          ),
          onPressed: () {
            Navigator.pop(context);
          },
        ),
      ),
      backgroundColor: Colors.white,
      // body: Text("新界面"),
      body: getconentNo(),
    );
  }

  //界面内容
  Widget getconentNo() {
    return SingleChildScrollView(
      child: Container(
          alignment: Alignment.topCenter,
          child: Column(
            children: [
              GestureDetector(
                child: Row(
                  children: [
                    // Container(
                    //     margin: const EdgeInsets.only(left: 10, right: 10),
                    //     padding: const EdgeInsets.only(left: 10, right: 10),
                    //     child: Row(
                    //       children: [
                    //         const Image(
                    //             image: AssetImage('images/password.png'), height: 18, width: 18),
                    //         Container(
                    //           padding: const EdgeInsets.only(left: 10, right: 10),
                    //           child: Text("新密码",
                    //               style: TextStyle(
                    //                   color: const Color(0xffA7AFC9),
                    //                   fontSize: Global.getScale(context) * 14)),
                    //         ),
                    //         Expanded(
                    //           child: TextField(
                    //             controller: passwordController,
                    //             style: const TextStyle(fontSize: 16),
                    //             obscureText: obscureText,
                    //             decoration: InputDecoration(
                    //               hintText: "请输入",
                    //               hintStyle: const TextStyle(color: Color(0xffA0A9C7)),
                    //               border: InputBorder.none,
                    //               enabledBorder: const UnderlineInputBorder(
                    //                 borderSide: BorderSide(color: Color(0xffe6e6e6)),
                    //               ),
                    //               focusedBorder: const UnderlineInputBorder(
                    //                 borderSide: BorderSide(color: Color(0xffe6e6e6)),
                    //               ),
                    //               suffixIcon: GestureDetector(
                    //                   child: obscureText
                    //                       ? const Icon(Iconfont.closeEye,
                    //                       color: Color(0xffA7AFC9), size: 15)
                    //                       : const Icon(Iconfont.openEye,
                    //                       color: Color(0xffA7AFC9), size: 15),
                    //                   onTap: () {
                    //                     setState(() {
                    //                       obscureText = !obscureText;
                    //                     });
                    //                   }),
                    //             ),
                    //           ),
                    //         ),
                    //       ],
                    //     )),
                    getTextStyle14("新密码"),
                    setTextField(passwordController, "请输入")
                  ],
                ),
                onTap: () {
                },
              ),
              getLine(),
              GestureDetector(
                child: Row(
                  children: [
                    // Container(
                    //     margin: const EdgeInsets.only(left: 10, right: 10),
                    //     padding: const EdgeInsets.only(left: 10, right: 10),
                    //     child: Row(
                    //       children: [
                    //         const Image(
                    //             image: AssetImage('images/password.png'), height: 18, width: 18),
                    //         Container(
                    //           padding: const EdgeInsets.only(left: 10, right: 10),
                    //           child: Text("新密码",
                    //               style: TextStyle(
                    //                   color: const Color(0xffA7AFC9),
                    //                   fontSize: Global.getScale(context) * 14)),
                    //         ),
                    //         Expanded(
                    //           child: TextField(
                    //             controller: newPasswordController,
                    //             style: const TextStyle(fontSize: 16),
                    //             obscureText: newObscureText,
                    //             decoration: InputDecoration(
                    //               hintText: "请输入",
                    //               hintStyle: const TextStyle(color: Color(0xffA0A9C7)),
                    //               border: InputBorder.none,
                    //               enabledBorder: const UnderlineInputBorder(
                    //                 borderSide: BorderSide(color: Color(0xffe6e6e6)),
                    //               ),
                    //               focusedBorder: const UnderlineInputBorder(
                    //                 borderSide: BorderSide(color: Color(0xffe6e6e6)),
                    //               ),
                    //               suffixIcon: GestureDetector(
                    //                   child: newObscureText
                    //                       ? const Icon(Iconfont.closeEye,
                    //                       color: Color(0xffA7AFC9), size: 15)
                    //                       : const Icon(Iconfont.openEye,
                    //                       color: Color(0xffA7AFC9), size: 15),
                    //                   onTap: () {
                    //                     setState(() {
                    //                       newObscureText = !newObscureText;
                    //                     });
                    //                   }),
                    //             ),
                    //           ),
                    //         ),
                    //       ],
                    //     )),
                    getTextStyle14("确认新密码"),
                    setTextField(newPasswordController, "请输入"),
                  ],
                ),
                onTap: () {
                  },
              ),
              Container(
                margin: const EdgeInsets.only(
                    left: 10, top: 20, bottom: 20, right: 10),
                child: Container(
                  //边框设置
                    decoration: BoxDecoration(
                      //背景
                      color: const Color(0xff00946B),
                      //设置四周圆角 角度
                      borderRadius:
                      const BorderRadius.all(Radius.circular(25.0)),
                      //设置四周边框
                      border: Border.all(
                        width: 1,
                        color: const Color(0xff00946B),
                      ),
                      // width: 1, color: Colors.white70),
                    ),
                    // margin: const EdgeInsets.only(left: 10, right: 10, bottom: 20),
                    padding: const EdgeInsets.all(10),
                    width: double.infinity,
                    child: GestureDetector(
                      child: const Text(
                        "下一步",
                        style: TextStyle(color: Colors.white),
                        textAlign: TextAlign.center,
                      ),
                      onTap: () {
                        if (passwordController.text.isEmpty) {
                          Toasts.showToast("请输入新密码");
                        }else if (newPasswordController.text.isEmpty) {
                          Toasts.showToast("请输入确认密码");
                        }else if (passwordController.text!=newPasswordController.text) {
                          Toasts.showToast("两次密码不相同");
                        }else{
                          checkPhoneOrEmailLogin(passwordController.text);
                        }
                      },
                    )),
              )
            ],
          )),
    );
  }

  static Widget getLine() {
    return Container(
      margin: const EdgeInsets.only(left: 20, right: 20, top: 10),
      width: double.infinity,
      height: 0.5,
      color: const Color(0xffE5E5E5),
    );
  }

  static Widget getTextStyle14(String name) {
    return Container(
      width: 100,
      margin: const EdgeInsets.only(left: 20, top: 10),
      child: Row(
        children: [
          Text(
            name,
            style: const TextStyle(fontSize: 16, color: Color(0xff333333)),
          )
        ],
      ),
    );
  }

  //右侧输入框
  static Widget setTextField(
      TextEditingController phoneController, String content) {
    if (content != "请输入") {
      phoneController.text = content;
    }
    return Expanded(
        flex: 1,
        child: Container(
            width: double.infinity,
            margin: const EdgeInsets.only(left: 20, top: 10),
            child:Container(
              width: double.infinity,
              margin: const EdgeInsets.only(left: 0, top: 10, right: 20, bottom: 0),
              child: TextField(
                keyboardType: TextInputType.number, //数字键盘
                maxLines: 1,
                controller: phoneController,
                decoration: InputDecoration(
                    hintText: content,
                    border: InputBorder.none,
                    hintStyle: const TextStyle(color: Color(0xff999999), fontSize: 14)),
              ),
            )
        )
    );

  }


}
