import 'package:flutter/material.dart';
import 'package:flutter_localizations/flutter_localizations.dart';
import 'package:toast/toast.dart';

import 'MyHome.dart';
import 'User/AppDetail.dart';
import 'login/BaseLogin.dart';

void main() {
  runApp(const MyApp());
}

class MyApp extends StatelessWidget {
  const MyApp({super.key});

  // This widget is the root of your application.
  @override
  Widget build(BuildContext context) {
    ToastContext().init(context);//初始化 toast:
    return MaterialApp(
        title: '纺织服装大数据',
        theme: ThemeData(
          primaryColor: Colors.white,
          visualDensity: VisualDensity.adaptivePlatformDensity,
        ),
        // home: CurriculumVitae(),
        //     home: AllPositions(),
        home:BaseLogin(),
        localizationsDelegates: const [
          //此处
          GlobalMaterialLocalizations.delegate,
          GlobalWidgetsLocalizations.delegate,
        ],
        supportedLocales: const [
          //此处
          Locale('zh', 'CH'),
          Locale('en', 'US'),
        ],
        // onGenerateRoute:onGenerateRoute,
        routes:{
          "/MyHome":(context) =>  const MyHome(),
          "/BaseLogin":(context) =>  BaseLogin(),
          // "/MyHome/AppDetail":(context) =>  AppDetail(),
        }
    );

  }


}

