import 'dart:collection';
import 'dart:convert';

import 'package:event_bus/event_bus.dart';
import 'package:flutter/material.dart';
import 'package:flutter/foundation.dart';
import 'package:textileclothing/WebPageNew.dart';
import 'package:flutter_svg/svg.dart';
import 'package:shared_preferences/shared_preferences.dart';
import 'package:textileclothing/dio/APIs.dart';
import 'package:zhiyong_plugin/zhiyong_plugin.dart';
// import '../WebPage.dart';

class Global {


  static EventBus eventBus = EventBus();
  static EventBus numberRedBus = EventBus();

  static double getScale(BuildContext context) {
    return MediaQuery.of(context).size.width / 375;
  }
  static Widget getNetworkSvg(BuildContext context, String url) {
    if (kIsWeb||!url.endsWith(".svg")) {
      return FadeInImage.assetNetwork(
        //这个是设置图标的
        placeholder: 'images/ic_nopic.png',
        image: url,
        width: Global.getScale(context) * 25,
        height: Global.getScale(context) * 25,
      );
    } else {
      return SvgPicture.network(url,
        color: const Color(0xff1964c7).withOpacity(0.50),
        width: Global.getScale(context) * 25,
        height: Global.getScale(context) * 25,
        placeholderBuilder: (BuildContext context) =>
            Container(
              // child: const CircularProgressIndicator()),
                child: Image.asset(
                  "images/ic_nopic.png", width: getScale(context) * 25,
                  height: getScale(context) * 25,)),

      );
    }
  }

// //新闻详情
//   static void openUrlNotice(BuildContext context, String url,[bool absolute=false,int  type=0,Function(Map)? callback]) {
//     if(kIsWeb){
//       if(absolute){
//         ZhiyongPlugin().openUrl(APIs.FORMUrl + url+"'");
//       }else{
//         ZhiyongPlugin().openUrl(APIs.FORMDATA + url+"'");
//       }
//
//       //ios相关代码
//     }else {
//       Navigator.push(context, MaterialPageRoute(builder: (context) {
//         return WebViewExample(
//             APIs.LOGIN_BASE + "/mobile/form/#" + url + "&showBar=false", "详情");
//         // }
//       }));
//     }
//
//   }
//应用详情
  //String type
  //1：处理
  //2：复用
  //3: 发起
  //11: 需要返回刷新
  static void openUrl(BuildContext context, String url,[bool absolute=false,int  type=0,Function(Map)? callback]) {
    if(kIsWeb){
      if(absolute){
        ZhiyongPlugin().openUrl("${APIs.FORMUrl}$url'");
      }else{
        ZhiyongPlugin().openUrl("${APIs.FORMDATA}$url'");
      }

      //ios相关代码

    }else {
      Navigator.push(context, MaterialPageRoute(builder: (context) {
        if(absolute) {
          return  WebViewNewExample(url,"新闻详情");
        }else{
          // return  WebViewNewExample("$url&showBar=false","新闻详情");
        return WebViewNewExample("${APIs.LOGIN_BASE}/mobile/form/#$url&showBar=false", "详情");//http://scjoyedu.eicp.net:53530/mobile/form/#/h5View/detail?id=1514435339618362550&token=a07d8f38-921f-44fc-8291-f647ea2e71ac&showBar=false
        }
      })).then((value) {
        Map data = HashMap();
        if (type == 1) {
          data.putIfAbsent("canshu", () => "chuli"); //处理
        } else if (type == 2) {
          data.putIfAbsent("canshu", () => "fuyong"); //复用
        } else if (type == 3) {
          data.putIfAbsent("canshu", () => "save"); //发起
        } else if (type == 11) {
          data.putIfAbsent("canshu", () => "pull"); //需要刷新
        } else {
          data.putIfAbsent("canshu", () => value.toString());
        }
        callback!.call(data);
      });
    }

  }
  //个人画像
  static void openUrls(BuildContext context, String url) {
    if(kIsWeb){
      // print("url------------------------"+APIs.FORMUrl+APIs.LOGIN_BASE +"/BigDataVisualization/#"+ url+"'");
      ZhiyongPlugin().openUrl(APIs.FORMUrl+APIs.LOGIN_BASE +"/BigDataVisualization/#"+ url+"'");
      //ios相关代码
    }else {
      Navigator.push(context, MaterialPageRoute(builder: (context) {
        // if(absolute) {
        //   return  WebViewExample(url+"&showBar=false","新闻详情");
        // }else{
        return WebViewNewExample(
            APIs.LOGIN_BASE  + "/BigDataVisualization/#" + url , "详情");
        // }
      })).then((value) {

      });

    }


  }
  //应用详情
  static void appUrl(BuildContext context, String url,[bool absolute=false]) {
    if(kIsWeb) {
      ZhiyongPlugin().openUrl("${APIs.FORMDATA}$url'");
    }else{
      if(absolute){
        Navigator.push(context, MaterialPageRoute(builder: (context) {
          return  WebViewNewExample(url,"新闻详情");
        }));

      }else{
        Navigator.push(context, MaterialPageRoute(builder: (context) {
          return WebViewNewExample(
              "${APIs.LOGIN_BASE}/mobile/form/#$url&showBar=false", "应用详情");
        }));
      }

    }

  }

  static void openUrloutside(BuildContext context, String url,[bool absolute=false,Function(Map)? callback]) async{

    String? token = await Global.getData("token") ;
    // print("url:-------------------------"+url);
    if(kIsWeb){
      // if(absolute){
        // ZhiyongPlugin().openUrl("${APIs.FORMUrl}$url'");
        // ZhiyongPlugin().openUrl("$url'");
      // }else{
      String ur = "https://www.baidu.com/?tn=21002492_12_hao_pg";
      ZhiyongPlugin().openUrl("${APIs.FORMUrl}$ur'");

      //   if(url.contains("?")){
      //     if(url.contains("token")){
      //       ZhiyongPlugin().openUrl("${APIs.FORMUrl}$url'");
      //     }else{
      //       ZhiyongPlugin().openUrl("${APIs.FORMUrl}$url&token=$token'");
      //     }
      //
      //   }else{
      //     String ur = "https://www.baidu.com/?tn=21002492_12_hao_pg";
      //
      //     print("url:-------------------------"+APIs.FORMUrl+ur+"'");
      //     ZhiyongPlugin().openUrl("${APIs.FORMUrl}$ur'");
      //     // ZhiyongPlugin().openUrl("${APIs.FORMUrl}$url?token=$token'");
      //     // ZhiyongPlugin().openUrl("${APIs.FORMUrl}$url?token=$token'");
      //   // }
      //
      // }

      //ios相关代码

    }else{
      Navigator.push(context, MaterialPageRoute(builder: (context) {

        if(url.contains("?")){
          return WebViewNewExample(url+"&token="+token!,"应用详情");

        }else{
          return WebViewNewExample(url+"?token="+token!,"应用详情");
        }


      })).then((value){
        Map data = new HashMap();
        // if(type==1){
          data.putIfAbsent("canshu", () => "pull");//处理
        // }else if(type==2){
        //   data.putIfAbsent("canshu", () => "fuyong");//复用
        // }else if(type==3){
        //   data.putIfAbsent("canshu", () => "save");//发起
        // }else if(type==11){
        //   data.putIfAbsent("canshu", () => "pull");//需要刷新
        // }else{
        //   data.putIfAbsent("canshu", () => value.toString());
        // }

        callback!.call(data);
      });

    }

  }
  static void saveData(String key,String value)  async{
  // /*  if(kIsWeb){
  //
  //     ZyPlugin.saveData(key, value);
  //   }else{*/
      final prefs = await SharedPreferences.getInstance();
      prefs.setString(key, value);
    //}
  }

  static void saveDatatoBool(String key,bool value)  async{
    /*  if(kIsWeb){

      ZyPlugin.saveData(key, value);
    }else{*/
    final prefs = await SharedPreferences.getInstance();
    prefs.setBool(key, value);
    //}
  }

  static Future<bool> isSaveKey(String key)  async{
    /*  if(kIsWeb){

      ZyPlugin.saveData(key, value);
    }else{*/
    final prefs = await SharedPreferences.getInstance();
    return prefs.containsKey(key);
    //}
  }

  static Future<bool?> getDataBool(String key) async {
/*    if(kIsWeb){

      return await ZyPlugin.getData(key);
    }else{*/
    final prefs =await SharedPreferences.getInstance();



    return prefs.getBool(key);
    //}
  }

  static Future<String?> getData(String key) async {
/*    if(kIsWeb){

      return await ZyPlugin.getData(key);
    }else{*/
      final prefs =await SharedPreferences.getInstance();
      return  prefs.getString(key);
    //}
  }

  static Future<String> removeData(String key) async {
   /* if(kIsWeb){

       ZyPlugin.removeData(key);
    }else{*/
      final prefs =await SharedPreferences.getInstance();
      prefs.remove(key);
   // }
    return Future.value("ok");
  }

  //加载状态
  static Widget add(){
    return Center(
        child: Column(
          mainAxisAlignment: MainAxisAlignment.center,
          children: const [
            Text(
              '正在加载中...',
              style: TextStyle(color: Color(0xFF000000), fontSize: 18.0),
            ),
          ],
        ));

  }
  //暂无数据
  static Widget Noata(){
    return Center(
        child: Column(
          mainAxisAlignment: MainAxisAlignment.center,
          children: const [
            Text(
              '暂无数据...',
              style: TextStyle(color: Color(0xFF000000), fontSize: 18.0),
            ),
          ],
        ));

  }

  //是否为空
  static bool getisEmpty(dynamic name) {
    if(name==null || name=="") {
      return true;
    }else{
      return false;
    }
  }

  static Widget getPartingLine(){
    return Container(
      margin: const EdgeInsets.only(left: 20, right: 20, top: 20),
      width: double.infinity,
      height: 0.5,
      color: const Color(0xffE5E5E5),
    );
  }

  //头像
  static Widget getImage(String avatar){
    return  FadeInImage.assetNetwork(
      placeholder: 'images/avatar.png',
      image: avatar,
      width: 25,
      height: 25,
      fit: BoxFit.cover
    );
  }

  //空头像
  static Widget getImageNull(){
    return  FadeInImage.assetNetwork(
        placeholder: 'images/avatar.png',
        image: "images/avatar.png",
        width: 25,
        height: 25,
        fit: BoxFit.cover
    );
  }


  static void showMyDialogWithListView(List<dynamic> list,BuildContext context,Function(String) callback) {
    showDialog(
      context: context,
      builder: (BuildContext context) {
        return AlertDialog(
            content: SizedBox(
              width: Global.getScale(context)*80,
              height: Global.getScale(context)*180,
              child: ListView.builder(
                itemBuilder: (BuildContext context, int index) {
                  return  GestureDetector(
                      child:Container(
                        alignment: Alignment.center,
                        width: 100,
                        padding: const EdgeInsets.all(10),
                        child: Text(list[index]["name"],
                            style: const TextStyle(
                                fontSize: 14, color: Color(0xff666666))),
                      ),
                      onTap: (){
                        callback.call(list[index]["name"]);
                        Navigator.pop(context);

                      }
                  );
                },
                itemCount: list.length,
                shrinkWrap: true,
              ),
            ));
      },
    );
  }
}

