
import 'package:flutter/cupertino.dart';
import 'package:pull_to_refresh/pull_to_refresh.dart';

class MySmartRefresher {

  //没有上拉加载更多
  Widget getRefresherNOUp(RefreshController refreshController,Function() onRefresh, Function() onLoading, Widget child) {
    return SmartRefresher(
      enablePullDown: true,//激活下拉刷新，默认开启
      enablePullUp: false,// 激活上拉加载更多，默认关闭
      header: const ClassicHeader(
        height: 45.0,
        releaseText: '松开手刷新',
        refreshingText: '刷新中',
        completeText: '刷新完成',
        failedText: '刷新失败',
        idleText: '下拉刷新',
      ),
      // ClassicFooter、CustomFooter、LinkFooter、LoadIndicator
      footer: const ClassicFooter(
        height: 45.0,
        noDataText:"没有更多数据了",
        canLoadingText: "松开手加载",
        loadingText: "加载中",
        failedText: '加载失败',
        idleText: '上拉加载',
      ),
      controller: refreshController,
      onRefresh: onRefresh,
      onLoading: onLoading,
      child: child,
    );
  }

  //下拉刷新，上拉加载更多
  Widget getRefreshers(RefreshController refreshController,Function() onRefresh, Function() onLoading, Widget child) {
    return SmartRefresher(
      enablePullDown: true,//激活下拉刷新，默认开启
      enablePullUp: true,// 激活上拉加载更多，默认关闭
      header: const ClassicHeader(
        height: 45.0,
        releaseText: '松开手刷新',
        refreshingText: '刷新中',
        completeText: '刷新完成',
        failedText: '刷新失败',
        idleText: '下拉刷新',
      ),
      // ClassicFooter、CustomFooter、LinkFooter、LoadIndicator
      footer: const ClassicFooter(
        height: 45.0,
        noDataText:"没有更多数据了",
        canLoadingText: "松开手加载",
        loadingText: "加载中",
        failedText: '加载失败',
        idleText: '上拉加载',
      ),
      controller: refreshController,
      onRefresh: onRefresh,
      onLoading: onLoading,
      child: child,
    );
  }

  Widget getRefresher(RefreshController refreshController,void Function() onRefresh, void Function() onLoading, Widget child) {
    return SmartRefresher(
      enablePullDown: true,//激活下拉刷新，默认开启
      enablePullUp: true,// 激活上拉加载更多，默认关闭
      header: const ClassicHeader(
        height: 45.0,
        releaseText: '松开手刷新',
        refreshingText: '刷新中',
        completeText: '刷新完成',
        failedText: '刷新失败',
        idleText: '下拉刷新',
      ),
      // ClassicFooter、CustomFooter、LinkFooter、LoadIndicator
      footer: const ClassicFooter(
        height: 45.0,
        noDataText:"没有更多数据了",
        canLoadingText: "松开手加载",
        loadingText: "加载中",
        failedText: '加载失败',
        idleText: '上拉加载',
      ),
      controller: refreshController,
      onRefresh: onRefresh,
      onLoading: onLoading,
      child: child,
    );
  }
  Widget getRefresherNo(RefreshController refreshController,void Function() onRefresh, Function() onLoading, Widget child,bool ispull) {
    return SmartRefresher(
      enablePullDown: ispull,
      enablePullUp: false,
      header: const ClassicHeader(
        height: 45.0,
        releaseText: '松开手刷新',
        refreshingText: '刷新中',
        completeText: '刷新完成',
        failedText: '刷新失败',
        idleText: '下拉刷新',
      ),
      // ClassicFooter、CustomFooter、LinkFooter、LoadIndicator
      footer: const ClassicFooter(
        height: 45.0,
        noDataText:"没有更多数据了",
        canLoadingText: "松开手加载",
        loadingText: "加载中",
        failedText: '加载失败',
        idleText: '上拉加载',
      ),
      controller: refreshController,
      onRefresh: onRefresh,
      onLoading: onLoading,
      child: child,
    );
  }
}
